--/**
-- * Copyright (c) 2007 E.D.Willink and others.
-- * All rights reserved.   This program and the accompanying materials
-- * are made available under the terms of the Eclipse Public License v1.0
-- * which accompanies this distribution, and is available at
-- * http://www.eclipse.org/legal/epl-v10.html
-- *
-- * Contributors:
-- *   E.D.Willink - Initial API and implementation
-- */
--
-- The KM3 KeyWord Lexer
--

%Options slr
%Options fp=KM3KWLexer,prefix=Char_
%options noserialize
%options package=org.eclipse.gmt.umlx.registry.km3.parser
%options template=KeywordTemplateD.g
%options export_terminals=("KM3Parsersym.java", "TK_")
%options include_directory="."

$Define

	--
	-- Definition of macros used in the template
	--
	$action_class /.$file_prefix./
	$eof_char /.Char_EOF./
	$copyright_contributions /../

$End

$Notice
	/./**
 * <copyright>
 *
 * Copyright (c) 2007 E.D.Willink and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   E.D.Willink - Initial API and implementation
 *
 * </copyright>
 */
	./
$End

$Globals
	/../
$End

$Include
	KWLexerMap.g
$End

$Export
	abstract
	attribute
	class
	container
	datatype
	enumeration
	extends
	literal
	oppositeOf
	ordered
	package
	reference
	unique
$End

$Terminals
	DollarSign
	a b c d e f g h i j k l m n o p q r s t u v w x y z
	A B C D E F G H I J K L M N O P Q R S T U V W X Y Z
$End

$Eof
	EOF
$End

$Start
	KeyWord
$End

$Rules

-- The Goal for the parser is a single Keyword

	KeyWord ::=
		  a b s t r a c t
		/.$BeginAction
			$setResult($_abstract);
		  $EndAction
		./
		
		| a t t r i b u t e
		/.$BeginAction
			$setResult($_attribute);
		  $EndAction
		./
		
		| c l a s s
		/.$BeginAction
			$setResult($_class);
		  $EndAction
		./
		
		| c o n t a i n e r
		/.$BeginAction
			$setResult($_container);
		  $EndAction
		./
		
		| d a t a t y p e
		/.$BeginAction
			$setResult($_datatype);
		  $EndAction
		./
		
		| e n u m e r a t i o n
		/.$BeginAction
			$setResult($_enumeration);
		  $EndAction
		./
		
		| e x t e n d s
		/.$BeginAction
			$setResult($_extends);
		  $EndAction
		./
		
		| l i t e r a l
		/.$BeginAction
			$setResult($_literal);
		  $EndAction
		./
		
		| o p p o s i t e O f
		/.$BeginAction
			$setResult($_oppositeOf);
		  $EndAction
		./
		
		| o r d e r e d
		/.$BeginAction
			$setResult($_ordered);
		  $EndAction
		./
		
		| p a c k a g e
		/.$BeginAction
			$setResult($_package);
		  $EndAction
		./
		
		| r e f e r e n c e
		/.$BeginAction
			$setResult($_reference);
		  $EndAction
		./
		
		| u n i q u e
		/.$BeginAction
			$setResult($_unique);
		  $EndAction
		./
$End
