/*******************************************************************************
 * Copyright (c) 2007 E.D.Willink and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     E.D.Willink - initial API and implementation
 *******************************************************************************/
package org.eclipse.gmt.umlx.editor.tree;

import org.eclipse.emf.ecore.xmi.XMLResource;
import org.eclipse.gmt.umlx.editor.IMasterPageManager;
import org.eclipse.gmt.umlx.editor.paged.PagedEditor;
import org.eclipse.gmt.umlx.editor.pages.AbstractPageFactory;
import org.eclipse.gmt.umlx.editor.pages.PageDefinitions;
import org.eclipse.gmt.umlx.editor.xml.EcoreXMLPageManager;

/**
 * An EcoreXMLPageFactory manages creation of Ecore XML pages.
 */
public class ResourceSetPageFactory extends AbstractPageFactory
{
	public ResourceSetPageFactory(PagedEditor pagedEditor) {
		super(pagedEditor);
	}

	public IMasterPageManager createMasterPageFor(PagedEditor pagedEditor, XMLResource resource, boolean isText) {
		return null;
	}

	public EcoreXMLPageManager createPageFor(PagedEditor pagedEditor, XMLResource resource, boolean isText) {
		TreePageManager pageManager = new TreePageManager(pagedEditor, "ResourceSet");
		pagedEditor.addPageManager(pageManager);
		return null;
	}

	public void createOtherPagesFor(PagedEditor pagedEditor) {
		createPageFor(pagedEditor, null, false);
	}
	
	public void registerAsIn(String name, PageDefinitions pageFactoryRegistries) throws InstantiationException, IllegalAccessException {
		TreePageFactoryRegistry pageFactoryRegistry = pageFactoryRegistries.create(TreePageFactoryRegistry.class);
		pageFactoryRegistry.registerPageFactory(name, this);
	}
}