/*******************************************************************************
 * Copyright (c) 2007 E.D.Willink and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     E.D.Willink - initial API and implementation
 *******************************************************************************/
package org.eclipse.gmt.umlx.eqvtc.cst.environment;

import java.util.Set;

import org.eclipse.gmt.umlx.eqvtc.cst.PatternCS;
import org.eclipse.qvt.declarative.ecore.QVTCore.Area;
import org.eclipse.qvt.declarative.ecore.QVTCore.QVTCoreFactory;
import org.eclipse.qvt.declarative.ecore.QVTCore.GuardPattern;

public class QVTcGuardPatternEnvironment extends QVTcPatternEnvironment
{
	private final GuardPattern pattern;
	
	public QVTcGuardPatternEnvironment(QVTcAreaEnvironment domainEnvironment, PatternCS patternCS) {
		super(domainEnvironment, patternCS);
		Area area = domainEnvironment.getArea();
		GuardPattern guardPattern = QVTCoreFactory.eINSTANCE.createGuardPattern();
		initASTMapping(guardPattern, patternCS);
		area.setGuardPattern(guardPattern);
		pattern = guardPattern;
	}

	@Override public GuardPattern getPattern() { return pattern; }

	@Override
	public Set<QVTcPatternEnvironment> getPatternEnvironmentClosure() {
		return getParentEnvironment().getGuardPatternEnvironmentClosure();
	}
	
	@Override
	public String toString() {
		String parentString = getInternalParent() != null ? (getInternalParent().toString() + ".") : "";
		return parentString + "guard";
	}
}
