/**
 * <copyright>
 * </copyright>
 *
 * $Id: EqvtcCSTFactoryImpl.java,v 1.5 2007/12/14 08:57:27 ewillink Exp $
 */
package org.eclipse.gmt.umlx.eqvtc.cst.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EFactoryImpl;
import org.eclipse.emf.ecore.plugin.EcorePlugin;
import org.eclipse.gmt.umlx.eqvtc.cst.*;
import org.eclipse.gmt.umlx.eqvtc.cst.AssignmentCS;
import org.eclipse.gmt.umlx.eqvtc.cst.BottomPatternCS;
import org.eclipse.gmt.umlx.eqvtc.cst.DirectionCS;
import org.eclipse.gmt.umlx.eqvtc.cst.DomainCS;
import org.eclipse.gmt.umlx.eqvtc.cst.EqvtcCSTFactory;
import org.eclipse.gmt.umlx.eqvtc.cst.EqvtcCSTPackage;
import org.eclipse.gmt.umlx.eqvtc.cst.GuardPatternCS;
import org.eclipse.gmt.umlx.eqvtc.cst.MappingCS;
import org.eclipse.gmt.umlx.eqvtc.cst.RealizedVariableCS;
import org.eclipse.gmt.umlx.eqvtc.cst.TopLevelCS;
import org.eclipse.gmt.umlx.eqvtc.cst.TransformationCS;
import org.eclipse.gmt.umlx.eqvtc.cst.UnrealizedVariableCS;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class EqvtcCSTFactoryImpl extends EFactoryImpl implements EqvtcCSTFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static EqvtcCSTFactory init() {
		try
		{
			EqvtcCSTFactory theEqvtcCSTFactory = (EqvtcCSTFactory)EPackage.Registry.INSTANCE.getEFactory("http://www.eclipse.org/gmt/umlx/EQVTrcst"); 
			if (theEqvtcCSTFactory != null)
			{
				return theEqvtcCSTFactory;
			}
		}
		catch (Exception exception)
		{
			EcorePlugin.INSTANCE.log(exception);
		}
		return new EqvtcCSTFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EqvtcCSTFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID())
		{
			case EqvtcCSTPackage.ASSIGNMENT_CS: return createAssignmentCS();
			case EqvtcCSTPackage.BOTTOM_PATTERN_CS: return createBottomPatternCS();
			case EqvtcCSTPackage.DIRECTION_CS: return createDirectionCS();
			case EqvtcCSTPackage.DOMAIN_CS: return createDomainCS();
			case EqvtcCSTPackage.ENFORCEMENT_OPERATION_CS: return createEnforcementOperationCS();
			case EqvtcCSTPackage.GUARD_PATTERN_CS: return createGuardPatternCS();
			case EqvtcCSTPackage.MAPPING_CS: return createMappingCS();
			case EqvtcCSTPackage.PARAM_DECLARATION_CS: return createParamDeclarationCS();
			case EqvtcCSTPackage.QUERY_CS: return createQueryCS();
			case EqvtcCSTPackage.REALIZED_VARIABLE_CS: return createRealizedVariableCS();
			case EqvtcCSTPackage.TOP_LEVEL_CS: return createTopLevelCS();
			case EqvtcCSTPackage.TRANSFORMATION_CS: return createTransformationCS();
			case EqvtcCSTPackage.UNREALIZED_VARIABLE_CS: return createUnrealizedVariableCS();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AssignmentCS createAssignmentCS() {
		AssignmentCSImpl assignmentCS = new AssignmentCSImpl();
		return assignmentCS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BottomPatternCS createBottomPatternCS() {
		BottomPatternCSImpl bottomPatternCS = new BottomPatternCSImpl();
		return bottomPatternCS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DirectionCS createDirectionCS() {
		DirectionCSImpl directionCS = new DirectionCSImpl();
		return directionCS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MappingCS createMappingCS() {
		MappingCSImpl mappingCS = new MappingCSImpl();
		return mappingCS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ParamDeclarationCS createParamDeclarationCS() {
		ParamDeclarationCSImpl paramDeclarationCS = new ParamDeclarationCSImpl();
		return paramDeclarationCS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public QueryCS createQueryCS() {
		QueryCSImpl queryCS = new QueryCSImpl();
		return queryCS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TopLevelCS createTopLevelCS() {
		TopLevelCSImpl topLevelCS = new TopLevelCSImpl();
		return topLevelCS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TransformationCS createTransformationCS() {
		TransformationCSImpl transformationCS = new TransformationCSImpl();
		return transformationCS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public UnrealizedVariableCS createUnrealizedVariableCS() {
		UnrealizedVariableCSImpl unrealizedVariableCS = new UnrealizedVariableCSImpl();
		return unrealizedVariableCS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EnforcementOperationCS createEnforcementOperationCS()
	{
		EnforcementOperationCSImpl enforcementOperationCS = new EnforcementOperationCSImpl();
		return enforcementOperationCS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DomainCS createDomainCS() {
		DomainCSImpl domainCS = new DomainCSImpl();
		return domainCS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GuardPatternCS createGuardPatternCS() {
		GuardPatternCSImpl guardPatternCS = new GuardPatternCSImpl();
		return guardPatternCS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RealizedVariableCS createRealizedVariableCS() {
		RealizedVariableCSImpl realizedVariableCS = new RealizedVariableCSImpl();
		return realizedVariableCS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EqvtcCSTPackage getEqvtcCSTPackage() {
		return (EqvtcCSTPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static EqvtcCSTPackage getPackage() {
		return EqvtcCSTPackage.eINSTANCE;
	}

} //EqvtcCSTFactoryImpl
