/**
* <copyright>
*
* Copyright (c) 2005, 2008 IBM Corporation and others.
* All rights reserved.   This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*   IBM - Initial API and implementation
*   E.D.Willink - Elimination of some shift-reduce conflicts
*   E.D.Willink - Remove unnecessary warning suppression
*   E.D.Willink - Extended API and implementation for QVTc
*
* </copyright>
*
* $Id: QVTcParserprs.java,v 1.8 2008/04/08 08:24:37 ewillink Exp $
*/

package org.eclipse.gmt.umlx.eqvtc.cst.parser;

public class QVTcParserprs implements lpg.lpgjavaruntime.ParseTable, QVTcParsersym {

    public interface IsKeyword {
        public final static byte isKeyword[] = {0,
            0,0,0,0,0,1,1,1,1,1,
            1,1,1,1,1,0,1,1,1,1,
            1,1,1,0,0,0,0,0,0,0,
            1,1,1,1,1,1,1,1,1,1,
            1,1,0,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,0,1,1,1,
            1,1,1,1,1,0,0,0,1,1,
            1,1,0,0,0,1,1,0,0,0,
            0,0,0,0,0,0,0,0,1,0,
            0,0,1,1,1,1,1,0,0,0,
            0,0,0
        };
    };
    public final static byte isKeyword[] = IsKeyword.isKeyword;
    public final boolean isKeyword(int index) { return isKeyword[index] != 0; }

    public interface BaseCheck {
        public final static short baseCheck[] = {0,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,6,8,0,1,1,
            3,0,1,1,1,1,1,3,3,1,
            1,3,3,3,3,3,3,1,1,3,
            3,3,3,1,1,3,3,3,3,3,
            3,3,3,1,1,1,1,3,3,3,
            3,1,1,3,3,3,3,1,1,2,
            2,1,2,2,4,6,1,1,1,1,
            3,2,2,5,5,1,1,1,1,1,
            1,1,1,1,1,1,1,1,3,0,
            1,1,1,1,1,1,1,3,3,4,
            1,1,1,1,1,0,1,1,3,1,
            1,3,2,3,1,1,1,1,1,4,
            1,1,1,1,1,1,1,1,2,2,
            2,2,1,1,4,4,4,4,4,4,
            4,4,4,4,4,1,3,5,6,8,
            1,3,5,3,0,1,1,1,1,1,
            4,4,0,1,1,3,1,1,3,3,
            1,1,5,5,5,5,5,5,5,5,
            5,5,5,5,5,5,5,5,5,5,
            5,5,5,5,5,2,2,5,0,1,
            0,1,1,3,5,0,1,2,3,7,
            5,5,0,1,1,3,1,1,3,0,
            2,2,2,3,3,2,1,2,2,2,
            1,1,2,2,2,1,1,1,2,1,
            3,1,3,3,2,2,3,4,2,2,
            6,2,1,2,1,2,1,1,1,1,
            1,0,2,2,0,2,3,1,1,0,
            2,2,2,0,2,3,2,1,1,1,
            3,3,3,4,1,1,1,3,1,2,
            1,1,1,1,1,1,3,2,2,4,
            2,4,3,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,-281,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-121,0,0,
            -3,-5,0,0,0,-13,0,-6,0,-37,
            -11,-14,0,-39,0,0,-26,0,0,0,
            -125,0,0,-22,-23,0,-24,-126,0,0,
            -27,0,0,0,0,-132,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-91,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-93,0,
            0,0,-28,0,-155,0,-1,0,-29,-7,
            0,-30,-32,-124,0,0,-33,-34,0,0,
            0,0,-10,0,-35,0,-38,-15,0,0,
            0,0,0,-115,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-40,-64,0,0,-65,0,
            0,0,-67,-68,0,0,0,-69,-70,0,
            0,0,-123,0,0,-71,-20,0,0,0,
            0,0,-72,-79,0,-4,0,0,-273,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-73,-74,0,-77,0,-78,0,
            -80,0,0,0,-82,-83,-36,-84,-85,-86,
            -89,-324,-18,-25,0,0,-274,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-92,-94,0,0,-95,0,-96,0,
            0,0,-97,-98,-99,-100,-101,-102,-103,-104,
            -105,-41,0,0,-122,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -154,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-152,0,0,-156,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-157,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-223,0,0,-158,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-159,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-261,0,0,
            -160,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-161,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-307,
            0,0,-162,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-163,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-315,0,0,-164,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -165,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-317,0,0,-166,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-167,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-106,0,0,-168,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-107,0,0,-169,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-108,0,0,
            -170,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-109,0,0,-171,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-110,
            0,0,-172,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-111,0,0,-180,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-112,0,0,-183,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-21,0,0,
            -247,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-113,0,-114,-117,-120,-129,0,
            -142,-143,-144,0,-145,-146,-147,-149,-150,-151,
            -173,0,0,-255,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-174,0,0,-262,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-177,-178,-179,0,-181,0,-263,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-182,-184,-185,0,-186,0,-264,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -193,-194,-195,0,-196,0,-265,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-197,
            -198,-199,0,-200,0,-266,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-201,-202,
            -203,0,-204,0,-267,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-205,-206,-208,
            0,-209,0,-268,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-210,-211,-212,0,
            -213,0,-269,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-214,-215,-220,0,-224,
            0,-270,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-225,-226,-227,0,-228,0,
            -271,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-229,-230,-231,0,-232,0,-272,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-233,-234,-235,0,-236,0,-285,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-237,0,0,-286,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-238,0,0,
            -118,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-239,0,-119,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-16,0,
            -148,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-240,-241,0,-242,-243,-244,-250,
            -254,-256,0,-257,-258,-260,-275,-276,0,-259,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-17,0,-320,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-277,-278,0,
            -279,-282,-284,-287,-288,-289,0,0,-31,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-44,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-81,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-175,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -207,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-221,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-222,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-245,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-246,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-249,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-251,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-283,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-306,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-316,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -318,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-330,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-331,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-138,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-139,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-140,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-141,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-133,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-134,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-135,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-136,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-137,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-130,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-131,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-127,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-128,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-42,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-43,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-176,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-310,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-311,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-2,
            -308,-9,-45,-46,-12,-87,0,0,0,0,
            -88,0,0,0,0,-153,0,0,0,0,
            -218,-290,-291,-292,-293,-294,-295,0,-216,0,
            0,0,0,-219,0,0,0,0,-319,0,
            0,0,0,-47,-296,0,0,0,0,-248,
            -116,0,0,0,0,0,0,0,-48,0,
            0,0,-297,-298,0,0,0,0,-8,0,
            0,0,0,0,-49,-299,-19,0,0,0,
            -217,-300,0,0,0,-301,0,0,0,0,
            -280,-90,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-329,0,0,0,0,
            -50,-302,-303,0,0,0,-51,0,0,0,
            0,0,-52,0,0,0,0,0,0,0,
            -53,-54,0,0,0,0,0,0,0,-55,
            -56,-57,-58,0,-59,-60,-61,0,0,-62,
            -63,0,-66,0,0,0,0,-75,-76,0,
            -187,-188,-304,-189,-190,0,0,0,-191,0,
            0,-192,0,0,0,-252,-253,-314,-305,-309,
            -312,-313,0,0,0,0,-321,0,0,0,
            -322,-323,0,0,-325,0,-326,-327,-328,-332,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0
        };
    };
    public final static short baseCheck[] = BaseCheck.baseCheck;
    public final int baseCheck(int index) { return baseCheck[index]; }
    public final static short rhs[] = baseCheck;
    public final int rhs(int index) { return rhs[index]; };

    public interface BaseAction {
        public final static char baseAction[] = {
            81,6,6,6,6,6,6,6,6,6,
            6,6,6,6,6,6,6,6,6,6,
            6,6,7,7,124,124,125,126,127,127,
            129,129,130,130,40,40,41,42,41,42,
            38,39,38,38,38,39,39,39,36,37,
            36,37,36,37,34,35,34,35,34,35,
            34,35,34,35,30,30,32,31,32,31,
            32,31,28,29,28,29,28,29,25,26,
            25,25,10,10,10,10,10,11,11,11,
            11,11,12,12,12,12,5,5,5,2,
            2,2,2,2,2,2,2,2,3,3,
            82,82,13,13,13,13,13,13,14,14,
            15,4,4,4,4,4,83,83,84,84,
            61,61,62,62,62,17,17,17,17,17,
            16,20,21,22,23,24,24,18,19,59,
            59,59,59,86,86,87,87,87,87,87,
            87,87,87,87,87,87,48,48,48,88,
            88,46,46,46,64,128,128,49,49,49,
            49,51,50,89,89,90,90,85,85,85,
            85,63,63,63,63,8,8,8,8,8,
            8,8,8,8,8,8,8,8,8,8,
            8,8,8,8,9,8,65,65,65,43,
            43,45,45,44,44,27,91,91,92,92,
            33,60,60,66,66,67,67,53,53,53,
            81,81,81,81,95,95,93,97,98,98,
            99,101,101,102,102,103,96,96,70,70,
            71,71,72,72,72,73,73,74,74,74,
            68,55,56,75,75,104,104,105,106,131,
            107,132,110,110,111,112,112,112,108,108,
            113,113,114,114,116,116,116,116,109,109,
            78,117,117,76,115,77,77,79,58,80,
            80,52,54,100,118,69,57,119,119,120,
            122,94,94,121,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,3,5,47,47,402,604,96,677,596,
            4179,4178,4023,89,90,624,82,87,88,112,
            113,114,115,116,117,135,136,137,138,139,
            72,73,79,681,67,54,55,685,65,688,
            49,686,41,690,37,1788,689,35,1452,342,
            96,189,1563,1933,22,118,1597,341,590,528,
            498,1215,1655,309,1653,342,96,1597,341,109,
            537,1653,342,96,198,1454,2128,486,1653,342,
            96,1735,4200,2129,305,306,607,604,96,677,
            596,4179,4178,4023,89,90,624,82,87,88,
            112,113,114,115,116,117,135,136,137,138,
            139,72,73,79,681,67,54,55,685,65,
            2177,53,297,1,604,96,677,596,4179,4178,
            4023,89,90,624,82,87,88,112,113,114,
            115,116,117,135,136,137,138,139,72,73,
            79,681,67,54,55,685,65,688,49,686,
            41,690,37,1788,689,35,691,250,278,1749,
            4112,743,463,596,527,1696,341,3,2277,785,
            690,309,301,901,1377,342,96,190,1221,4189,
            22,4192,192,1597,341,1485,522,1547,1597,341,
            1787,522,305,306,106,604,96,677,596,4179,
            4178,4023,89,90,624,82,87,88,112,113,
            114,115,116,117,135,136,137,138,139,72,
            73,79,681,67,54,55,685,65,688,49,
            686,41,690,37,1837,689,35,149,277,191,
            391,398,392,4089,520,1378,1083,2276,4020,1203,
            1789,1790,519,600,1596,128,130,261,1683,1249,
            150,153,154,1302,342,96,1550,84,4189,22,
            4185,192,151,1658,99,269,395,1791,1883,302,
            604,96,677,596,4179,4178,4023,89,90,624,
            82,87,88,112,113,114,115,116,117,135,
            136,137,138,139,72,73,79,681,67,54,
            55,685,65,688,49,686,41,690,37,237,
            689,35,272,312,1669,1686,152,1748,191,598,
            259,1520,235,83,84,1587,1721,84,1453,1523,
            1549,294,105,93,493,4132,4183,302,604,96,
            677,596,4179,4178,4023,89,90,624,82,87,
            88,112,113,114,115,116,117,135,136,137,
            138,139,72,73,79,681,67,54,55,685,
            65,688,49,686,41,690,37,237,689,35,
            311,311,268,1698,1751,687,255,392,267,603,
            235,83,84,778,866,1038,1040,1042,1046,1049,
            1051,1476,100,4199,4183,695,604,96,677,596,
            4179,4178,4023,89,90,624,82,87,88,112,
            113,114,115,116,117,135,136,137,138,139,
            72,73,79,681,67,54,55,685,65,688,
            49,686,41,690,37,223,689,35,509,1936,
            1934,695,604,96,677,596,4179,4178,4023,89,
            90,624,82,87,88,112,113,114,115,116,
            117,135,136,137,138,139,72,73,79,681,
            67,54,55,685,65,688,49,686,41,690,
            37,223,689,35,100,1936,2275,695,604,96,
            677,596,4179,4178,4023,89,90,624,82,87,
            88,112,113,114,115,116,117,135,136,137,
            138,139,72,73,79,681,67,54,55,685,
            65,688,49,686,41,690,37,223,689,35,
            228,1936,2279,695,604,96,677,596,4179,4178,
            4023,89,90,624,82,87,88,112,113,114,
            115,116,117,135,136,137,138,139,72,73,
            79,681,67,54,55,685,65,688,49,686,
            41,690,37,223,689,35,100,1936,2324,695,
            604,96,677,596,4179,4178,4023,89,90,624,
            82,87,88,112,113,114,115,116,117,135,
            136,137,138,139,72,73,79,681,67,54,
            55,685,65,688,49,686,41,690,37,223,
            689,35,229,1936,2325,695,604,96,677,596,
            4179,4178,4023,89,90,624,82,87,88,112,
            113,114,115,116,117,135,136,137,138,139,
            72,73,79,681,67,54,55,685,65,688,
            49,686,41,690,37,223,689,35,100,1936,
            2326,695,604,96,677,596,4179,4178,4023,89,
            90,624,82,87,88,112,113,114,115,116,
            117,135,136,137,138,139,72,73,79,681,
            67,54,55,685,65,688,49,686,41,690,
            37,223,689,35,2715,1936,2328,695,604,96,
            677,596,4179,4178,4023,89,90,624,82,87,
            88,112,113,114,115,116,117,135,136,137,
            138,139,72,73,79,681,67,54,55,685,
            65,688,49,686,41,690,37,223,689,35,
            100,1936,2373,695,604,96,677,596,4179,4178,
            4023,89,90,624,82,87,88,112,113,114,
            115,116,117,135,136,137,138,139,72,73,
            79,681,67,54,55,685,65,688,49,686,
            41,690,37,223,689,35,186,1936,2374,695,
            604,96,677,596,4179,4178,4023,89,90,624,
            82,87,88,112,113,114,115,116,117,135,
            136,137,138,139,72,73,79,681,67,54,
            55,685,65,688,49,686,41,690,37,223,
            689,35,100,1936,2375,695,604,96,677,596,
            4179,4178,4023,89,90,624,82,87,88,112,
            113,114,115,116,117,135,136,137,138,139,
            72,73,79,681,67,54,55,685,65,688,
            49,686,41,690,37,223,689,35,4217,1936,
            2377,695,604,96,677,596,4179,4178,4023,89,
            90,624,82,87,88,112,113,114,115,116,
            117,135,136,137,138,139,72,73,79,681,
            67,54,55,685,65,688,49,686,41,690,
            37,223,689,35,100,1936,2422,695,604,96,
            677,596,4179,4178,4023,89,90,624,82,87,
            88,112,113,114,115,116,117,135,136,137,
            138,139,72,73,79,681,67,54,55,685,
            65,688,49,686,41,690,37,223,689,35,
            4219,1936,2468,695,604,96,677,596,4179,4178,
            4023,89,90,624,82,87,88,112,113,114,
            115,116,117,135,136,137,138,139,72,73,
            79,681,67,54,55,685,65,688,49,686,
            41,690,37,223,689,35,1590,1936,2514,695,
            604,96,677,596,4179,4178,4023,89,90,624,
            82,87,88,112,113,114,115,116,117,135,
            136,137,138,139,72,73,79,681,67,54,
            55,685,65,688,49,686,41,690,37,223,
            689,35,1758,1936,2604,695,604,96,677,596,
            4179,4178,4023,89,90,624,82,87,88,112,
            113,114,115,116,117,135,136,137,138,139,
            72,73,79,681,67,54,55,685,65,688,
            49,686,41,690,37,223,689,35,1760,1936,
            2605,695,604,96,677,596,4179,4178,4023,89,
            90,624,82,87,88,112,113,114,115,116,
            117,135,136,137,138,139,72,73,79,681,
            67,54,55,685,65,688,49,686,41,690,
            37,223,689,35,1766,1936,2607,695,604,96,
            677,596,4179,4178,4023,89,90,624,82,87,
            88,112,113,114,115,116,117,135,136,137,
            138,139,72,73,79,681,67,54,55,685,
            65,688,49,686,41,690,37,223,689,35,
            1770,1936,2608,695,604,96,677,596,4179,4178,
            4023,89,90,624,82,87,88,112,113,114,
            115,116,117,135,136,137,138,139,72,73,
            79,681,67,54,55,685,65,688,49,686,
            41,690,37,223,689,35,1772,1936,2609,695,
            604,96,677,596,4179,4178,4023,89,90,624,
            82,87,88,112,113,114,115,116,117,135,
            136,137,138,139,72,73,79,681,67,54,
            55,685,65,688,49,686,41,690,37,223,
            689,35,1774,1936,2610,695,604,96,677,596,
            4179,4178,4023,89,90,624,82,87,88,112,
            113,114,115,116,117,135,136,137,138,139,
            72,73,79,681,67,54,55,685,65,688,
            49,686,41,690,37,223,689,35,493,1936,
            2611,204,604,96,677,596,4179,4178,4023,89,
            90,624,82,87,88,112,113,114,115,116,
            117,135,136,137,138,139,72,73,79,681,
            67,54,55,685,65,688,49,686,41,690,
            37,1837,689,35,1776,311,1780,1782,1784,1756,
            617,1762,1787,1791,274,1778,1764,1789,1495,1379,
            1794,1795,129,130,695,604,96,677,596,4179,
            4178,4023,89,90,624,82,87,88,112,113,
            114,115,116,117,135,136,137,138,139,72,
            73,79,681,67,54,55,685,65,688,49,
            686,41,690,37,223,689,35,1796,1936,2713,
            783,604,96,677,596,4179,4178,4023,89,90,
            624,82,87,88,112,113,114,115,116,117,
            135,136,137,138,139,72,73,79,681,67,
            54,55,685,65,688,49,686,41,690,37,
            166,689,35,1797,1700,1679,4042,1701,2716,783,
            604,96,677,596,4179,4178,4023,89,90,624,
            82,87,88,112,113,114,115,116,117,135,
            136,137,138,139,72,73,79,681,67,54,
            55,685,65,688,49,686,41,690,37,166,
            689,35,1712,400,1798,4042,1799,4044,783,604,
            96,677,596,4179,4178,4023,89,90,624,82,
            87,88,112,113,114,115,116,117,135,136,
            137,138,139,72,73,79,681,67,54,55,
            685,65,688,49,686,41,690,37,166,689,
            35,1801,1805,1807,4042,1809,4045,783,604,96,
            677,596,4179,4178,4023,89,90,624,82,87,
            88,112,113,114,115,116,117,135,136,137,
            138,139,72,73,79,681,67,54,55,685,
            65,688,49,686,41,690,37,166,689,35,
            1812,1818,1820,4042,1822,4046,783,604,96,677,
            596,4179,4178,4023,89,90,624,82,87,88,
            112,113,114,115,116,117,135,136,137,138,
            139,72,73,79,681,67,54,55,685,65,
            688,49,686,41,690,37,166,689,35,1825,
            1830,1836,4042,1838,4047,783,604,96,677,596,
            4179,4178,4023,89,90,624,82,87,88,112,
            113,114,115,116,117,135,136,137,138,139,
            72,73,79,681,67,54,55,685,65,688,
            49,686,41,690,37,166,689,35,1840,1842,
            1720,4042,1722,4065,783,604,96,677,596,4179,
            4178,4023,89,90,624,82,87,88,112,113,
            114,115,116,117,135,136,137,138,139,72,
            73,79,681,67,54,55,685,65,688,49,
            686,41,690,37,166,689,35,1595,1599,1552,
            4042,1724,4083,783,604,96,677,596,4179,4178,
            4023,89,90,624,82,87,88,112,113,114,
            115,116,117,135,136,137,138,139,72,73,
            79,681,67,54,55,685,65,688,49,686,
            41,690,37,166,689,35,1734,1738,1803,4042,
            1844,4084,783,604,96,677,596,4179,4178,4023,
            89,90,624,82,87,88,112,113,114,115,
            116,117,135,136,137,138,139,72,73,79,
            681,67,54,55,685,65,688,49,686,41,
            690,37,166,689,35,1814,1832,1828,4042,1850,
            4096,783,604,96,677,596,4179,4178,4023,89,
            90,624,82,87,88,112,113,114,115,116,
            117,135,136,137,138,139,72,73,79,681,
            67,54,55,685,65,688,49,686,41,690,
            37,166,689,35,1851,1854,1855,4042,1858,4102,
            783,604,96,677,596,4179,4178,4023,89,90,
            624,82,87,88,112,113,114,115,116,117,
            135,136,137,138,139,72,73,79,681,67,
            54,55,685,65,688,49,686,41,690,37,
            166,689,35,1862,1863,1866,4042,1867,4106,695,
            604,96,677,596,4179,4178,4023,89,90,624,
            82,87,88,112,113,114,115,116,117,135,
            136,137,138,139,72,73,79,681,67,54,
            55,685,65,688,49,686,41,690,37,223,
            689,35,1870,1936,4201,695,604,96,677,596,
            4179,4178,4023,89,90,624,82,87,88,112,
            113,114,115,116,117,135,136,137,138,139,
            72,73,79,681,67,54,55,685,65,688,
            49,686,41,690,37,223,689,35,1871,1936,
            4202,607,604,96,677,596,4179,4178,4023,89,
            90,624,82,87,88,112,113,114,115,116,
            117,135,136,137,138,139,72,73,79,681,
            67,54,55,685,65,688,49,686,41,690,
            37,223,689,35,1874,1887,607,604,96,677,
            596,4179,4178,4023,89,90,624,82,87,88,
            112,113,114,115,116,117,135,136,137,138,
            139,72,73,79,681,67,54,55,685,65,
            688,49,686,41,690,37,223,689,35,493,
            1932,607,604,96,677,596,4179,4178,4023,89,
            90,624,82,87,88,112,113,114,115,116,
            117,135,136,137,138,139,72,73,79,681,
            67,54,55,685,65,688,49,686,41,690,
            37,2228,689,35,1875,1879,312,1880,1884,1887,
            1888,1891,1845,264,1894,1898,1900,1303,1902,310,
            607,604,96,677,596,4179,4178,4023,89,90,
            624,82,87,88,112,113,114,115,116,117,
            135,136,137,138,139,72,73,79,681,67,
            54,55,685,65,688,49,686,41,690,37,
            223,689,35,493,2714,507,604,96,677,596,
            4179,4178,4023,89,90,624,82,87,88,112,
            113,114,115,116,117,135,136,137,138,139,
            72,73,79,681,67,54,55,685,65,688,
            49,686,41,690,37,237,689,35,1903,1892,
            312,1883,1723,1906,1725,503,1907,263,236,607,
            604,96,677,596,4179,4178,4023,89,90,624,
            82,87,88,112,113,114,115,116,117,135,
            136,137,138,139,72,73,79,681,67,54,
            55,685,65,688,49,686,41,690,37,595,
            689,35,607,604,96,677,596,4179,4178,4023,
            89,90,624,82,87,88,112,113,114,115,
            116,117,135,136,137,138,139,72,73,79,
            681,67,54,55,685,65,688,49,686,41,
            690,37,747,689,35,607,604,96,677,596,
            4179,4178,4023,89,90,624,82,87,88,112,
            113,114,115,116,117,135,136,137,138,139,
            72,73,79,681,67,54,55,685,65,688,
            49,686,41,690,37,1779,689,35,607,604,
            96,677,596,4179,4178,4023,89,90,624,82,
            87,88,112,113,114,115,116,117,135,136,
            137,138,139,72,73,79,681,67,54,55,
            685,65,688,49,686,41,690,37,133,689,
            35,607,604,96,677,596,4179,4178,4023,89,
            90,624,82,87,88,112,113,114,115,116,
            117,135,136,137,138,139,72,73,79,681,
            67,54,55,685,65,688,49,686,41,690,
            37,2617,689,35,607,604,96,677,596,4179,
            4178,4023,89,90,624,82,87,88,112,113,
            114,115,116,117,135,136,137,138,139,72,
            73,79,681,67,54,55,685,65,688,49,
            686,41,690,37,308,689,35,607,604,96,
            677,596,4179,4178,4023,89,90,624,82,87,
            88,112,113,114,115,116,117,135,136,137,
            138,139,72,73,79,681,67,54,55,685,
            65,688,49,686,41,690,37,225,689,35,
            607,604,96,677,596,4179,4178,4023,89,90,
            624,82,87,88,112,113,114,115,116,117,
            135,136,137,138,139,72,73,79,681,67,
            54,55,685,65,688,49,686,41,690,37,
            134,689,35,607,604,96,677,596,4179,4178,
            4023,89,90,624,82,87,88,112,113,114,
            115,116,117,135,136,137,138,139,72,73,
            79,681,67,54,55,685,65,688,49,686,
            41,690,37,132,689,35,607,604,96,677,
            596,4179,4178,4023,89,90,624,82,87,88,
            112,113,114,115,116,117,135,136,137,138,
            139,72,73,79,681,67,54,55,685,65,
            688,49,686,41,690,37,174,689,35,607,
            604,96,677,596,4179,4178,4023,89,90,624,
            82,87,88,112,113,114,115,116,117,135,
            136,137,138,139,72,73,79,681,67,54,
            55,685,65,688,49,686,41,690,37,224,
            689,35,607,604,96,677,596,4179,4178,4023,
            89,90,624,82,87,88,112,113,114,115,
            116,117,135,136,137,138,139,72,73,79,
            681,67,54,55,685,65,688,49,686,41,
            690,37,173,689,35,607,604,96,677,596,
            4179,4178,4023,89,90,624,82,87,88,112,
            113,114,115,116,117,135,136,137,138,139,
            72,73,79,681,67,54,55,685,65,688,
            49,686,41,690,37,4207,689,35,607,604,
            96,677,596,4179,4178,4023,89,90,624,82,
            87,88,112,113,114,115,116,117,135,136,
            137,138,139,72,73,79,681,67,54,55,
            685,65,688,49,686,41,690,37,4218,689,
            35,607,604,96,677,596,4179,4178,4023,89,
            90,624,82,87,88,112,113,114,115,116,
            117,135,136,137,138,139,72,73,79,681,
            67,54,55,685,65,688,49,686,41,690,
            37,167,689,35,607,604,96,677,596,4179,
            4178,4023,89,90,624,82,87,88,112,113,
            114,115,116,117,135,136,137,138,139,72,
            73,79,681,67,54,55,685,65,688,49,
            686,41,690,37,4220,689,35,607,604,96,
            677,596,4179,4178,4023,89,90,624,82,87,
            88,112,113,114,115,116,117,135,136,137,
            138,139,72,73,79,681,67,54,55,685,
            65,688,49,686,41,690,37,168,689,35,
            607,604,96,677,596,4179,4178,4023,89,90,
            624,82,87,88,112,113,114,115,116,117,
            135,136,137,138,139,72,73,79,681,67,
            54,55,685,65,688,49,686,41,2179,39,
            607,604,96,677,596,4179,4178,4023,89,90,
            624,82,87,88,112,113,114,115,116,117,
            135,136,137,138,139,72,73,79,681,67,
            54,55,685,65,688,49,2181,47,607,604,
            96,677,596,4179,4178,4023,89,90,624,82,
            87,88,112,113,114,115,116,117,135,136,
            137,138,139,72,73,79,681,67,54,55,
            685,65,688,49,2226,46,607,604,96,677,
            596,4179,4178,4023,89,90,624,82,87,88,
            112,113,114,115,116,117,135,136,137,138,
            139,72,73,79,681,67,54,55,685,65,
            688,49,2227,45,607,604,96,677,596,4179,
            4178,4023,89,90,624,82,87,88,112,113,
            114,115,116,117,135,136,137,138,139,72,
            73,79,681,67,54,55,685,65,2178,51,
            607,604,96,677,596,4179,4178,4023,89,90,
            624,82,87,88,112,113,114,115,116,117,
            135,136,137,138,139,72,73,79,681,67,
            62,63,685,65,607,604,96,677,596,4179,
            4178,4023,89,90,624,82,87,88,112,113,
            114,115,116,117,135,136,137,138,139,72,
            73,79,681,67,60,61,685,65,607,604,
            96,677,596,4179,4178,4023,89,90,624,82,
            87,88,112,113,114,115,116,117,135,136,
            137,138,139,72,73,79,681,67,58,59,
            685,65,607,604,96,677,596,4179,4178,4023,
            89,90,624,82,87,88,112,113,114,115,
            116,117,135,136,137,138,139,72,73,79,
            681,67,56,57,685,65,871,604,96,677,
            596,4179,4178,4023,89,90,624,82,87,88,
            112,113,114,115,116,117,135,136,137,138,
            139,72,73,79,2130,71,871,604,96,677,
            596,4179,4178,4023,89,90,624,82,87,88,
            112,113,114,115,116,117,135,136,137,138,
            139,72,73,79,2132,69,871,604,96,677,
            596,4179,4178,4023,89,90,624,82,87,88,
            112,113,114,115,116,117,135,136,137,138,
            139,76,77,79,871,604,96,677,596,4179,
            4178,4023,89,90,624,82,87,88,112,113,
            114,115,116,117,135,136,137,138,139,74,
            75,79,1053,604,96,677,596,4179,4178,4023,
            89,90,624,82,87,88,112,113,114,115,
            116,117,135,136,137,138,139,81,1053,604,
            96,677,596,4179,4178,4023,89,90,624,82,
            87,88,112,113,114,115,116,117,135,136,
            137,138,139,80,955,604,96,677,596,4179,
            4178,4023,89,90,624,82,87,88,112,113,
            114,115,116,117,135,136,137,138,139,80,
            1136,604,96,677,596,4179,4178,4023,89,90,
            692,82,87,88,112,113,114,115,116,117,
            135,136,137,138,139,1219,604,96,677,596,
            4179,4178,4023,89,90,692,82,87,88,112,
            113,114,115,116,117,135,136,137,138,139,
            91,493,295,506,506,493,1519,341,177,1781,
            1782,1519,341,177,1781,1782,1519,341,177,1781,
            1782,289,1727,1648,1910,1914,1915,1918,4212,1519,
            341,177,1781,1782,1519,341,177,1781,1782,1519,
            341,177,1781,1782,506,1919,749,753,316,311,
            1521,1521,523,4215,247,323,178,179,4211,506,
            320,178,179,1923,1924,2230,178,179,241,86,
            391,398,392,4089,520,506,1927,387,2618,178,
            179,1637,1928,303,178,179,1931,754,239,178,
            179,491,493,242,243,4022,190,188,414,513,
            407,421,755,417,694,415,1519,341,177,1781,
            1782,506,1932,1911,189,187,311,506,756,4025,
            402,617,401,506,311,273,319,185,2711,617,
            280,506,506,273,4111,2712,1884,345,316,316,
            506,506,506,506,275,506,506,506,1786,1786,
            506,506,276,504,757,304,178,179,396,954,
            758,506,506,1935,506,506,759,292,284,1586,
            2708,2709,506,266,760,761,506,506,506,1936,
            1937,1939,1940,1406,1452,1498,1544,31,1590,1636,
            1682,1943,1944,1774,1776,1945,1777,637,1946,1543,
            1947,93,1778,4244,2612,2614,293,1777,2615,4244,
            4244,4244,2616,4244,4244,217,4244,4244,4244,95,
            94,218,4244,4244
        };
    };
    public final static char baseAction[] = BaseAction.baseAction;
    public final int baseAction(int index) { return baseAction[index]; }
    public final static char lhs[] = baseAction;
    public final int lhs(int index) { return lhs[index]; };

    public interface TermCheck {
        public final static byte termCheck[] = {0,
            0,1,0,3,4,5,6,7,8,9,
            10,11,12,13,14,15,16,17,18,19,
            20,21,22,23,24,25,26,27,28,29,
            0,31,32,33,34,35,36,37,38,39,
            40,41,42,43,44,45,46,47,48,49,
            50,51,52,53,54,55,56,57,58,59,
            60,61,62,63,64,65,66,67,68,69,
            70,71,72,73,74,75,76,77,78,79,
            80,81,82,0,1,0,86,87,3,4,
            0,6,0,1,9,3,4,7,0,0,
            15,11,3,13,0,0,1,107,3,4,
            5,6,7,8,9,10,11,12,13,14,
            15,16,17,18,19,20,21,22,23,24,
            25,26,27,28,29,105,31,32,33,34,
            35,36,37,38,39,40,41,42,43,44,
            45,46,47,48,49,50,51,52,53,54,
            55,56,57,58,59,60,61,62,63,64,
            65,66,67,68,69,70,71,72,73,74,
            75,76,77,78,79,80,81,82,0,0,
            1,86,87,95,96,97,98,0,108,95,
            96,97,98,0,1,100,3,4,5,6,
            7,8,9,10,11,12,13,14,15,16,
            17,18,19,20,21,22,23,24,25,26,
            27,28,29,0,31,32,33,34,35,36,
            37,38,39,40,41,42,43,44,45,46,
            47,48,49,50,51,52,53,54,55,56,
            57,58,59,60,61,62,63,64,65,66,
            67,68,69,70,71,72,73,74,75,76,
            77,78,79,80,81,82,89,99,0,86,
            87,3,4,0,0,2,8,3,4,0,
            0,0,1,100,3,4,5,6,7,8,
            9,10,11,12,13,14,15,16,17,18,
            19,20,21,22,23,24,25,26,27,28,
            29,0,31,32,33,34,35,36,37,38,
            39,40,41,42,43,44,45,46,47,48,
            49,50,51,52,53,54,55,56,57,58,
            59,60,61,62,63,64,65,66,67,68,
            69,70,71,72,73,74,75,76,77,78,
            79,80,81,82,90,85,0,86,87,3,
            4,0,6,2,0,0,1,3,4,0,
            1,0,1,102,3,4,5,6,7,8,
            9,10,11,12,13,14,15,16,17,18,
            19,20,21,22,23,24,25,26,27,28,
            29,0,31,32,33,34,35,36,37,38,
            39,40,41,42,43,44,45,46,47,48,
            49,50,51,52,53,54,55,56,57,58,
            59,60,61,62,63,64,65,66,67,68,
            69,70,71,72,73,74,75,76,77,78,
            79,80,81,82,85,0,91,86,87,94,
            0,0,0,3,4,3,4,0,8,14,
            3,4,0,0,1,0,0,1,107,3,
            4,5,6,7,8,9,10,11,12,13,
            14,15,16,17,18,19,20,21,22,23,
            24,25,26,27,28,29,0,31,32,33,
            34,35,36,37,38,39,40,41,42,43,
            44,45,46,47,48,49,50,51,52,53,
            54,55,56,57,58,59,60,61,62,63,
            64,65,66,67,68,69,70,71,72,73,
            74,75,76,77,78,79,80,81,82,0,
            88,89,86,87,91,0,91,0,1,0,
            1,12,0,1,0,10,0,1,102,3,
            4,5,6,7,8,9,10,11,12,13,
            14,15,16,17,18,19,20,21,22,23,
            24,25,26,27,28,29,0,31,32,33,
            34,35,36,37,38,39,40,41,42,43,
            44,45,46,47,48,49,50,51,52,53,
            54,55,56,57,58,59,60,61,62,63,
            64,65,66,67,68,69,70,71,72,73,
            74,75,76,77,78,79,80,81,82,0,
            91,0,86,87,0,1,7,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,27,28,29,88,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,70,71,72,73,74,75,
            76,77,78,79,80,81,82,0,1,90,
            86,87,0,1,0,3,4,5,6,7,
            8,9,10,11,12,13,14,15,16,17,
            18,19,20,21,22,23,24,25,26,27,
            28,29,0,31,32,33,34,35,36,37,
            38,39,40,41,42,43,44,45,46,47,
            48,49,50,51,52,53,54,55,56,57,
            58,59,60,61,62,63,64,65,66,67,
            68,69,70,71,72,73,74,75,76,77,
            78,79,80,81,82,0,1,83,86,87,
            0,1,0,3,4,5,6,7,8,9,
            10,11,12,13,14,15,16,17,18,19,
            20,21,22,23,24,25,26,27,28,29,
            0,31,32,33,34,35,36,37,38,39,
            40,41,42,43,44,45,46,47,48,49,
            50,51,52,53,54,55,56,57,58,59,
            60,61,62,63,64,65,66,67,68,69,
            70,71,72,73,74,75,76,77,78,79,
            80,81,82,0,0,1,86,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,27,28,29,84,31,32,33,34,35,
            36,37,38,39,40,41,42,43,44,45,
            46,47,48,49,50,51,52,53,54,55,
            56,57,58,59,60,61,62,63,64,65,
            66,67,68,69,70,71,72,73,74,75,
            76,77,78,79,80,81,82,0,1,0,
            1,0,1,0,91,0,1,94,0,1,
            0,1,0,1,100,3,4,5,6,7,
            8,9,10,11,12,13,14,15,16,17,
            18,19,20,21,22,23,24,25,26,27,
            28,29,0,31,32,33,34,35,36,37,
            38,39,40,41,42,43,44,45,46,47,
            48,49,50,51,52,53,54,55,56,57,
            58,59,60,61,62,63,64,65,66,67,
            68,69,70,71,72,73,74,75,76,77,
            78,79,80,81,82,0,1,0,3,4,
            5,6,7,8,9,10,11,12,13,14,
            15,16,17,18,19,20,21,22,23,24,
            25,26,27,28,29,83,31,32,33,34,
            35,36,37,38,39,40,41,42,43,44,
            45,46,47,48,49,50,51,52,53,54,
            55,56,57,58,59,60,61,62,63,64,
            65,66,0,68,69,70,71,72,73,74,
            75,76,77,78,0,80,81,82,0,1,
            0,3,4,5,6,7,8,9,10,11,
            12,13,14,15,16,17,18,19,20,21,
            22,23,24,25,26,27,28,29,0,31,
            32,33,34,35,36,37,38,39,40,41,
            42,43,44,45,46,47,48,49,50,51,
            52,53,54,55,56,57,58,59,60,61,
            62,63,64,65,66,83,68,69,70,71,
            72,73,74,75,76,77,78,83,80,81,
            82,0,0,89,3,85,5,6,7,8,
            9,10,11,12,13,14,15,16,17,18,
            19,20,21,22,23,24,25,26,27,28,
            29,83,31,32,33,34,35,36,37,38,
            39,40,41,42,43,44,45,46,47,48,
            49,50,51,52,53,54,55,56,57,58,
            59,60,61,62,63,64,65,66,67,68,
            69,70,71,72,73,74,0,0,0,3,
            79,5,6,7,8,9,10,11,12,13,
            14,15,16,17,18,19,20,21,22,23,
            24,25,26,27,28,29,104,31,32,33,
            34,35,36,37,38,39,40,41,42,43,
            44,45,46,47,48,49,50,51,52,53,
            54,55,56,57,58,59,60,61,62,63,
            64,65,66,67,68,69,70,71,72,73,
            74,0,0,0,3,79,0,6,7,8,
            9,10,11,12,13,14,15,90,17,18,
            19,20,21,22,23,0,1,99,26,27,
            28,29,0,30,0,34,35,36,37,38,
            39,40,41,42,0,44,45,46,47,48,
            49,50,51,52,53,54,55,56,57,58,
            59,60,61,62,63,64,65,66,0,0,
            0,3,0,3,6,7,8,9,10,11,
            12,13,14,15,0,17,18,19,20,21,
            22,23,0,24,25,0,0,2,0,0,
            5,0,34,35,36,37,38,39,40,41,
            42,16,0,45,46,47,48,49,84,24,
            25,26,27,28,29,30,31,32,33,31,
            32,33,31,32,33,0,0,93,43,0,
            1,0,30,75,0,0,0,0,0,3,
            3,4,6,7,8,9,10,11,12,13,
            14,15,67,17,18,19,20,21,22,23,
            26,27,28,29,26,27,28,29,106,43,
            88,85,83,88,89,90,0,92,93,3,
            95,96,97,98,99,83,101,0,103,104,
            105,106,0,67,0,3,2,0,6,7,
            8,9,10,11,12,13,14,15,0,17,
            18,19,20,21,22,23,91,30,0,94,
            85,84,0,5,30,0,34,35,36,37,
            38,39,40,41,42,0,44,0,3,0,
            0,6,7,8,9,10,11,12,13,14,
            15,0,17,18,19,20,21,22,23,0,
            0,0,0,0,0,5,0,30,5,30,
            30,84,85,0,0,88,16,0,5,16,
            83,30,5,24,25,24,25,0,0,16,
            0,83,30,16,30,0,30,0,1,0,
            1,0,84,0,30,0,1,85,83,0,
            1,0,1,0,1,0,1,0,30,0,
            1,0,1,0,1,88,0,1,0,90,
            0,1,92,0,0,0,0,0,0,2,
            0,1,0,92,0,1,0,1,0,1,
            88,0,1,0,88,2,92,0,1,0,
            1,0,1,30,0,1,30,0,30,0,
            1,0,85,2,84,0,1,0,1,0,
            1,0,1,0,0,1,85,84,5,0,
            0,2,2,0,0,2,2,0,103,2,
            83,0,0,2,2,0,0,2,2,0,
            0,2,2,0,0,2,2,89,0,0,
            2,2,0,0,90,2,0,0,2,2,
            0,0,2,0,1,93,101,0,1,0,
            1,0,0,2,2,0,0,2,2,0,
            0,2,85,0,0,2,2,0,0,2,
            2,30,0,0,2,2,0,0,2,2,
            0,0,2,2,0,0,0,2,0,0,
            2,2,0,0,0,0,0,2,2,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,30,0,0,0,0,0,
            0,0,90,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,84,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,89,84,0,0,0,
            0,0,89,89,84,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0
        };
    };
    public final static byte termCheck[] = TermCheck.termCheck;
    public final int termCheck(int index) { return termCheck[index]; }

    public interface TermAction {
        public final static char termAction[] = {0,
            289,2762,240,608,4388,4162,4571,4573,4575,4568,
            4572,4574,4576,4577,4578,4579,4161,4582,4584,4583,
            4581,4580,4569,4570,4173,4152,4151,4143,4137,4131,
            4244,4095,4079,4064,4345,4343,4344,4346,4347,4348,
            4349,4350,4351,4160,4341,675,674,623,616,609,
            4258,4259,4260,603,4245,4246,4247,4248,4249,4250,
            4251,4252,4253,4254,4255,4256,4257,3918,4165,4163,
            4166,4167,4171,4170,4024,599,679,4385,4387,3892,
            4389,4390,4392,4244,400,4244,762,2805,4587,4588,
            4244,1728,4244,400,4097,4587,4588,626,78,4244,
            693,396,744,533,300,126,2762,2561,608,4388,
            4162,4571,4573,4575,4568,4572,4574,4576,4577,4578,
            4579,4161,4582,4584,4583,4581,4580,4569,4570,4173,
            4152,4151,4143,4137,4131,4474,4095,4079,4064,4345,
            4343,4344,4346,4347,4348,4349,4350,4351,4160,4341,
            675,674,623,616,609,4258,4259,4260,603,4245,
            4246,4247,4248,4249,4250,4251,4252,4253,4254,4255,
            4256,4257,3944,4165,4163,4166,4167,4171,4170,4024,
            599,679,4385,4387,3892,4389,4390,4392,260,4244,
            4561,762,2805,524,613,418,411,4244,4243,524,
            613,418,411,4244,2762,2848,608,4388,4162,4571,
            4573,4575,4568,4572,4574,4576,4577,4578,4579,4161,
            4582,4584,4583,4581,4580,4569,4570,4173,4152,4151,
            4143,4137,4131,4244,4095,4079,4064,4345,4343,4344,
            4346,4347,4348,4349,4350,4351,4160,4341,675,674,
            623,616,609,4258,4259,4260,603,4245,4246,4247,
            4248,4249,4250,4251,4252,4253,4254,4255,4256,4257,
            3944,4165,4163,4166,4167,4171,4170,4024,599,679,
            4385,4387,3892,4389,4390,4392,4489,538,294,762,
            2805,6186,6186,4244,4244,1785,6186,4587,4588,4244,
            315,233,2762,2848,608,4388,4162,4571,4573,4575,
            4568,4572,4574,4576,4577,4578,4579,4161,4582,4584,
            4583,4581,4580,4569,4570,4173,4152,4151,4143,4137,
            4131,4244,4095,4079,4064,4345,4343,4344,4346,4347,
            4348,4349,4350,4351,4160,4341,675,674,623,616,
            609,4258,4259,4260,603,4245,4246,4247,4248,4249,
            4250,4251,4252,4253,4254,4255,4256,4257,3918,4165,
            4163,4166,4167,4171,4170,4024,599,679,4385,4387,
            3892,4389,4390,4392,4490,404,4244,762,2805,4587,
            4588,4244,1728,4335,258,219,22,4587,4588,119,
            1794,299,2762,4133,608,4388,4162,4571,4573,4575,
            4568,4572,4574,4576,4577,4578,4579,4161,4582,4584,
            4583,4581,4580,3995,3970,4173,4152,4151,4143,4137,
            4131,4244,4095,4079,4064,4345,4343,4344,4346,4347,
            4348,4349,4350,4351,4160,4341,675,674,623,616,
            609,4258,4259,4260,603,4245,4246,4247,4248,4249,
            4250,4251,4252,4253,4254,4255,4256,4257,3918,4165,
            4163,4166,4167,4171,4170,4024,599,679,4385,4387,
            3892,4389,4390,4392,109,256,6134,762,2805,2471,
            4244,4244,4244,4587,4588,4587,4588,285,4021,4497,
            6539,6539,4244,142,219,219,4244,2762,2561,608,
            4388,4162,4571,4573,4575,4568,4572,4574,4576,4577,
            4578,4579,4161,4582,4584,4583,4581,4580,4569,4570,
            4173,4152,4151,4143,4137,4131,4244,4095,4079,4064,
            4345,4343,4344,4346,4347,4348,4349,4350,4351,4160,
            4341,675,674,623,616,609,4258,4259,4260,603,
            4245,4246,4247,4248,4249,4250,4251,4252,4253,4254,
            4255,4256,4257,3918,4165,4163,4166,4167,4171,4170,
            4024,599,679,4385,4387,3892,4389,4390,4392,262,
            3278,1222,762,2805,4464,251,4464,4244,765,147,
            23,2663,4244,811,4244,4492,4244,2762,4133,608,
            4388,4162,4571,4573,4575,4568,4572,4574,4576,4577,
            4578,4579,4161,4582,4584,4583,4581,4580,4569,4570,
            4173,4152,4151,4143,4137,4131,4244,4095,4079,4064,
            4345,4343,4344,4346,4347,4348,4349,4350,4351,4160,
            4341,675,674,623,616,609,4258,4259,4260,603,
            4245,4246,4247,4248,4249,4250,4251,4252,4253,4254,
            4255,4256,4257,3918,4165,4163,4166,4167,4171,4170,
            4024,599,679,4385,4387,3892,4389,4390,4392,4244,
            23,4244,762,2805,221,2762,626,608,4388,4162,
            4571,4573,4575,4568,4572,4574,4576,4577,4578,4579,
            4161,4582,4584,4583,4581,4580,4569,4570,4173,4152,
            4151,4143,4137,4131,3364,4095,4079,4064,4345,4343,
            4344,4346,4347,4348,4349,4350,4351,4160,4341,675,
            674,623,616,609,4258,4259,4260,603,4245,4246,
            4247,4248,4249,4250,4251,4252,4253,4254,4255,4256,
            4257,3918,4165,4163,4166,4167,4171,4170,4024,599,
            679,4385,4387,3892,4389,4390,4392,4244,515,4514,
            762,2805,4244,2762,4244,4043,4388,4162,4571,4573,
            4575,4568,4572,4574,4576,4577,4578,4579,4161,4582,
            4584,4583,4581,4580,4569,4570,4173,4152,4151,4143,
            4137,4131,4244,4095,4079,4064,4345,4343,4344,4346,
            4347,4348,4349,4350,4351,4160,4341,675,674,623,
            616,609,4258,4259,4260,603,4245,4246,4247,4248,
            4249,4250,4251,4252,4253,4254,4255,4256,4257,3918,
            4165,4163,4166,4167,4171,4170,4024,599,679,4385,
            4387,3892,4389,4390,4392,4244,857,4488,762,2805,
            4244,2762,4244,608,4388,4162,4571,4573,4575,4568,
            4572,4574,4576,4577,4578,4579,4161,4582,4584,4583,
            4581,4580,4569,4570,4173,4152,4151,4143,4137,4131,
            4244,4095,4079,4064,4345,4343,4344,4346,4347,4348,
            4349,4350,4351,4160,4341,675,674,623,616,609,
            4258,4259,4260,603,4245,4246,4247,4248,4249,4250,
            4251,4252,4253,4254,4255,4256,4257,3918,4165,4163,
            4166,4167,4171,4170,4024,599,679,4385,4387,3892,
            4389,4390,4392,219,4244,2762,762,608,4388,4162,
            4571,4573,4575,4568,4572,4574,4576,4577,4578,4579,
            4161,4582,4584,4583,4581,4580,4569,4570,4173,4152,
            4151,4143,4137,4131,4026,4095,4079,4064,4345,4343,
            4344,4346,4347,4348,4349,4350,4351,4160,4341,675,
            674,623,616,609,4258,4259,4260,603,4245,4246,
            4247,4248,4249,4250,4251,4252,4253,4254,4255,4256,
            4257,3918,4165,4163,4166,4167,4171,4170,4024,599,
            679,4385,4387,3892,4389,4390,4392,4244,903,4244,
            949,4244,995,4244,4464,4244,1041,2516,4244,1087,
            4244,1133,4244,2762,3063,608,4388,4162,4571,4573,
            4575,4568,4572,4574,4576,4577,4578,4579,4161,4582,
            4584,4583,4581,4580,4569,4570,4173,4152,4151,4143,
            4137,4131,4244,4095,4079,4064,4345,4343,4344,4346,
            4347,4348,4349,4350,4351,4160,4341,675,674,623,
            616,609,4258,4259,4260,603,4245,4246,4247,4248,
            4249,4250,4251,4252,4253,4254,4255,4256,4257,3918,
            4165,4163,4166,4167,4171,4170,4024,599,679,4385,
            4387,3892,4389,4390,4392,326,2762,4244,608,4388,
            4162,4571,4573,4575,4568,4572,4574,4576,4577,4578,
            4579,4161,4582,4584,4583,4581,4580,4569,4570,4173,
            4152,4151,4143,4137,4131,544,4095,4079,4064,4345,
            4343,4344,4346,4347,4348,4349,4350,4351,4160,4341,
            675,674,623,616,609,4258,4259,4260,603,4245,
            4246,4247,4248,4249,4250,4251,4252,4253,4254,4255,
            4256,4257,4244,4165,4163,4166,4167,4171,4170,4024,
            599,679,4385,4387,4244,4389,4390,4392,325,2762,
            314,608,4388,4162,4571,4573,4575,4568,4572,4574,
            4576,4577,4578,4579,4161,4582,4584,4583,4581,4580,
            4569,4570,4173,4152,4151,4143,4137,4131,21,4095,
            4079,4064,4345,4343,4344,4346,4347,4348,4349,4350,
            4351,4160,4341,675,674,623,616,609,4258,4259,
            4260,603,4245,4246,4247,4248,4249,4250,4251,4252,
            4253,4254,4255,4256,4257,4071,4165,4163,4166,4167,
            4171,4170,4024,599,679,4385,4387,2719,4389,4390,
            4392,4244,4244,4565,4342,404,4162,4571,4573,4575,
            4568,4572,4574,4576,4577,4578,4579,4161,4582,4584,
            4583,4581,4580,4569,4570,4184,4152,4151,4143,4137,
            4131,125,4095,4079,4064,4345,4343,4344,4346,4347,
            4348,4349,4350,4351,4160,4341,4261,4262,4263,4264,
            4265,4258,4259,4260,4267,4245,4246,4247,4248,4249,
            4250,4251,4252,4253,4254,4255,4256,4257,4182,4165,
            4163,4166,4167,4171,4170,4024,4244,4244,4244,4342,
            4181,4162,4571,4573,4575,4568,4572,4574,4576,4577,
            4578,4579,4161,4582,4584,4583,4581,4580,4569,4570,
            4184,4152,4151,4143,4137,4131,3235,4095,4079,4064,
            4345,4343,4344,4346,4347,4348,4349,4350,4351,4160,
            4341,4261,4262,4263,4264,4265,4258,4259,4260,4267,
            1981,2083,2081,2080,2034,2079,2032,2031,2030,1985,
            1983,1982,4257,4182,4165,4163,4166,4167,4171,4170,
            4024,4244,48,257,4342,4181,4244,4571,4573,4575,
            4568,4572,4574,4576,4577,4578,4579,4566,4582,4584,
            4583,4581,4580,4569,4570,4244,1179,2977,3742,3708,
            3674,3640,4244,4498,4244,4345,4343,4344,4346,4347,
            4348,4349,4350,4351,307,4341,4261,4262,4263,4264,
            4265,4258,4259,4260,4267,4245,4246,4247,4248,4249,
            4250,4251,4252,4253,4254,4255,4256,4257,4244,66,
            4244,4352,34,1885,4571,4573,4575,4568,4572,4574,
            4576,4577,4578,4579,4244,4582,4584,4583,4581,4580,
            4569,4570,4244,3864,3836,22,313,4464,36,20,
            4464,38,4345,4343,4344,4346,4347,4348,4349,4350,
            4351,4464,4244,4365,4366,4367,4368,4369,4031,4464,
            4464,4464,4464,4464,4464,4464,4464,4464,4464,3566,
            3528,3490,3566,3528,3490,219,64,2934,4464,4244,
            1225,4244,2559,1783,52,342,4244,294,50,4352,
            290,290,4571,4573,4575,4568,4572,4574,4576,4577,
            4578,4579,4464,4582,4584,4583,4581,4580,4569,4570,
            3742,3708,3674,3640,3742,3708,3674,3640,3450,3806,
            3407,404,124,4464,4464,4464,183,4464,4464,744,
            4464,4464,4464,4464,4464,4509,4464,98,4464,4464,
            4464,4464,4244,3776,4244,4342,535,19,4571,4573,
            4575,4568,4572,4574,4576,4577,4578,4579,18,4582,
            4584,4583,4581,4580,4569,4570,4464,171,171,2620,
            341,290,98,3106,4562,17,4345,4343,4344,4346,
            4347,4348,4349,4350,4351,110,4341,288,4352,4244,
            4244,4571,4573,4575,4568,4572,4574,4576,4577,4578,
            4579,4244,4582,4584,4583,4581,4580,4569,4570,70,
            40,68,298,44,4244,3604,4244,4527,3604,4070,
            3149,4036,108,43,252,171,426,42,3604,426,
            123,3149,3604,3864,3836,3864,3836,4244,226,426,
            171,122,4535,426,3149,4244,1314,4244,1271,4244,
            1317,180,4036,4244,4493,4244,1363,108,121,4244,
            1409,4244,1455,4244,1501,4244,1547,4244,854,4244,
            1593,4244,1639,92,1685,4530,4244,4049,4244,4384,
            4244,4101,4196,227,4244,131,127,4244,222,4329,
            1,1038,4244,4197,12,1840,11,1889,10,1938,
            4539,9,1987,4244,3321,4458,4198,8,2036,7,
            2085,5,2134,946,6,2183,1731,111,3149,4,
            2232,4244,388,4459,4036,3,2281,2,2330,4244,
            629,4244,697,172,4244,2379,404,4054,3192,4244,
            4244,4457,4456,4244,4244,4455,4454,4244,2891,4453,
            4041,4244,4244,4452,4451,4244,4244,4450,4448,4244,
            4244,4447,4446,4244,4244,4445,4444,4531,4244,4244,
            4443,4442,4244,4244,4364,4441,4244,4244,4440,4449,
            4244,184,4439,4244,2425,2934,3020,217,811,216,
            1685,4244,4244,4425,4426,4244,4244,4330,4409,4244,
            238,4408,404,4244,4244,4407,4406,4244,4244,4405,
            4404,1130,4244,4244,4403,4402,4244,4244,4401,4400,
            4244,4244,4399,4476,234,4244,4244,4475,4244,4244,
            4438,4437,4244,4244,4244,4244,4244,4413,4414,4244,
            285,4244,4244,4244,4244,4244,4244,4244,4244,4244,
            4244,4244,4244,4244,2665,4244,4244,4244,4244,4244,
            4244,4244,4515,4244,4244,4244,4244,4244,4244,4244,
            4244,4244,4244,4244,4244,4244,4244,4244,4244,4244,
            4244,4244,4244,4244,4059,4244,4244,4244,4244,4244,
            4244,4244,4244,4244,4244,4244,4244,4244,4244,4244,
            4244,4244,4244,4244,4244,4244,4244,4244,4244,4244,
            4244,4244,4244,4244,4244,4540,4126,4244,4244,4244,
            4244,4244,4546,4545,282
        };
    };
    public final static char termAction[] = TermAction.termAction;
    public final int termAction(int index) { return termAction[index]; }

    public interface Asb {
        public final static char asb[] = {0,
            96,96,274,272,276,275,101,196,503,484,
            86,199,484,234,484,199,199,370,198,372,
            199,391,89,114,199,484,113,92,277,104,
            281,620,372,109,620,372,1,112,474,403,
            501,283,283,281,507,507,507,507,507,507,
            507,507,507,507,507,507,507,507,507,507,
            507,507,507,277,277,239,239,202,202,237,
            237,237,237,237,238,238,107,372,241,245,
            281,247,253,249,258,255,561,561,84,199,
            1,233,378,374,84,372,372,372,372,372,
            372,372,372,372,372,372,372,372,372,372,
            372,372,372,372,117,501,372,281,281,205,
            452,2,292,292,474,474,282,282,381,282,
            282,281,281,281,281,281,281,281,281,281,
            281,383,372,372,277,620,391,281,393,379,
            378,501,561,2,66,2,2,2,2,2,
            2,2,2,2,2,2,2,2,2,2,
            2,2,403,396,281,120,402,402,400,2,
            405,405,2,204,84,234,507,507,507,239,
            238,240,239,239,239,239,239,239,239,239,
            239,239,239,239,372,372,281,245,245,249,
            249,255,253,253,253,561,83,510,561,394,
            281,281,501,229,84,84,408,84,84,84,
            84,84,84,84,84,84,84,84,84,84,
            84,84,84,84,281,281,118,501,281,84,
            281,240,240,84,2,372,372,205,281,205,
            501,281,281,281,281,281,281,281,281,281,
            281,281,279,279,411,84,84,234,403,622,
            510,268,281,84,2,2,405,390,84,269,
            595,84,84,84,84,84,84,84,84,84,
            84,84,618,234,84,281,501,199,391,413,
            413,84,84,240,501,281,501,281,561,280,
            626,620,391,364,391,270,84,270,561,281,
            281,84
        };
    };
    public final static char asb[] = Asb.asb;
    public final int asb(int index) { return asb[index]; }

    public interface Asr {
        public final static byte asr[] = {0,
            107,87,76,54,55,56,57,58,59,60,
            61,62,63,64,65,66,50,51,52,45,
            46,47,48,49,35,36,34,37,38,39,
            40,41,42,44,82,53,77,24,78,4,
            80,81,75,72,73,71,70,68,69,5,
            16,43,25,26,27,28,29,31,32,33,
            74,1,67,79,86,9,22,23,6,10,
            7,11,8,12,13,14,15,21,20,17,
            19,18,3,2,0,89,83,0,89,30,
            0,89,14,10,0,7,11,13,108,0,
            7,90,0,83,30,12,85,0,1,85,
            0,85,30,89,14,0,90,87,86,76,
            54,55,56,57,58,59,60,61,62,63,
            64,65,66,50,51,52,45,46,47,48,
            49,35,36,34,37,38,39,40,41,42,
            22,23,10,7,11,8,12,13,14,21,
            20,17,19,18,44,82,53,77,24,78,
            80,81,75,72,73,71,70,68,69,5,
            16,43,25,26,27,28,29,31,32,33,
            74,1,67,79,100,9,15,6,3,4,
            0,94,91,85,93,43,67,24,25,26,
            27,28,29,16,92,95,96,101,97,98,
            103,104,105,31,32,33,106,1,90,89,
            99,5,88,30,2,0,83,94,1,91,
            97,98,95,96,24,25,43,67,26,27,
            28,29,5,16,31,32,33,93,2,92,
            89,101,103,104,105,99,106,90,30,88,
            0,3,4,99,12,30,83,0,2,102,
            87,86,76,82,77,78,4,80,81,75,
            1,35,36,34,37,38,39,40,41,42,
            9,22,23,6,10,7,11,8,12,13,
            14,15,21,20,17,19,18,44,3,72,
            73,71,70,68,69,5,16,43,24,25,
            26,27,28,29,31,32,33,74,67,79,
            53,54,55,56,57,58,59,60,61,62,
            63,64,65,66,50,51,52,45,46,47,
            48,49,0,89,97,98,95,96,0,3,
            4,1,0,2,88,89,84,30,99,0,
            103,0,5,2,83,90,30,99,85,88,
            89,0,89,93,0,90,30,101,0,84,
            5,30,90,0,92,30,0,2,85,0,
            104,0,93,67,94,95,85,89,96,91,
            97,98,106,76,82,77,24,78,4,80,
            81,75,72,73,71,70,68,69,5,16,
            43,25,26,27,28,29,31,32,33,74,
            1,54,55,56,57,58,59,60,61,62,
            63,64,65,66,50,51,52,45,46,47,
            48,49,53,35,36,34,37,38,39,40,
            41,42,44,9,22,23,6,10,7,11,
            8,12,13,14,15,21,20,17,19,18,
            3,0,3,4,90,0,1,91,0,76,
            77,78,43,67,24,25,26,27,5,28,
            29,16,1,90,44,87,31,32,33,79,
            86,80,81,50,51,52,53,54,55,56,
            57,58,59,60,61,62,63,64,65,68,
            69,70,71,72,73,74,66,82,107,4,
            35,36,34,37,38,39,40,41,42,75,
            45,46,47,48,49,3,9,22,23,6,
            10,7,11,8,12,13,14,15,21,20,
            17,19,18,0,88,85,43,67,24,25,
            26,27,5,28,29,16,1,94,95,96,
            91,97,98,31,32,33,106,2,30,84,
            0,8,3,4,0,105,0
        };
    };
    public final static byte asr[] = Asr.asr;
    public final int asr(int index) { return asr[index]; }

    public interface Nasb {
        public final static byte nasb[] = {0,
            17,78,88,35,88,88,19,112,89,101,
            88,97,101,88,101,35,35,37,115,38,
            40,88,88,88,41,101,88,88,88,88,
            2,88,88,88,88,38,6,88,26,88,
            46,2,2,2,95,95,95,95,95,95,
            95,95,95,95,95,95,95,95,95,95,
            95,95,95,88,88,95,88,88,88,88,
            88,88,88,88,95,95,88,88,32,88,
            2,88,88,88,88,88,100,100,88,121,
            2,88,15,88,88,88,88,88,88,88,
            88,88,88,88,88,88,88,88,88,88,
            88,88,88,88,2,110,88,2,2,88,
            25,2,28,24,26,26,73,73,88,68,
            68,10,10,63,63,63,63,53,58,58,
            58,88,88,88,88,88,88,48,88,88,
            88,46,100,2,101,2,2,2,2,2,
            2,2,2,2,2,2,2,2,2,2,
            2,2,88,88,2,2,88,88,88,2,
            88,88,2,88,88,88,95,95,95,95,
            95,95,88,88,88,88,88,88,88,88,
            88,88,88,88,88,88,2,88,88,88,
            88,88,88,88,88,100,118,103,100,88,
            2,2,46,88,88,88,88,88,88,88,
            88,88,88,88,88,88,88,88,88,88,
            88,88,88,88,2,2,2,107,2,88,
            2,95,95,88,2,88,88,88,2,88,
            46,43,43,43,43,43,43,43,43,43,
            43,43,2,2,88,88,88,88,88,120,
            1,88,2,88,2,2,88,88,88,88,
            88,88,88,88,88,88,88,88,88,88,
            88,88,88,88,88,2,46,122,88,2,
            2,88,88,95,46,2,46,2,100,2,
            88,88,88,32,88,88,88,88,100,2,
            2,88
        };
    };
    public final static byte nasb[] = Nasb.nasb;
    public final int nasb(int index) { return nasb[index]; }

    public interface Nasr {
        public final static char nasr[] = {0,
            117,6,1,4,0,111,112,110,0,6,
            1,4,35,0,92,0,81,0,74,73,
            70,105,0,86,7,5,0,5,7,9,
            0,59,60,0,54,0,52,55,0,56,
            52,0,6,1,4,46,0,6,1,4,
            58,0,6,1,4,39,0,6,1,4,
            37,0,6,1,4,31,0,6,1,4,
            29,0,6,1,4,26,0,120,119,122,
            95,73,74,70,68,93,94,0,97,99,
            98,102,103,0,43,0,47,121,0,4,
            3,0,114,116,113,0,64,46,0,85,
            0,52,104,0,52,75,0,90,0,115,
            76,57,0
        };
    };
    public final static char nasr[] = Nasr.nasr;
    public final int nasr(int index) { return nasr[index]; }

    public interface TerminalIndex {
        public final static char terminalIndex[] = {0,
            12,13,112,32,8,102,104,106,98,103,
            105,107,108,109,110,11,36,37,38,41,
            42,99,101,4,5,6,7,9,10,20,
            47,48,49,87,88,89,90,91,93,94,
            95,96,2,35,62,63,64,65,66,56,
            57,58,59,67,68,69,70,71,72,73,
            74,75,76,77,78,86,3,79,80,81,
            82,83,84,85,92,31,33,34,50,54,
            55,97,14,21,22,52,43,19,23,15,
            26,17,1,16,18,24,27,28,53,113,
            25,29,44,45,46,51,100,111,39,40,
            60,61,114
        };
    };
    public final static char terminalIndex[] = TerminalIndex.terminalIndex;
    public final int terminalIndex(int index) { return terminalIndex[index]; }

    public interface NonterminalIndex {
        public final static char nonterminalIndex[] = {0,
            193,0,117,140,118,115,116,0,138,135,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,133,134,0,131,132,128,
            129,130,0,126,127,124,125,122,123,120,
            121,0,0,139,0,119,187,146,147,0,
            0,160,152,168,174,176,185,186,136,137,
            142,0,144,148,0,0,151,153,157,167,
            169,170,171,173,177,179,180,184,0,0,
            0,0,0,141,143,145,0,0,0,149,
            0,150,154,155,156,158,159,161,162,163,
            164,165,166,172,175,0,0,0,0,0,
            178,0,0,181,182,0,183,188,189,190,
            191,192,0,0,0,0,0,0,0,0,
            0,0
        };
    };
    public final static char nonterminalIndex[] = NonterminalIndex.nonterminalIndex;
    public final int nonterminalIndex(int index) { return nonterminalIndex[index]; }

    public interface ScopePrefix {
        public final static char scopePrefix[] = {
            183,17,211,290,191,5,12,58,63,68,
            73,78,83,88,93,98,103,108,113,118,
            123,128,133,138,143,148,153,158,163,26,
            168,172,231,235,239,243,247,251,255,259,
            263,267,271,275,279,296,44,51,176,217,
            283,51,201,201,287,35,1,224,300,300,
            308,308,316,316,316,316,330,330,338,338,
            338,224
        };
    };
    public final static char scopePrefix[] = ScopePrefix.scopePrefix;
    public final int scopePrefix(int index) { return scopePrefix[index]; }

    public interface ScopeSuffix {
        public final static char scopeSuffix[] = {
            10,24,10,10,197,10,10,10,10,10,
            10,10,10,10,10,10,10,10,10,10,
            10,10,10,10,10,10,10,10,10,31,
            10,10,10,10,10,10,10,10,10,10,
            10,10,10,3,3,10,48,55,180,221,
            55,55,197,205,10,38,3,221,302,305,
            310,313,318,321,324,327,332,335,340,343,
            346,226
        };
    };
    public final static char scopeSuffix[] = ScopeSuffix.scopeSuffix;
    public final int scopeSuffix(int index) { return scopeSuffix[index]; }

    public interface ScopeLhs {
        public final static char scopeLhs[] = {
            88,33,88,10,88,60,60,9,8,8,
            8,8,8,8,8,8,8,8,8,8,
            8,8,8,8,8,8,8,63,63,33,
            50,51,87,87,87,87,87,87,87,87,
            87,87,87,16,15,10,27,65,46,48,
            12,12,88,88,11,33,68,48,29,29,
            31,31,35,35,35,35,37,37,39,39,
            39,48
        };
    };
    public final static char scopeLhs[] = ScopeLhs.scopeLhs;
    public final int scopeLhs(int index) { return scopeLhs[index]; }

    public interface ScopeLa {
        public final static byte scopeLa[] = {
            2,105,2,2,88,2,2,2,2,2,
            2,2,2,2,2,2,2,2,2,2,
            2,2,2,2,2,2,2,2,2,104,
            2,2,2,2,2,2,2,2,2,2,
            2,2,2,90,90,2,99,92,5,88,
            92,92,88,89,2,103,90,88,25,24,
            67,43,29,28,27,26,16,5,33,32,
            31,30
        };
    };
    public final static byte scopeLa[] = ScopeLa.scopeLa;
    public final int scopeLa(int index) { return scopeLa[index]; }

    public interface ScopeStateSet {
        public final static byte scopeStateSet[] = {
            2,48,2,39,2,12,12,38,37,37,
            37,37,37,37,37,37,37,37,37,37,
            37,37,37,37,37,37,37,1,1,48,
            4,4,2,2,2,2,2,2,2,2,
            2,2,2,39,39,39,44,1,15,110,
            39,39,2,2,39,48,122,110,46,46,
            48,48,52,52,52,52,54,54,57,57,
            57,110
        };
    };
    public final static byte scopeStateSet[] = ScopeStateSet.scopeStateSet;
    public final int scopeStateSet(int index) { return scopeStateSet[index]; }

    public interface ScopeRhs {
        public final static char scopeRhs[] = {0,
            187,0,15,0,179,1,118,98,0,13,
            0,179,1,118,97,0,153,104,153,103,
            153,87,0,46,0,153,103,153,87,0,
            45,120,46,0,153,87,0,44,120,45,
            120,46,0,204,159,86,0,53,120,0,
            157,94,118,0,17,0,0,158,1,156,
            120,0,158,1,156,33,0,158,1,156,
            32,0,158,1,156,31,0,158,1,156,
            29,0,158,1,156,28,0,158,1,156,
            27,0,158,1,156,26,0,158,1,156,
            25,0,158,1,156,24,0,158,1,156,
            43,0,158,1,156,16,0,158,1,156,
            5,0,158,1,156,69,0,158,1,156,
            68,0,158,1,156,70,0,158,1,156,
            71,0,158,1,156,73,0,158,1,156,
            72,0,158,1,156,118,0,158,1,156,
            79,0,158,1,156,67,0,202,1,75,
            0,162,1,117,0,162,84,3,0,8,
            120,0,153,88,159,89,159,1,54,0,
            159,89,159,1,54,0,19,120,13,0,
            159,1,54,0,23,119,19,120,13,0,
            153,88,159,1,54,0,159,30,159,0,
            19,120,0,159,0,20,119,19,120,0,
            161,1,65,0,161,1,64,0,161,1,
            63,0,161,1,62,0,161,1,61,0,
            161,1,60,0,161,1,58,0,161,1,
            59,0,161,1,57,0,161,1,56,0,
            161,1,55,0,198,83,75,0,196,83,
            117,0,157,94,119,0,153,1,0,158,
            1,118,85,116,0,158,1,76,0,141,
            0,5,134,0,4,134,0,145,0,3,
            132,0,2,132,0,147,0,10,129,0,
            9,129,0,7,129,0,6,129,0,149,
            0,11,127,0,8,127,0,151,0,49,
            125,0,48,125,0,47,125,0
        };
    };
    public final static char scopeRhs[] = ScopeRhs.scopeRhs;
    public final int scopeRhs(int index) { return scopeRhs[index]; }

    public interface ScopeState {
        public final static char scopeState[] = {0,
            613,524,0,4126,4059,4054,4049,4036,4031,4026,
            0,692,624,0,1314,1222,1130,2330,2281,2232,
            2183,2134,2085,2036,1987,1938,1889,1840,1038,4070,
            946,4101,854,4071,762,0,524,613,3995,3970,
            3944,3918,3892,3864,3836,3806,3776,3742,3708,3674,
            3640,3604,426,3566,3528,3490,3407,3364,2665,3321,
            3278,3235,2425,2379,3192,345,697,629,2620,1794,
            3149,3106,1731,3063,3020,2977,2934,2891,1685,1639,
            2848,1593,1547,1501,1455,1409,1363,1317,1271,1225,
            1179,1133,1087,1041,995,949,903,857,811,2561,
            3450,765,2516,2471,544,463,2805,2762,2719,2330,
            2281,2232,2183,2134,2085,2036,1987,1938,1889,1840,
            0,520,4020,0
        };
    };
    public final static char scopeState[] = ScopeState.scopeState;
    public final int scopeState(int index) { return scopeState[index]; }

    public interface InSymb {
        public final static char inSymb[] = {0,
            0,194,183,7,185,184,187,186,208,13,
            235,232,11,233,99,30,12,15,9,165,
            6,209,216,214,215,211,212,210,182,116,
            83,160,231,116,2,165,1,116,85,153,
            86,79,67,1,120,74,33,32,31,29,
            28,27,26,25,43,16,5,69,68,70,
            71,73,72,117,75,24,53,114,3,49,
            48,47,46,45,119,118,116,76,123,141,
            87,145,149,147,154,151,84,84,219,223,
            225,224,159,3,153,156,156,156,156,156,
            156,156,156,156,156,156,156,156,156,156,
            156,156,156,156,83,83,156,94,94,156,
            85,1,96,95,98,97,25,24,153,67,
            43,16,5,29,28,27,26,106,33,32,
            31,116,117,75,2,170,190,107,153,204,
            205,30,84,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,196,153,100,67,197,198,3,1,
            157,157,1,118,158,157,79,67,24,120,
            118,120,54,65,64,63,62,61,60,58,
            59,57,56,55,118,118,103,141,141,147,
            147,151,149,149,149,1,1,83,84,153,
            93,99,30,162,158,195,116,158,158,158,
            158,158,158,158,158,158,158,158,158,158,
            158,158,158,158,101,100,30,30,5,158,
            30,92,92,158,1,156,156,156,94,156,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,153,162,202,203,220,226,
            229,227,5,158,1,1,157,159,161,159,
            3,161,161,161,161,161,161,161,161,161,
            161,179,102,180,179,104,30,8,190,23,
            22,158,158,92,89,88,30,88,84,30,
            153,170,191,123,191,159,153,159,84,88,
            88,153
        };
    };
    public final static char inSymb[] = InSymb.inSymb;
    public final int inSymb(int index) { return inSymb[index]; }

    public interface Name {
        public final static String name[] = {
            "",
            ":=",
            "+",
            "-",
            "*",
            "/",
            ">",
            "<",
            "=",
            ">=",
            "<=",
            "<>",
            "(",
            ")",
            "{",
            "}",
            "[",
            "]",
            "->",
            "|",
            ",",
            ":",
            "::",
            ";",
            ".",
            "..",
            "@pre",
            "^",
            "^^",
            "?",
            "$empty",
            "NUMERIC_OPERATION",
            "STRING_LITERAL",
            "INTEGER_LITERAL",
            "REAL_LITERAL",
            "self",
            "inv",
            "pre",
            "post",
            "context",
            "package",
            "endpackage",
            "def",
            "if",
            "then",
            "else",
            "endif",
            "and",
            "or",
            "xor",
            "not",
            "implies",
            "let",
            "in",
            "true",
            "false",
            "body",
            "derive",
            "init",
            "null",
            "attr",
            "oper",
            "Set",
            "Bag",
            "Sequence",
            "Collection",
            "OrderedSet",
            "iterate",
            "forAll",
            "exists",
            "isUnique",
            "any",
            "one",
            "collect",
            "select",
            "reject",
            "collectNested",
            "sortedBy",
            "closure",
            "oclIsKindOf",
            "oclIsTypeOf",
            "oclAsType",
            "oclIsNew",
            "oclIsUndefined",
            "oclIsInvalid",
            "oclIsInState",
            "allInstances",
            "String",
            "Integer",
            "UnlimitedNatural",
            "Real",
            "Boolean",
            "Tuple",
            "OclAny",
            "OclVoid",
            "Invalid",
            "OclMessage",
            "OclInvalid",
            "check",
            "creation",
            "default",
            "deletion",
            "enforce",
            "imports",
            "map",
            "query",
            "realize",
            "refines",
            "transformation",
            "uses",
            "where",
            "EOF_TOKEN",
            "IDENTIFIER",
            "INTEGER_RANGE_START",
            "ERROR_TOKEN",
            "keywordAsIdentifier1",
            "keywordAsIdentifier",
            "pathNameCS",
            "simpleNameCS",
            "variableCS",
            "oclExpressionCS",
            "impliesExpCS",
            "andOrXorExpCS",
            "andOrXorWithLet",
            "equalityExpCS",
            "equalityWithLet",
            "relationalExpCS",
            "relationalWithLet",
            "ifExpCSPrec",
            "additiveWithLet",
            "additiveExpCS",
            "multiplicativeExpCS",
            "multiplicativeWithLet",
            "unaryExpCS",
            "unaryWithLet",
            "dotArrowExpCS",
            "callExpCS",
            "messageExpCS",
            "keywordOperationCallExpCS",
            "argumentsCS",
            "collectionTypeIdentifierCS",
            "collectionLiteralPartsCS",
            "collectionLiteralPartCS",
            "variableListCS2",
            "featureCallExpCS",
            "loopExpCS",
            "iterContents",
            "typeCS",
            "variableCS2",
            "variableListCS",
            "letExpSubCS",
            "oclMessageArgumentsCS",
            "oclMessageArgCS",
            "MappingCS",
            "TransformationCS",
            "QueryCS",
            "TransformationCS_0_",
            "TransformationNameCS",
            "DirectionCS",
            "DirectionCS_0_",
            "DirectionNameCS",
            "DirectionCS_1_",
            "DirectionCS_2_",
            "PackageNameCS",
            "DirectionCS_3_",
            "DirectionCS_4_",
            "DirectionCS_5_",
            "MappingCS_1_",
            "MappingNameCS",
            "MappingCS_2_",
            "MappingCS_3_",
            "MappingCS_4_",
            "DomainCS",
            "MappingCS_8",
            "DomainCS_0_",
            "ComposedMappingCS",
            "DomainCS_1_",
            "DomainCS_2_",
            "GuardPatternCS_1_",
            "UnrealizedVariableCS",
            "ConstraintCS",
            "BottomPatternCS_1_",
            "RealizedVariableCS",
            "EnforcementOperationCS",
            "EnforcementOperationCS_1_",
            "VariableNameCS",
            "AssignmentCS_0_",
            "identifierCS",
            "QueryNameCS",
            "QueryCS_preParamDeclaration",
            "QueryCS_postParamDeclaration",
            "paramDeclarationCS",
            "QueryCS_postType",
            "coreIdentifier"
        };
    };
    public final static String name[] = Name.name;
    public final String name(int index) { return name[index]; }

    public final static int
           ERROR_SYMBOL      = 113,
           SCOPE_UBOUND      = 71,
           SCOPE_SIZE        = 72,
           MAX_NAME_LENGTH   = 28;

    public final int getErrorSymbol() { return ERROR_SYMBOL; }
    public final int getScopeUbound() { return SCOPE_UBOUND; }
    public final int getScopeSize() { return SCOPE_SIZE; }
    public final int getMaxNameLength() { return MAX_NAME_LENGTH; }

    public final static int
           NUM_STATES        = 332,
           NT_OFFSET         = 113,
           LA_STATE_OFFSET   = 4588,
           MAX_LA            = 2,
           NUM_RULES         = 344,
           NUM_NONTERMINALS  = 132,
           NUM_SYMBOLS       = 245,
           SEGMENT_SIZE      = 8192,
           START_STATE       = 517,
           IDENTIFIER_SYMBOL = 3,
           EOFT_SYMBOL       = 108,
           EOLT_SYMBOL       = 108,
           ACCEPT_ACTION     = 4243,
           ERROR_ACTION      = 4244;

    public final static boolean BACKTRACK = false;

    public final int getNumStates() { return NUM_STATES; }
    public final int getNtOffset() { return NT_OFFSET; }
    public final int getLaStateOffset() { return LA_STATE_OFFSET; }
    public final int getMaxLa() { return MAX_LA; }
    public final int getNumRules() { return NUM_RULES; }
    public final int getNumNonterminals() { return NUM_NONTERMINALS; }
    public final int getNumSymbols() { return NUM_SYMBOLS; }
    public final int getSegmentSize() { return SEGMENT_SIZE; }
    public final int getStartState() { return START_STATE; }
    public final int getStartSymbol() { return lhs[0]; }
    public final int getIdentifierSymbol() { return IDENTIFIER_SYMBOL; }
    public final int getEoftSymbol() { return EOFT_SYMBOL; }
    public final int getEoltSymbol() { return EOLT_SYMBOL; }
    public final int getAcceptAction() { return ACCEPT_ACTION; }
    public final int getErrorAction() { return ERROR_ACTION; }
    public final boolean isValidForParser() { return isValidForParser; }
    public final boolean getBacktrack() { return BACKTRACK; }

    public final int originalState(int state) {
        return -baseCheck[state];
    }
    public final int asi(int state) {
        return asb[originalState(state)];
    }
    public final int nasi(int state) {
        return nasb[originalState(state)];
    }
    public final int inSymbol(int state) {
        return inSymb[originalState(state)];
    }

    public final int ntAction(int state, int sym) {
        return baseAction[state + sym];
    }

    public final int tAction(int state, int sym) {
        int i = baseAction[state],
            k = i + sym;
        return termAction[termCheck[k] == sym ? k : i];
    }
    public final int lookAhead(int la_state, int sym) {
        int k = la_state + sym;
        return termAction[termCheck[k] == sym ? k : la_state];
    }
}
