/*******************************************************************************
 * Copyright (c) 2007 E.D.Willink and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     E.D.Willink - initial API and implementation
 *******************************************************************************/
package org.eclipse.gmt.umlx.eqvtc.editor;

import org.eclipse.gmt.umlx.editor.wizards.PagedNewWizardPage;
import org.eclipse.gmt.umlx.qvt.ui.preferences.QVTPreferences;
import org.eclipse.jface.viewers.ISelection;

/**
 * The "New" wizard page allows setting the container for the new file as well
 * as the file name. The page will only accept file name without the extension
 * OR with the extension that matches the expected one (qvtc).
 */
public class QVTcNewWizardPage extends PagedNewWizardPage
{
	public QVTcNewWizardPage(ISelection selection) {
		super(selection);
	}

	@Override protected String getFileExtension() {
		return QVTPreferences.getCoreTextExtension();
	}

	@Override protected String[] getFileExtensions() {
		return QVTPreferences.getCoreTextExtensions();
	}
}