/*******************************************************************************
 * Copyright (c) 2007 E.D.Willink and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     E.D.Willink - initial API and implementation
 *******************************************************************************/
package org.eclipse.gmt.umlx.eqvtc.editor;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.gmt.umlx.editor.text.TextColorManager;
import org.eclipse.gmt.umlx.editor.text.TextDefaultContentScanner;
import org.eclipse.jface.text.rules.IRule;
import org.eclipse.jface.text.rules.MultiLineRule;

/**
 * Defines a scanner to process the residual NiceXSL partition.
 */
public class QVTcTextDefaultContentScanner extends TextDefaultContentScanner {
    public QVTcTextDefaultContentScanner(TextColorManager colorManager) {
    	super(colorManager);
    	List<IRule> rules = new ArrayList<IRule>();
    	for (IRule rule : fRules)
    		rules.add(rule);
        rules.add(new MultiLineRule("/*", "*/", colorManager.getMultiLineCommentToken()));
        rules.add(new QVTcTextKeywordRule(colorManager, colorManager.getDefaultContextToken()));
    	IRule[] result = new IRule[rules.size()];
    	rules.toArray(result);
    	setRules(result);
    }
}
