/*******************************************************************************
 * Copyright (c) 2007 E.D.Willink and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     E.D.Willink - initial API and implementation
 *******************************************************************************/
package org.eclipse.gmt.umlx.eqvtc.editor;

import org.eclipse.gmt.umlx.editor.text.EssentialOCLTextKeywordRule;
import org.eclipse.gmt.umlx.editor.text.TextColorManager;
import org.eclipse.jface.text.rules.IToken;

/**
 * Defines a rule to recognise the QVT keywords.
 */
public class QVTcTextKeywordRule extends EssentialOCLTextKeywordRule {

    public QVTcTextKeywordRule(TextColorManager colorManager, IToken defaultToken) {
    	super(colorManager, defaultToken);
        IToken token = colorManager.getKeywordToken();
        addWord("check", token);
        addWord("creation", token);
        addWord("default", token);
        addWord("deletion", token);
        addWord("enforce", token);
        addWord("imports", token);
        addWord("map", token);
        addWord("query", token);
        addWord("realize", token);
        addWord("refines", token);
        addWord("transformation", token);
        addWord("uses", token);
        addWord("where", token);
    }
}
