/*******************************************************************************
 * Copyright (c) 2007 E.D.Willink and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     E.D.Willink - initial API and implementation
 *******************************************************************************/
package org.eclipse.gmt.umlx.eqvtr.cst;

import org.eclipse.emf.common.util.EList;
import org.eclipse.gmt.umlx.eqvt.cst.IdentifierCS;
import org.eclipse.ocl.cst.CSTNode;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Model Decl CS</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.gmt.umlx.eqvtr.cst.ModelDeclCS#getModelId <em>Model Id</em>}</li>
 *   <li>{@link org.eclipse.gmt.umlx.eqvtr.cst.ModelDeclCS#getMetaModelId <em>Meta Model Id</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.gmt.umlx.eqvtr.cst.EqvtrCSTPackage#getModelDeclCS()
 * @model
 * @generated
 */
public interface ModelDeclCS extends CSTNode {
	/**
	 * Returns the value of the '<em><b>Model Id</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Model Id</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Model Id</em>' containment reference.
	 * @see #setModelId(IdentifierCS)
	 * @see org.eclipse.gmt.umlx.eqvtr.cst.EqvtrCSTPackage#getModelDeclCS_ModelId()
	 * @model containment="true"
	 * @generated
	 */
	IdentifierCS getModelId();

	/**
	 * Sets the value of the '{@link org.eclipse.gmt.umlx.eqvtr.cst.ModelDeclCS#getModelId <em>Model Id</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Model Id</em>' containment reference.
	 * @see #getModelId()
	 * @generated
	 */
	void setModelId(IdentifierCS value);

	/**
	 * Returns the value of the '<em><b>Meta Model Id</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.gmt.umlx.eqvt.cst.IdentifierCS}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Meta Model Id</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Meta Model Id</em>' containment reference list.
	 * @see org.eclipse.gmt.umlx.eqvtr.cst.EqvtrCSTPackage#getModelDeclCS_MetaModelId()
	 * @model containment="true"
	 * @generated
	 */
	EList<IdentifierCS> getMetaModelId();

} // ModelDeclCS
