/*******************************************************************************
 * Copyright (c) 2007 E.D.Willink and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     E.D.Willink - initial API and implementation
 *******************************************************************************/
package org.eclipse.gmt.umlx.eqvtr.cst;

import org.eclipse.emf.common.util.EList;
import org.eclipse.gmt.umlx.eqvt.cst.IdentifierCS;
import org.eclipse.ocl.cst.CSTNode;
import org.eclipse.ocl.cst.OCLExpressionCS;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Relation CS</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.gmt.umlx.eqvtr.cst.RelationCS#isTop <em>Top</em>}</li>
 *   <li>{@link org.eclipse.gmt.umlx.eqvtr.cst.RelationCS#getIdentifier <em>Identifier</em>}</li>
 *   <li>{@link org.eclipse.gmt.umlx.eqvtr.cst.RelationCS#getOverrides <em>Overrides</em>}</li>
 *   <li>{@link org.eclipse.gmt.umlx.eqvtr.cst.RelationCS#getVarDeclaration <em>Var Declaration</em>}</li>
 *   <li>{@link org.eclipse.gmt.umlx.eqvtr.cst.RelationCS#getDomain <em>Domain</em>}</li>
 *   <li>{@link org.eclipse.gmt.umlx.eqvtr.cst.RelationCS#getWhen <em>When</em>}</li>
 *   <li>{@link org.eclipse.gmt.umlx.eqvtr.cst.RelationCS#getWhere <em>Where</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.gmt.umlx.eqvtr.cst.EqvtrCSTPackage#getRelationCS()
 * @model
 * @generated
 */
public interface RelationCS extends CSTNode {
	/**
	 * Returns the value of the '<em><b>Top</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Top</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Top</em>' attribute.
	 * @see #setTop(boolean)
	 * @see org.eclipse.gmt.umlx.eqvtr.cst.EqvtrCSTPackage#getRelationCS_Top()
	 * @model
	 * @generated
	 */
	boolean isTop();

	/**
	 * Sets the value of the '{@link org.eclipse.gmt.umlx.eqvtr.cst.RelationCS#isTop <em>Top</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Top</em>' attribute.
	 * @see #isTop()
	 * @generated
	 */
	void setTop(boolean value);

	/**
	 * Returns the value of the '<em><b>Identifier</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Identifier</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Identifier</em>' containment reference.
	 * @see #setIdentifier(IdentifierCS)
	 * @see org.eclipse.gmt.umlx.eqvtr.cst.EqvtrCSTPackage#getRelationCS_Identifier()
	 * @model containment="true"
	 * @generated
	 */
	IdentifierCS getIdentifier();

	/**
	 * Sets the value of the '{@link org.eclipse.gmt.umlx.eqvtr.cst.RelationCS#getIdentifier <em>Identifier</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Identifier</em>' containment reference.
	 * @see #getIdentifier()
	 * @generated
	 */
	void setIdentifier(IdentifierCS value);

	/**
	 * Returns the value of the '<em><b>Overrides</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Overrides</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Overrides</em>' containment reference.
	 * @see #setOverrides(IdentifierCS)
	 * @see org.eclipse.gmt.umlx.eqvtr.cst.EqvtrCSTPackage#getRelationCS_Overrides()
	 * @model containment="true"
	 * @generated
	 */
	IdentifierCS getOverrides();

	/**
	 * Sets the value of the '{@link org.eclipse.gmt.umlx.eqvtr.cst.RelationCS#getOverrides <em>Overrides</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Overrides</em>' containment reference.
	 * @see #getOverrides()
	 * @generated
	 */
	void setOverrides(IdentifierCS value);

	/**
	 * Returns the value of the '<em><b>Var Declaration</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.gmt.umlx.eqvtr.cst.VarDeclarationCS}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Var Declaration</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Var Declaration</em>' containment reference list.
	 * @see org.eclipse.gmt.umlx.eqvtr.cst.EqvtrCSTPackage#getRelationCS_VarDeclaration()
	 * @model containment="true"
	 * @generated
	 */
	EList<VarDeclarationCS> getVarDeclaration();

	/**
	 * Returns the value of the '<em><b>Domain</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.gmt.umlx.eqvtr.cst.AbstractDomainCS}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Domain</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Domain</em>' containment reference list.
	 * @see org.eclipse.gmt.umlx.eqvtr.cst.EqvtrCSTPackage#getRelationCS_Domain()
	 * @model containment="true"
	 * @generated
	 */
	EList<AbstractDomainCS> getDomain();

	/**
	 * Returns the value of the '<em><b>When</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.ocl.cst.OCLExpressionCS}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>When</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>When</em>' containment reference list.
	 * @see org.eclipse.gmt.umlx.eqvtr.cst.EqvtrCSTPackage#getRelationCS_When()
	 * @model containment="true"
	 * @generated
	 */
	EList<OCLExpressionCS> getWhen();

	/**
	 * Returns the value of the '<em><b>Where</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.ocl.cst.OCLExpressionCS}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Where</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Where</em>' containment reference list.
	 * @see org.eclipse.gmt.umlx.eqvtr.cst.EqvtrCSTPackage#getRelationCS_Where()
	 * @model containment="true"
	 * @generated
	 */
	EList<OCLExpressionCS> getWhere();

} // RelationCS
