/*******************************************************************************
 * Copyright (c) 2007 E.D.Willink and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     E.D.Willink - initial API and implementation
 *******************************************************************************/
package org.eclipse.gmt.umlx.eqvtr.cst;

import org.eclipse.emf.common.util.EList;
import org.eclipse.ocl.cst.CSTNode;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Top Level CS</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.gmt.umlx.eqvtr.cst.TopLevelCS#getImportClause <em>Import Clause</em>}</li>
 *   <li>{@link org.eclipse.gmt.umlx.eqvtr.cst.TopLevelCS#getTransformation <em>Transformation</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.gmt.umlx.eqvtr.cst.EqvtrCSTPackage#getTopLevelCS()
 * @model
 * @generated
 */
public interface TopLevelCS extends CSTNode {
	/**
	 * Returns the value of the '<em><b>Import Clause</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.gmt.umlx.eqvtr.cst.UnitCS}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Import Clause</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Import Clause</em>' containment reference list.
	 * @see org.eclipse.gmt.umlx.eqvtr.cst.EqvtrCSTPackage#getTopLevelCS_ImportClause()
	 * @model containment="true"
	 * @generated
	 */
	EList<UnitCS> getImportClause();

	/**
	 * Returns the value of the '<em><b>Transformation</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.gmt.umlx.eqvtr.cst.TransformationCS}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Transformation</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Transformation</em>' containment reference list.
	 * @see org.eclipse.gmt.umlx.eqvtr.cst.EqvtrCSTPackage#getTopLevelCS_Transformation()
	 * @model containment="true"
	 * @generated
	 */
	EList<TransformationCS> getTransformation();

} // TopLevelCS
