/**
* <copyright>
*
* Copyright (c) 2005, 2008 IBM Corporation and others.
* All rights reserved.   This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*   IBM - Initial API and implementation
*   E.D.Willink - Elimination of some shift-reduce conflicts
*   E.D.Willink - Remove unnecessary warning suppression
*   E.D.Willink - Extended API and implementation for QVTr
*
* </copyright>
*
* $Id: QVTrParserprs.java,v 1.6 2008/04/05 18:03:04 ewillink Exp $
*/

package org.eclipse.gmt.umlx.eqvtr.cst.parser;

public class QVTrParserprs implements lpg.lpgjavaruntime.ParseTable, QVTrParsersym {

    public interface IsKeyword {
        public final static byte isKeyword[] = {0,
            0,0,0,1,0,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,0,0,1,0,
            0,0,0,0,0,0,0,1,1,1,
            1,1,1,1,1,1,1,1,1,0,
            1,1,1,1,1,0,0,0,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,0,0,0,0,1,1,
            1,0,1,1,0,0,0,0,0,0,
            0,0,0,0,0,1,1,1,1,1,
            0,0,0,0,0,0,0
        };
    };
    public final static byte isKeyword[] = IsKeyword.isKeyword;
    public final boolean isKeyword(int index) { return isKeyword[index] != 0; }

    public interface BaseCheck {
        public final static short baseCheck[] = {0,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,6,8,0,1,1,
            3,0,1,1,1,1,1,3,3,1,
            1,3,3,3,3,3,3,1,1,3,
            3,3,3,1,1,3,3,3,3,3,
            3,3,3,1,1,1,1,3,3,3,
            3,1,1,3,3,3,3,1,1,2,
            2,1,2,2,4,6,1,1,1,1,
            3,2,2,5,5,1,1,1,1,1,
            1,1,1,1,1,1,1,1,3,0,
            1,1,1,1,1,1,1,3,3,4,
            1,1,1,1,1,0,1,1,3,1,
            1,3,2,3,1,1,1,1,1,4,
            1,1,1,1,1,1,1,1,2,2,
            2,2,1,1,4,4,4,4,4,4,
            4,4,4,4,4,1,3,5,6,8,
            1,3,5,3,0,1,1,1,1,1,
            4,4,0,1,1,3,1,1,3,3,
            1,1,5,5,5,5,5,5,5,5,
            5,5,5,5,5,5,5,5,5,5,
            5,5,5,5,5,2,2,5,0,1,
            0,1,1,3,5,0,1,2,3,7,
            5,5,0,1,1,3,1,1,3,0,
            4,1,2,1,3,4,3,2,1,3,
            2,2,1,2,2,2,2,2,2,2,
            2,2,1,1,3,2,2,3,1,1,
            2,1,2,1,3,2,2,1,1,2,
            2,3,3,1,2,3,3,1,2,2,
            1,3,4,3,1,2,2,2,1,3,
            3,2,1,2,2,6,1,1,1,4,
            4,4,4,3,1,2,2,2,2,3,
            2,3,3,3,2,1,2,2,4,2,
            1,1,4,3,2,2,4,2,4,3,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,-153,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-162,0,-3,0,-4,0,0,0,
            -201,0,0,-5,0,0,-16,0,0,-91,
            -164,0,-7,0,-12,0,0,0,0,0,
            -14,-17,0,0,-325,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-18,
            0,-185,0,0,0,-20,0,-21,0,0,
            0,0,-25,-104,0,0,0,-326,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-119,0,-28,0,-29,0,0,-166,
            0,0,0,-32,0,-33,-6,0,0,0,
            -163,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-200,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-52,0,0,-202,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-203,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-198,0,0,-204,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-205,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-275,
            0,0,-206,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-207,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-313,0,0,-208,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-209,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-358,0,0,
            -210,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-211,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-362,0,0,-212,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-213,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-364,0,0,-214,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-215,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-36,
            0,0,-216,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-39,0,0,-217,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-40,0,0,-218,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -41,0,0,-226,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-42,0,0,
            -232,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-105,0,0,-299,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-167,0,-44,0,-45,0,0,-46,-49,
            -50,-13,0,0,0,-307,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-314,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-106,-51,-75,0,
            -22,0,0,-315,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-107,0,0,
            0,-100,0,0,-316,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-76,0,
            0,0,-116,0,0,-317,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-78,
            0,-79,0,-124,0,0,-318,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -80,0,-81,0,-184,0,0,-319,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-82,0,-83,0,-189,0,0,-320,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-84,0,-85,0,-86,-89,0,-321,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-90,-92,-94,0,-95,-96,0,
            -322,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-97,-98,-99,0,-101,-102,
            0,-323,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-103,-109,-110,0,-111,
            -112,0,-324,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-113,-114,-115,0,
            -117,-121,0,-335,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-122,0,0,
            -336,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-123,0,0,-159,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-125,0,-160,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-126,0,-311,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-127,0,-368,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-130,
            -131,-132,-133,-134,-135,-136,-137,-138,-139,0,
            -19,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-27,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-38,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-55,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-93,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -128,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-194,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-221,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-256,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-270,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -274,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-297,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-298,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-301,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-303,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -333,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-356,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,-363,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-365,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-375,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            -376,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,-179,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,-140,-141,-142,-143,-144,-145,-146,-147,
            -148,-149,-150,0,0,-180,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-181,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-182,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-173,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-174,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-175,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-176,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-177,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-178,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-171,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-172,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-168,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-169,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,-53,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,-54,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-222,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-8,-56,-151,-43,0,-165,0,-23,0,
            -152,0,0,0,0,-155,-47,0,0,-26,
            0,-154,-161,-11,0,-186,0,-37,0,-57,
            -156,0,0,-170,0,-187,-188,-30,0,0,
            -190,-191,0,0,0,0,0,0,0,0,
            0,0,0,-157,0,0,0,0,-192,-300,
            -195,-58,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,-196,0,-2,
            0,0,0,0,-197,0,-9,0,0,0,
            0,-219,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,-220,0,-223,0,
            0,0,0,0,0,0,0,0,0,0,
            0,-118,0,0,0,0,-24,0,0,0,
            0,0,0,0,0,-120,0,0,0,0,
            0,0,0,0,0,-183,0,0,0,0,
            -193,0,0,0,0,-199,0,0,0,0,
            -330,0,0,0,0,-366,0,0,0,0,
            -367,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,-48,0,0,-158,0,
            0,0,0,0,0,-272,0,0,-10,0,
            -15,0,-31,0,0,-59,0,0,-1,0,
            -60,0,0,-129,0,-61,0,0,-62,0,
            -63,0,0,-64,0,-65,0,0,-66,0,
            -67,0,0,-34,0,-68,-69,0,-35,0,
            -108,0,-224,0,-225,-70,0,0,-227,-71,
            -72,-228,0,-73,-74,-77,0,-229,0,0,
            0,-230,-87,0,0,-88,-236,-237,-238,0,
            -239,-240,0,-241,0,-266,-231,0,-304,0,
            0,-305,0,-361,0,0,0,-233,0,0,
            0,0,-234,0,-235,-242,0,-243,0,0,
            -244,-245,0,0,0,0,0,0,0,0,
            0,0,-246,-247,-248,0,0,-249,-250,0,
            0,0,0,-251,0,0,-252,0,-253,0,
            0,-254,0,-255,-257,0,-258,0,-259,-260,
            -261,-262,-263,-264,-265,-267,-268,-269,-271,-273,
            -276,-277,-278,-279,-280,-281,-282,-283,-284,-285,
            -286,-287,-288,-289,0,-290,-291,-292,-293,-294,
            -295,-296,-302,-306,-308,-309,-310,-312,-327,-328,
            -329,-331,-332,-334,-337,-338,-339,-340,-341,-342,
            -343,-344,-345,-346,-347,-348,-349,-350,-351,-352,
            -353,-354,-355,-357,-359,-360,-369,-370,-371,-372,
            -373,-374,-377,0
        };
    };
    public final static short baseCheck[] = BaseCheck.baseCheck;
    public final int baseCheck(int index) { return baseCheck[index]; }
    public final static short rhs[] = baseCheck;
    public final int rhs(int index) { return rhs[index]; };

    public interface BaseAction {
        public final static char baseAction[] = {
            80,6,6,6,6,6,6,6,6,6,
            6,6,6,6,6,6,6,6,6,6,
            6,6,7,7,133,133,134,135,136,136,
            138,138,139,139,51,51,52,53,52,53,
            49,50,49,49,49,50,50,50,36,37,
            36,37,36,37,34,35,34,35,34,35,
            34,35,34,35,30,30,32,31,32,31,
            32,31,28,29,28,29,28,29,10,26,
            10,10,11,11,11,11,11,12,12,12,
            12,12,13,13,13,13,5,5,5,3,
            3,3,3,3,3,3,3,3,2,2,
            83,83,14,14,14,14,14,14,15,15,
            16,4,4,4,4,4,84,84,85,85,
            66,66,67,67,67,18,18,18,18,18,
            17,21,22,23,24,25,25,19,20,81,
            81,81,81,87,87,88,88,88,88,88,
            88,88,88,88,88,88,60,60,60,89,
            89,57,57,57,69,137,137,61,61,61,
            61,59,62,90,90,91,91,86,86,86,
            86,68,68,68,68,8,8,8,8,8,
            8,8,8,8,8,8,8,8,8,8,
            8,8,8,8,9,8,70,70,70,54,
            54,56,56,55,55,27,92,92,93,93,
            33,82,82,71,71,72,72,64,64,64,
            94,94,80,80,95,95,97,97,98,99,
            99,100,100,102,102,102,96,74,75,75,
            76,73,73,65,77,105,105,107,101,106,
            78,79,108,108,109,109,110,110,112,112,
            113,113,116,116,117,117,118,118,119,119,
            104,120,120,111,63,121,121,121,121,122,
            122,123,123,125,125,114,115,39,39,38,
            38,42,42,42,42,43,43,44,40,40,
            126,45,45,45,45,46,47,47,48,41,
            41,127,127,124,128,128,129,131,103,103,
            130,51,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,2,5,58,58,58,191,
            2162,2348,96,1979,4906,4903,4643,89,90,72,
            440,82,87,88,112,113,114,115,116,117,
            135,136,137,138,139,73,79,2405,67,54,
            55,2406,65,2409,49,2408,41,341,1978,307,
            308,1861,4826,1860,1854,1856,4645,1859,2466,37,
            4747,2465,35,1424,365,1560,96,29,4928,22,
            118,1977,364,4994,1452,128,130,1950,364,1624,
            384,1256,365,1575,96,346,4912,22,4911,192,
            151,1192,1615,4732,4749,387,2162,2348,96,1979,
            4906,4903,4643,89,90,72,440,82,87,88,
            112,113,114,115,116,117,135,136,137,138,
            139,73,79,2405,67,54,55,2406,65,2409,
            49,2408,41,341,1978,307,308,1861,4826,1860,
            1854,1856,4645,1859,2466,37,237,2465,35,152,
            1499,191,1503,365,4993,96,1712,4916,1680,235,
            300,83,84,124,1896,367,5040,5042,387,2162,
            2348,96,1979,4906,4903,4643,89,90,72,440,
            82,87,88,112,113,114,115,116,117,135,
            136,137,138,139,73,79,2405,67,54,55,
            2406,65,2409,49,2408,41,341,1978,307,308,
            1861,4826,1860,1854,1856,4645,1859,2466,37,237,
            2465,35,263,1641,365,479,96,1286,109,4666,
            1641,365,235,96,1621,4972,1313,1896,367,5043,
            5042,688,2162,2348,96,1979,4906,4903,4643,89,
            90,72,440,82,87,88,112,113,114,115,
            116,117,135,136,137,138,139,73,79,2405,
            67,54,55,2406,65,2409,49,2408,41,341,
            1978,307,308,1861,4826,1860,1854,1856,4645,1859,
            2466,37,223,2465,35,445,4935,4933,688,2162,
            2348,96,1979,4906,4903,4643,89,90,72,440,
            82,87,88,112,113,114,115,116,117,135,
            136,137,138,139,73,79,2405,67,54,55,
            2406,65,2409,49,2408,41,341,1978,307,308,
            1861,4826,1860,1854,1856,4645,1859,2466,37,223,
            2465,35,188,4935,4992,688,2162,2348,96,1979,
            4906,4903,4643,89,90,72,440,82,87,88,
            112,113,114,115,116,117,135,136,137,138,
            139,73,79,2405,67,54,55,2406,65,2409,
            49,2408,41,341,1978,307,308,1861,4826,1860,
            1854,1856,4645,1859,2466,37,223,2465,35,4854,
            4935,4995,688,2162,2348,96,1979,4906,4903,4643,
            89,90,72,440,82,87,88,112,113,114,
            115,116,117,135,136,137,138,139,73,79,
            2405,67,54,55,2406,65,2409,49,2408,41,
            341,1978,307,308,1861,4826,1860,1854,1856,4645,
            1859,2466,37,223,2465,35,188,4935,4996,688,
            2162,2348,96,1979,4906,4903,4643,89,90,72,
            440,82,87,88,112,113,114,115,116,117,
            135,136,137,138,139,73,79,2405,67,54,
            55,2406,65,2409,49,2408,41,341,1978,307,
            308,1861,4826,1860,1854,1856,4645,1859,2466,37,
            223,2465,35,228,4935,4997,688,2162,2348,96,
            1979,4906,4903,4643,89,90,72,440,82,87,
            88,112,113,114,115,116,117,135,136,137,
            138,139,73,79,2405,67,54,55,2406,65,
            2409,49,2408,41,341,1978,307,308,1861,4826,
            1860,1854,1856,4645,1859,2466,37,223,2465,35,
            188,4935,4998,688,2162,2348,96,1979,4906,4903,
            4643,89,90,72,440,82,87,88,112,113,
            114,115,116,117,135,136,137,138,139,73,
            79,2405,67,54,55,2406,65,2409,49,2408,
            41,341,1978,307,308,1861,4826,1860,1854,1856,
            4645,1859,2466,37,223,2465,35,229,4935,4999,
            688,2162,2348,96,1979,4906,4903,4643,89,90,
            72,440,82,87,88,112,113,114,115,116,
            117,135,136,137,138,139,73,79,2405,67,
            54,55,2406,65,2409,49,2408,41,341,1978,
            307,308,1861,4826,1860,1854,1856,4645,1859,2466,
            37,223,2465,35,188,4935,5000,688,2162,2348,
            96,1979,4906,4903,4643,89,90,72,440,82,
            87,88,112,113,114,115,116,117,135,136,
            137,138,139,73,79,2405,67,54,55,2406,
            65,2409,49,2408,41,341,1978,307,308,1861,
            4826,1860,1854,1856,4645,1859,2466,37,223,2465,
            35,5026,4935,5001,688,2162,2348,96,1979,4906,
            4903,4643,89,90,72,440,82,87,88,112,
            113,114,115,116,117,135,136,137,138,139,
            73,79,2405,67,54,55,2406,65,2409,49,
            2408,41,341,1978,307,308,1861,4826,1860,1854,
            1856,4645,1859,2466,37,223,2465,35,188,4935,
            5002,688,2162,2348,96,1979,4906,4903,4643,89,
            90,72,440,82,87,88,112,113,114,115,
            116,117,135,136,137,138,139,73,79,2405,
            67,54,55,2406,65,2409,49,2408,41,341,
            1978,307,308,1861,4826,1860,1854,1856,4645,1859,
            2466,37,223,2465,35,186,4935,5003,688,2162,
            2348,96,1979,4906,4903,4643,89,90,72,440,
            82,87,88,112,113,114,115,116,117,135,
            136,137,138,139,73,79,2405,67,54,55,
            2406,65,2409,49,2408,41,341,1978,307,308,
            1861,4826,1860,1854,1856,4645,1859,2466,37,223,
            2465,35,188,4935,5004,688,2162,2348,96,1979,
            4906,4903,4643,89,90,72,440,82,87,88,
            112,113,114,115,116,117,135,136,137,138,
            139,73,79,2405,67,54,55,2406,65,2409,
            49,2408,41,341,1978,307,308,1861,4826,1860,
            1854,1856,4645,1859,2466,37,223,2465,35,5048,
            4935,5006,688,2162,2348,96,1979,4906,4903,4643,
            89,90,72,440,82,87,88,112,113,114,
            115,116,117,135,136,137,138,139,73,79,
            2405,67,54,55,2406,65,2409,49,2408,41,
            341,1978,307,308,1861,4826,1860,1854,1856,4645,
            1859,2466,37,223,2465,35,188,4935,5007,688,
            2162,2348,96,1979,4906,4903,4643,89,90,72,
            440,82,87,88,112,113,114,115,116,117,
            135,136,137,138,139,73,79,2405,67,54,
            55,2406,65,2409,49,2408,41,341,1978,307,
            308,1861,4826,1860,1854,1856,4645,1859,2466,37,
            223,2465,35,5050,4935,5008,688,2162,2348,96,
            1979,4906,4903,4643,89,90,72,440,82,87,
            88,112,113,114,115,116,117,135,136,137,
            138,139,73,79,2405,67,54,55,2406,65,
            2409,49,2408,41,341,1978,307,308,1861,4826,
            1860,1854,1856,4645,1859,2466,37,223,2465,35,
            1501,4935,5009,688,2162,2348,96,1979,4906,4903,
            4643,89,90,72,440,82,87,88,112,113,
            114,115,116,117,135,136,137,138,139,73,
            79,2405,67,54,55,2406,65,2409,49,2408,
            41,341,1978,307,308,1861,4826,1860,1854,1856,
            4645,1859,2466,37,223,2465,35,1694,4935,5010,
            688,2162,2348,96,1979,4906,4903,4643,89,90,
            72,440,82,87,88,112,113,114,115,116,
            117,135,136,137,138,139,73,79,2405,67,
            54,55,2406,65,2409,49,2408,41,341,1978,
            307,308,1861,4826,1860,1854,1856,4645,1859,2466,
            37,223,2465,35,1397,4935,5011,688,2162,2348,
            96,1979,4906,4903,4643,89,90,72,440,82,
            87,88,112,113,114,115,116,117,135,136,
            137,138,139,73,79,2405,67,54,55,2406,
            65,2409,49,2408,41,341,1978,307,308,1861,
            4826,1860,1854,1856,4645,1859,2466,37,223,2465,
            35,1714,4935,5012,688,2162,2348,96,1979,4906,
            4903,4643,89,90,72,440,82,87,88,112,
            113,114,115,116,117,135,136,137,138,139,
            73,79,2405,67,54,55,2406,65,2409,49,
            2408,41,341,1978,307,308,1861,4826,1860,1854,
            1856,4645,1859,2466,37,223,2465,35,1003,4935,
            5013,688,2162,2348,96,1979,4906,4903,4643,89,
            90,72,440,82,87,88,112,113,114,115,
            116,117,135,136,137,138,139,73,79,2405,
            67,54,55,2406,65,2409,49,2408,41,341,
            1978,307,308,1861,4826,1860,1854,1856,4645,1859,
            2466,37,223,2465,35,1065,4935,5014,289,2162,
            2348,96,1979,4906,4903,4643,89,90,72,440,
            82,87,88,112,113,114,115,116,117,135,
            136,137,138,139,73,79,2405,67,54,55,
            2406,65,2409,49,2408,41,341,1978,307,308,
            1861,4826,1860,1854,1856,4645,1859,2466,37,4747,
            2465,35,1641,365,219,96,1624,4974,298,1505,
            1668,1635,1896,367,129,130,688,2162,2348,96,
            1979,4906,4903,4643,89,90,72,440,82,87,
            88,112,113,114,115,116,117,135,136,137,
            138,139,73,79,2405,67,54,55,2406,65,
            2409,49,2408,41,341,1978,307,308,1861,4826,
            1860,1854,1856,4645,1859,2466,37,223,2465,35,
            250,4935,5024,783,2162,2348,96,1979,4906,4903,
            4643,89,90,72,440,82,87,88,112,113,
            114,115,116,117,135,136,137,138,139,73,
            79,2405,67,54,55,2406,65,2409,49,2408,
            41,341,1978,307,308,1861,4826,1860,1854,1856,
            4645,1859,2466,37,166,2465,35,1065,385,518,
            5028,1896,367,5027,783,2162,2348,96,1979,4906,
            4903,4643,89,90,72,440,82,87,88,112,
            113,114,115,116,117,135,136,137,138,139,
            73,79,2405,67,54,55,2406,65,2409,49,
            2408,41,341,1978,307,308,1861,4826,1860,1854,
            1856,4645,1859,2466,37,166,2465,35,1065,271,
            297,5028,1896,367,5030,783,2162,2348,96,1979,
            4906,4903,4643,89,90,72,440,82,87,88,
            112,113,114,115,116,117,135,136,137,138,
            139,73,79,2405,67,54,55,2406,65,2409,
            49,2408,41,341,1978,307,308,1861,4826,1860,
            1854,1856,4645,1859,2466,37,166,2465,35,591,
            275,296,5028,1896,367,5031,783,2162,2348,96,
            1979,4906,4903,4643,89,90,72,440,82,87,
            88,112,113,114,115,116,117,135,136,137,
            138,139,73,79,2405,67,54,55,2406,65,
            2409,49,2408,41,341,1978,307,308,1861,4826,
            1860,1854,1856,4645,1859,2466,37,166,2465,35,
            650,245,1163,5028,1896,367,5032,783,2162,2348,
            96,1979,4906,4903,4643,89,90,72,440,82,
            87,88,112,113,114,115,116,117,135,136,
            137,138,139,73,79,2405,67,54,55,2406,
            65,2409,49,2408,41,341,1978,307,308,1861,
            4826,1860,1854,1856,4645,1859,2466,37,166,2465,
            35,1620,4699,1723,5028,1896,367,5033,783,2162,
            2348,96,1979,4906,4903,4643,89,90,72,440,
            82,87,88,112,113,114,115,116,117,135,
            136,137,138,139,73,79,2405,67,54,55,
            2406,65,2409,49,2408,41,341,1978,307,308,
            1861,4826,1860,1854,1856,4645,1859,2466,37,166,
            2465,35,906,292,1001,5028,1896,367,5034,783,
            2162,2348,96,1979,4906,4903,4643,89,90,72,
            440,82,87,88,112,113,114,115,116,117,
            135,136,137,138,139,73,79,2405,67,54,
            55,2406,65,2409,49,2408,41,341,1978,307,
            308,1861,4826,1860,1854,1856,4645,1859,2466,37,
            166,2465,35,1426,4989,1427,5028,1451,2014,5035,
            783,2162,2348,96,1979,4906,4903,4643,89,90,
            72,440,82,87,88,112,113,114,115,116,
            117,135,136,137,138,139,73,79,2405,67,
            54,55,2406,65,2409,49,2408,41,341,1978,
            307,308,1861,4826,1860,1854,1856,4645,1859,2466,
            37,166,2465,35,444,1555,1569,5028,1691,1125,
            5036,783,2162,2348,96,1979,4906,4903,4643,89,
            90,72,440,82,87,88,112,113,114,115,
            116,117,135,136,137,138,139,73,79,2405,
            67,54,55,2406,65,2409,49,2408,41,341,
            1978,307,308,1861,4826,1860,1854,1856,4645,1859,
            2466,37,166,2465,35,1259,248,2030,5028,1761,
            2015,5037,783,2162,2348,96,1979,4906,4903,4643,
            89,90,72,440,82,87,88,112,113,114,
            115,116,117,135,136,137,138,139,73,79,
            2405,67,54,55,2406,65,2409,49,2408,41,
            341,1978,307,308,1861,4826,1860,1854,1856,4645,
            1859,2466,37,166,2465,35,1759,1715,2059,5028,
            2019,2035,5038,783,2162,2348,96,1979,4906,4903,
            4643,89,90,72,440,82,87,88,112,113,
            114,115,116,117,135,136,137,138,139,73,
            79,2405,67,54,55,2406,65,2409,49,2408,
            41,341,1978,307,308,1861,4826,1860,1854,1856,
            4645,1859,2466,37,166,2465,35,2025,2040,2028,
            5028,1788,2061,5039,688,2162,2348,96,1979,4906,
            4903,4643,89,90,72,440,82,87,88,112,
            113,114,115,116,117,135,136,137,138,139,
            73,79,2405,67,54,55,2406,65,2409,49,
            2408,41,341,1978,307,308,1861,4826,1860,1854,
            1856,4645,1859,2466,37,223,2465,35,2068,4935,
            5045,688,2162,2348,96,1979,4906,4903,4643,89,
            90,72,440,82,87,88,112,113,114,115,
            116,117,135,136,137,138,139,73,79,2405,
            67,54,55,2406,65,2409,49,2408,41,341,
            1978,307,308,1861,4826,1860,1854,1856,4645,1859,
            2466,37,223,2465,35,2073,4935,5046,593,2162,
            2348,96,1979,4906,4903,4643,89,90,72,440,
            82,87,88,112,113,114,115,116,117,135,
            136,137,138,139,73,79,2405,67,54,55,
            2406,65,2409,49,2408,41,341,1978,307,308,
            1861,4826,1860,1854,1856,4645,1859,2466,37,223,
            2465,35,1732,4902,593,2162,2348,96,1979,4906,
            4903,4643,89,90,72,440,82,87,88,112,
            113,114,115,116,117,135,136,137,138,139,
            73,79,2405,67,54,55,2406,65,2409,49,
            2408,41,341,1978,307,308,1861,4826,1860,1854,
            1856,4645,1859,2466,37,223,2465,35,880,4917,
            593,2162,2348,96,1979,4906,4903,4643,89,90,
            72,440,82,87,88,112,113,114,115,116,
            117,135,136,137,138,139,73,79,2405,67,
            54,55,2406,65,2409,49,2408,41,341,1978,
            307,308,1861,4826,1860,1854,1856,4645,1859,2466,
            37,223,2465,35,813,5025,490,2162,2348,96,
            1979,4906,4903,4643,89,90,72,440,82,87,
            88,112,113,114,115,116,117,135,136,137,
            138,139,73,79,2405,67,54,55,2406,65,
            2409,49,2408,41,341,1978,307,308,1861,4826,
            1860,1854,1856,4645,1859,2466,37,237,2465,35,
            2074,2041,2054,1951,975,1257,1612,2079,2081,2084,
            236,1,2162,2348,96,1979,4906,4903,4643,89,
            90,72,440,82,87,88,112,113,114,115,
            116,117,135,136,137,138,139,73,79,2405,
            67,54,55,2406,65,2409,49,2408,41,341,
            1978,307,308,1861,4826,1860,1854,1856,4645,1859,
            2466,37,1738,2465,35,96,2162,2348,96,1979,
            4906,4903,4643,89,90,72,440,82,87,88,
            112,113,114,115,116,117,135,136,137,138,
            139,73,79,2405,67,54,55,2406,65,2409,
            49,2408,41,341,1978,307,308,1861,4826,1860,
            1854,1856,4645,1859,2466,37,2530,2465,35,593,
            2162,2348,96,1979,4906,4903,4643,89,90,72,
            440,82,87,88,112,113,114,115,116,117,
            135,136,137,138,139,73,79,2405,67,54,
            55,2406,65,2409,49,2408,41,341,1978,307,
            308,1861,4826,1860,1854,1856,4645,1859,2466,37,
            2591,2465,35,593,2162,2348,96,1979,4906,4903,
            4643,89,90,72,440,82,87,88,112,113,
            114,115,116,117,135,136,137,138,139,73,
            79,2405,67,54,55,2406,65,2409,49,2408,
            41,341,1978,307,308,1861,4826,1860,1854,1856,
            4645,1859,2466,37,2933,2465,35,593,2162,2348,
            96,1979,4906,4903,4643,89,90,72,440,82,
            87,88,112,113,114,115,116,117,135,136,
            137,138,139,73,79,2405,67,54,55,2406,
            65,2409,49,2408,41,341,1978,307,308,1861,
            4826,1860,1854,1856,4645,1859,2466,37,4674,2465,
            35,593,2162,2348,96,1979,4906,4903,4643,89,
            90,72,440,82,87,88,112,113,114,115,
            116,117,135,136,137,138,139,73,79,2405,
            67,54,55,2406,65,2409,49,2408,41,341,
            1978,307,308,1861,4826,1860,1854,1856,4645,1859,
            2466,37,4701,2465,35,593,2162,2348,96,1979,
            4906,4903,4643,89,90,72,440,82,87,88,
            112,113,114,115,116,117,135,136,137,138,
            139,73,79,2405,67,54,55,2406,65,2409,
            49,2408,41,341,1978,307,308,1861,4826,1860,
            1854,1856,4645,1859,2466,37,320,2465,35,593,
            2162,2348,96,1979,4906,4903,4643,89,90,72,
            440,82,87,88,112,113,114,115,116,117,
            135,136,137,138,139,73,79,2405,67,54,
            55,2406,65,2409,49,2408,41,341,1978,307,
            308,1861,4826,1860,1854,1856,4645,1859,2466,37,
            133,2465,35,593,2162,2348,96,1979,4906,4903,
            4643,89,90,72,440,82,87,88,112,113,
            114,115,116,117,135,136,137,138,139,73,
            79,2405,67,54,55,2406,65,2409,49,2408,
            41,341,1978,307,308,1861,4826,1860,1854,1856,
            4645,1859,2466,37,5019,2465,35,593,2162,2348,
            96,1979,4906,4903,4643,89,90,72,440,82,
            87,88,112,113,114,115,116,117,135,136,
            137,138,139,73,79,2405,67,54,55,2406,
            65,2409,49,2408,41,341,1978,307,308,1861,
            4826,1860,1854,1856,4645,1859,2466,37,5021,2465,
            35,593,2162,2348,96,1979,4906,4903,4643,89,
            90,72,440,82,87,88,112,113,114,115,
            116,117,135,136,137,138,139,73,79,2405,
            67,54,55,2406,65,2409,49,2408,41,341,
            1978,307,308,1861,4826,1860,1854,1856,4645,1859,
            2466,37,225,2465,35,593,2162,2348,96,1979,
            4906,4903,4643,89,90,72,440,82,87,88,
            112,113,114,115,116,117,135,136,137,138,
            139,73,79,2405,67,54,55,2406,65,2409,
            49,2408,41,341,1978,307,308,1861,4826,1860,
            1854,1856,4645,1859,2466,37,134,2465,35,593,
            2162,2348,96,1979,4906,4903,4643,89,90,72,
            440,82,87,88,112,113,114,115,116,117,
            135,136,137,138,139,73,79,2405,67,54,
            55,2406,65,2409,49,2408,41,341,1978,307,
            308,1861,4826,1860,1854,1856,4645,1859,2466,37,
            132,2465,35,593,2162,2348,96,1979,4906,4903,
            4643,89,90,72,440,82,87,88,112,113,
            114,115,116,117,135,136,137,138,139,73,
            79,2405,67,54,55,2406,65,2409,49,2408,
            41,341,1978,307,308,1861,4826,1860,1854,1856,
            4645,1859,2466,37,174,2465,35,593,2162,2348,
            96,1979,4906,4903,4643,89,90,72,440,82,
            87,88,112,113,114,115,116,117,135,136,
            137,138,139,73,79,2405,67,54,55,2406,
            65,2409,49,2408,41,341,1978,307,308,1861,
            4826,1860,1854,1856,4645,1859,2466,37,224,2465,
            35,593,2162,2348,96,1979,4906,4903,4643,89,
            90,72,440,82,87,88,112,113,114,115,
            116,117,135,136,137,138,139,73,79,2405,
            67,54,55,2406,65,2409,49,2408,41,341,
            1978,307,308,1861,4826,1860,1854,1856,4645,1859,
            2466,37,173,2465,35,593,2162,2348,96,1979,
            4906,4903,4643,89,90,72,440,82,87,88,
            112,113,114,115,116,117,135,136,137,138,
            139,73,79,2405,67,54,55,2406,65,2409,
            49,2408,41,341,1978,307,308,1861,4826,1860,
            1854,1856,4645,1859,2466,37,5047,2465,35,593,
            2162,2348,96,1979,4906,4903,4643,89,90,72,
            440,82,87,88,112,113,114,115,116,117,
            135,136,137,138,139,73,79,2405,67,54,
            55,2406,65,2409,49,2408,41,341,1978,307,
            308,1861,4826,1860,1854,1856,4645,1859,2466,37,
            5049,2465,35,593,2162,2348,96,1979,4906,4903,
            4643,89,90,72,440,82,87,88,112,113,
            114,115,116,117,135,136,137,138,139,73,
            79,2405,67,54,55,2406,65,2409,49,2408,
            41,341,1978,307,308,1861,4826,1860,1854,1856,
            4645,1859,2466,37,167,2465,35,593,2162,2348,
            96,1979,4906,4903,4643,89,90,72,440,82,
            87,88,112,113,114,115,116,117,135,136,
            137,138,139,73,79,2405,67,54,55,2406,
            65,2409,49,2408,41,341,1978,307,308,1861,
            4826,1860,1854,1856,4645,1859,2466,37,5053,2465,
            35,593,2162,2348,96,1979,4906,4903,4643,89,
            90,72,440,82,87,88,112,113,114,115,
            116,117,135,136,137,138,139,73,79,2405,
            67,54,55,2406,65,2409,49,2408,41,341,
            1978,307,308,1861,4826,1860,1854,1856,4645,1859,
            2466,37,168,2465,35,878,2931,2348,96,1979,
            4906,4903,4643,89,90,72,440,82,87,88,
            112,113,114,115,116,117,135,136,137,138,
            139,73,79,2405,67,54,55,2406,65,2409,
            49,2408,41,2087,2089,2091,2093,2095,2097,2100,
            2104,2108,2113,2115,4981,39,878,2931,2348,96,
            1979,4906,4903,4643,89,90,72,440,82,87,
            88,112,113,114,115,116,117,135,136,137,
            138,139,73,79,2405,67,54,55,2406,65,
            2409,49,4982,47,878,2931,2348,96,1979,4906,
            4903,4643,89,90,72,440,82,87,88,112,
            113,114,115,116,117,135,136,137,138,139,
            73,79,2405,67,54,55,2406,65,2409,49,
            4983,46,878,2931,2348,96,1979,4906,4903,4643,
            89,90,72,440,82,87,88,112,113,114,
            115,116,117,135,136,137,138,139,73,79,
            2405,67,54,55,2406,65,2409,49,4984,45,
            878,2931,2348,96,1979,4906,4903,4643,89,90,
            72,440,82,87,88,112,113,114,115,116,
            117,135,136,137,138,139,73,79,2405,67,
            54,55,2406,65,4979,53,878,2931,2348,96,
            1979,4906,4903,4643,89,90,72,440,82,87,
            88,112,113,114,115,116,117,135,136,137,
            138,139,73,79,2405,67,54,55,2406,65,
            4980,51,878,2931,2348,96,1979,4906,4903,4643,
            89,90,72,440,82,87,88,112,113,114,
            115,116,117,135,136,137,138,139,73,79,
            2405,67,62,63,2406,65,878,2931,2348,96,
            1979,4906,4903,4643,89,90,72,440,82,87,
            88,112,113,114,115,116,117,135,136,137,
            138,139,73,79,2405,67,60,61,2406,65,
            878,2931,2348,96,1979,4906,4903,4643,89,90,
            72,440,82,87,88,112,113,114,115,116,
            117,135,136,137,138,139,73,79,2405,67,
            58,59,2406,65,878,2931,2348,96,1979,4906,
            4903,4643,89,90,72,440,82,87,88,112,
            113,114,115,116,117,135,136,137,138,139,
            73,79,2405,67,56,57,2406,65,973,2931,
            2348,96,1979,4906,4903,4643,89,90,72,440,
            82,87,88,112,113,114,115,116,117,135,
            136,137,138,139,73,79,4975,71,973,2931,
            2348,96,1979,4906,4903,4643,89,90,72,440,
            82,87,88,112,113,114,115,116,117,135,
            136,137,138,139,73,79,4977,69,973,2931,
            2348,96,1979,4906,4903,4643,89,90,76,440,
            82,87,88,112,113,114,115,116,117,135,
            136,137,138,139,77,79,973,2931,2348,96,
            1979,4906,4903,4643,89,90,74,440,82,87,
            88,112,113,114,115,116,117,135,136,137,
            138,139,75,79,1164,2931,2348,96,1979,4906,
            4903,4643,89,90,81,440,82,87,88,112,
            113,114,115,116,117,135,136,137,138,139,
            1164,2931,2348,96,1979,4906,4903,4643,89,90,
            80,440,82,87,88,112,113,114,115,116,
            117,135,136,137,138,139,1067,2931,2348,96,
            1979,4906,4903,4643,89,90,80,440,82,87,
            88,112,113,114,115,116,117,135,136,137,
            138,139,1557,745,2118,1815,2648,1340,365,582,
            96,2120,4912,22,4914,192,2122,1731,364,2762,
            1554,2818,780,2124,1896,367,1869,4987,1896,367,
            745,1731,364,4889,2056,2818,908,2106,1950,364,
            2589,2075,2126,332,1978,307,308,1861,4826,1860,
            1854,1856,4645,1859,1731,364,4892,2934,2818,2110,
            780,2128,745,331,294,1978,307,308,1861,4826,
            1860,1854,1856,4645,1859,149,321,191,1760,188,
            1622,272,263,295,2935,2129,263,1679,273,1510,
            323,187,2130,1510,150,153,154,247,4874,4879,
            596,246,4874,4879,596,254,255,1674,4883,2131,
            518,523,4767,322,4660,516,2936,190,2941,585,
            2995,510,1585,364,4681,177,2818,1923,367,189,
            4841,452,328,451,280,281,1585,364,4681,177,
            2818,2526,2527,4881,2588,2470,1585,364,4681,177,
            2818,1585,364,4681,177,2818,1585,364,4681,177,
            2818,1585,364,4681,177,2818,1585,364,5052,177,
            2818,1585,364,4681,177,2818,243,434,443,427,
            4727,179,4642,340,178,291,1896,367,252,1731,
            364,4898,4843,2818,587,179,2179,337,178,1896,
            367,1896,367,1896,367,179,745,4985,178,93,
            179,745,4990,178,690,179,745,4991,178,745,
            179,745,5044,178,745,5051,745,4991,178,745,
            179,745,239,178,1787,367,745,745,277,1896,
            367,1842,367,1701,270,2004,745,2469,324,1978,
            745,745,1979,185,745,745,589,244,1980,1567,
            2937,270,1474,1463,2874,2938,221,745,745,745,
            2939,745,386,4113,745,4114,745,2005,4115,745,
            4116,267,745,4117,745,4118,5022,5023,2011,4720,
            4119,4120,264,2132,594,2135,2137,264,2139,4676,
            4121,2141,2143,425,4122,4123,4718,4725,4644,4651,
            4656,261,317,2145,2147,2149,260,93,2151,2153,
            4663,5015,5016,4656,2155,5017,5018,2160,217,2164,
            5020,336,2168,95,2170,1644,94,2013,218,1425,
            1531,547,2016,2017,2022,2066,2172,2173,2174,2178,
            2180,1070,2186,2189,2166,2190,2193,2194,2197,2198,
            2201,2202,2205,2206,2209,302,2210,2213,2214,2217,
            2218,2221,2225,2226,2229,2232,2234,2236,2238,2183,
            2240,2222,2242,2230,2243,2006,1926,2246,3,1672,
            2247,2250,2251,2254,2255,2259,2260,2263,2264,2267,
            2268,2271,2272,2273,2276,2277,2278,381,716,2281,
            875,2282,2020,2284,5056,5056
        };
    };
    public final static char baseAction[] = BaseAction.baseAction;
    public final int baseAction(int index) { return baseAction[index]; }
    public final static char lhs[] = baseAction;
    public final int lhs(int index) { return lhs[index]; };

    public interface TermCheck {
        public final static byte termCheck[] = {0,
            0,1,0,3,4,5,6,7,8,9,
            10,11,12,13,14,15,16,17,18,19,
            20,21,22,23,24,25,26,27,0,29,
            28,31,32,33,34,35,36,37,38,39,
            40,41,42,43,44,45,46,47,48,49,
            50,51,52,53,54,55,56,57,30,59,
            60,61,62,63,64,65,66,67,68,69,
            70,71,72,73,74,75,76,77,78,79,
            80,81,82,83,84,85,86,87,88,89,
            90,91,0,93,94,0,1,95,3,4,
            5,6,7,8,9,10,11,12,13,14,
            15,16,17,18,19,20,21,22,23,24,
            25,26,27,0,29,0,31,32,33,34,
            35,36,37,38,39,40,41,42,43,44,
            45,46,47,48,49,50,51,52,53,54,
            55,56,57,30,59,60,61,62,63,64,
            65,66,67,68,69,70,71,72,73,74,
            75,76,77,78,79,80,81,82,83,84,
            85,86,87,88,89,90,91,0,93,94,
            0,1,5,3,4,5,6,7,8,9,
            10,11,12,13,14,15,16,17,18,19,
            20,21,22,23,24,25,26,27,0,29,
            0,31,32,33,34,35,36,37,38,39,
            40,41,42,43,44,45,46,47,48,49,
            50,51,52,53,54,55,56,0,30,59,
            60,61,62,63,64,65,66,67,68,69,
            70,71,72,73,74,75,76,77,78,79,
            80,81,82,83,84,85,86,87,88,89,
            90,91,0,93,94,38,39,40,0,1,
            100,3,4,5,6,7,8,9,10,11,
            12,13,14,15,16,17,18,19,20,21,
            22,23,24,25,26,27,96,29,98,31,
            32,33,34,35,36,37,38,39,40,41,
            42,43,44,45,46,47,48,49,50,51,
            52,53,54,55,56,0,1,59,60,61,
            62,63,64,65,66,67,68,69,70,71,
            72,73,74,75,76,77,78,79,80,81,
            82,83,84,85,86,87,88,89,90,91,
            0,93,94,0,0,0,0,1,100,3,
            4,5,6,7,8,9,10,11,12,13,
            14,15,16,17,18,19,20,21,22,23,
            24,25,26,27,30,29,0,31,32,33,
            34,35,36,37,38,39,40,41,42,43,
            44,45,46,47,48,49,50,51,52,53,
            54,55,56,0,1,59,60,61,62,63,
            64,65,66,67,68,69,70,71,72,73,
            74,75,76,77,78,79,80,81,82,83,
            84,85,86,87,88,89,90,91,0,93,
            94,96,99,98,101,7,103,104,108,0,
            1,105,3,4,5,6,7,8,9,10,
            11,12,13,14,15,16,17,18,19,20,
            21,22,23,24,25,26,27,0,29,0,
            31,32,33,34,35,36,37,38,39,40,
            41,42,43,44,45,46,47,48,49,50,
            51,52,53,54,55,56,0,30,59,60,
            61,62,63,64,65,66,67,68,69,70,
            71,72,73,74,75,76,77,78,79,80,
            81,82,83,84,85,86,87,88,89,90,
            91,0,93,94,38,39,40,6,0,1,
            0,0,0,1,105,3,4,5,6,7,
            8,9,10,11,12,13,14,15,16,17,
            18,19,20,21,22,23,24,25,26,27,
            30,29,0,31,32,33,34,35,36,37,
            38,39,40,41,42,43,44,45,46,47,
            48,49,50,51,52,53,54,55,56,0,
            1,59,60,61,62,63,64,65,66,67,
            68,69,70,71,72,73,74,75,76,77,
            78,79,80,81,82,83,84,85,86,87,
            88,89,90,91,96,93,94,0,1,0,
            3,4,5,6,7,8,9,10,11,12,
            13,14,15,16,17,18,19,20,21,22,
            23,24,25,26,27,0,29,28,31,32,
            33,34,35,36,37,38,39,40,41,42,
            43,44,45,46,47,48,49,50,51,52,
            53,54,55,56,0,96,59,60,61,62,
            63,64,65,66,67,68,69,70,71,72,
            73,74,75,76,77,78,79,80,81,82,
            83,84,85,86,87,88,89,90,91,0,
            93,94,0,1,5,3,4,5,6,7,
            8,9,10,11,12,13,14,15,16,17,
            18,19,20,21,22,23,24,25,26,27,
            95,29,0,31,32,33,34,35,36,37,
            38,39,40,41,42,43,44,45,46,47,
            48,49,50,51,52,53,54,55,56,27,
            96,59,60,61,62,63,64,65,66,67,
            68,69,70,71,72,73,74,75,76,77,
            78,79,80,81,82,83,84,85,86,87,
            88,89,90,91,0,93,94,0,1,0,
            1,4,5,6,7,8,9,10,11,12,
            13,14,15,16,17,18,19,20,21,22,
            23,24,25,26,27,0,29,0,31,32,
            33,34,35,36,37,38,39,40,41,42,
            43,44,45,46,47,48,49,50,51,52,
            53,54,55,56,27,30,59,60,61,62,
            63,64,65,66,67,68,69,70,71,72,
            73,74,75,76,77,78,79,80,81,82,
            83,84,85,86,87,88,89,90,91,95,
            93,94,0,1,0,1,4,5,6,7,
            8,9,10,11,12,13,14,15,16,17,
            18,19,20,21,22,23,24,25,26,27,
            0,29,0,31,32,33,34,35,36,37,
            38,39,40,41,42,43,44,45,46,47,
            48,49,50,51,52,53,54,55,56,0,
            30,59,60,61,62,63,64,65,66,67,
            68,69,70,71,72,73,74,75,76,77,
            78,79,80,81,82,83,84,85,86,87,
            88,89,90,91,0,93,0,1,4,0,
            4,5,6,7,8,9,10,11,12,13,
            14,15,16,17,18,19,20,21,22,23,
            24,25,26,27,92,29,27,31,32,33,
            34,35,36,37,38,39,40,41,42,43,
            44,45,46,47,48,49,50,51,52,53,
            54,55,56,0,0,59,60,61,62,63,
            64,65,66,67,68,69,70,71,72,73,
            74,75,76,77,78,79,80,81,82,83,
            84,85,86,87,88,89,90,91,34,35,
            36,37,0,0,1,3,100,4,5,6,
            7,8,9,10,11,12,13,14,15,16,
            17,18,19,20,21,22,23,24,25,26,
            27,0,29,0,31,32,33,34,35,36,
            37,38,39,40,41,42,43,44,45,46,
            47,48,49,50,51,52,53,54,55,56,
            58,30,59,60,61,62,63,64,65,66,
            67,68,69,70,71,72,73,74,75,76,
            77,78,79,80,81,82,83,84,85,86,
            87,88,89,90,91,0,0,1,0,4,
            5,6,7,8,9,10,11,12,13,14,
            15,16,17,18,19,20,21,22,23,24,
            25,26,27,92,29,0,31,32,33,34,
            35,36,37,38,39,40,41,42,43,44,
            45,46,47,48,49,50,51,52,53,54,
            55,56,0,28,59,60,61,62,63,64,
            65,66,67,68,69,70,71,72,73,74,
            75,76,77,78,79,80,81,82,83,0,
            28,0,57,4,5,6,7,8,9,10,
            11,12,13,14,15,16,17,18,19,20,
            21,22,23,24,25,26,27,109,29,57,
            31,32,33,34,35,36,37,38,39,40,
            41,42,43,44,45,46,47,48,49,50,
            51,52,53,54,55,56,0,1,59,60,
            61,62,63,64,65,66,67,68,69,70,
            71,72,73,74,75,76,77,78,79,80,
            81,82,83,0,0,0,0,4,5,6,
            7,8,9,10,11,12,13,14,15,16,
            17,18,19,20,21,22,23,24,25,26,
            0,0,29,2,58,30,30,0,34,35,
            36,37,0,1,41,42,43,44,45,46,
            47,48,49,0,51,52,53,54,55,28,
            30,0,59,60,61,62,63,64,65,66,
            67,68,69,70,71,72,73,74,0,0,
            0,28,0,3,0,82,4,5,6,7,
            8,9,10,11,12,13,14,15,16,17,
            18,19,20,21,22,23,24,25,26,27,
            0,29,28,31,32,33,34,35,36,37,
            38,39,40,41,42,43,44,45,46,47,
            48,49,50,0,0,57,0,4,96,0,
            98,8,6,10,34,35,36,37,0,16,
            97,18,13,17,0,19,0,75,76,77,
            78,79,80,81,0,11,32,33,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,0,1,57,0,111,2,0,50,0,
            0,0,3,0,56,41,42,43,44,45,
            46,47,48,49,0,51,52,53,54,55,
            0,20,28,0,4,5,6,7,8,9,
            10,11,12,13,14,15,16,17,18,19,
            20,21,22,23,24,25,26,0,84,29,
            0,0,2,0,3,32,33,58,0,0,
            57,41,42,43,44,45,46,47,48,49,
            0,57,14,0,15,28,3,27,28,28,
            0,31,32,33,34,35,36,37,38,39,
            40,0,92,0,0,0,3,27,7,99,
            50,31,0,9,57,3,56,57,28,58,
            0,0,21,112,4,5,6,7,8,9,
            10,11,12,13,14,15,16,17,18,19,
            20,21,22,23,24,25,26,57,0,0,
            0,30,92,3,0,95,95,97,57,99,
            12,101,102,103,104,102,106,107,108,109,
            110,51,52,53,54,55,0,0,28,58,
            4,5,6,7,8,9,10,11,12,13,
            14,15,16,17,18,19,20,21,22,23,
            24,25,26,0,0,29,30,3,4,5,
            6,7,8,9,10,11,12,13,14,15,
            16,17,18,19,20,21,22,23,24,25,
            26,0,0,29,57,4,5,6,7,8,
            9,10,11,12,13,14,15,16,17,18,
            19,20,21,22,23,24,25,26,0,110,
            29,3,4,5,6,7,8,9,10,11,
            12,13,14,15,16,17,18,19,20,21,
            22,23,24,25,26,0,0,29,57,4,
            5,6,7,8,9,10,11,12,13,14,
            15,16,17,18,19,20,21,22,23,24,
            25,26,0,0,29,0,4,5,6,7,
            8,9,10,11,12,13,14,15,16,17,
            18,19,20,21,22,23,24,25,26,0,
            0,29,2,4,5,6,7,8,9,10,
            11,12,13,14,15,16,17,18,19,20,
            21,22,23,24,25,26,0,0,0,0,
            4,5,6,7,8,9,10,11,12,13,
            14,15,16,17,18,19,20,21,22,23,
            24,25,26,0,0,0,3,30,30,30,
            0,1,0,0,0,0,0,92,0,0,
            95,0,0,0,0,3,3,0,0,0,
            27,3,28,28,0,58,58,58,0,0,
            0,3,27,27,32,33,31,31,27,30,
            28,28,31,0,0,0,28,3,0,30,
            0,0,4,3,30,0,28,0,58,30,
            3,58,0,0,0,3,3,58,0,1,
            0,1,28,0,1,58,0,1,0,1,
            0,1,0,1,0,1,0,1,58,0,
            1,97,97,0,1,0,92,0,1,0,
            92,58,0,1,0,1,92,0,1,0,
            1,0,1,0,1,0,1,0,0,0,
            0,0,58,2,0,30,0,1,0,1,
            0,1,0,1,0,1,0,1,0,1,
            0,1,0,1,0,1,28,92,28,0,
            1,106,28,0,1,0,57,0,1,0,
            1,0,0,0,3,3,3,0,0,0,
            3,2,0,5,57,0,57,2,0,0,
            2,2,0,0,2,2,0,0,2,2,
            0,0,2,2,0,0,2,2,0,0,
            2,2,0,0,2,2,0,0,2,2,
            0,0,2,58,0,0,2,2,0,0,
            2,0,1,0,1,0,1,0,1,0,
            1,0,0,2,2,0,0,2,2,0,
            0,2,2,0,0,2,2,28,0,0,
            2,2,0,0,2,2,0,0,2,2,
            0,0,0,3,2,0,0,0,2,2,
            0,0,2,0,0,2,0,0,0,107,
            0,0,0,0,0,0,0,0,0,28,
            0,0,0,0,0,0,0,0,0,0,
            0,30,0,92,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,92,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,0,0,0,0,0,
            0
        };
    };
    public final static byte termCheck[] = TermCheck.termCheck;
    public final int termCheck(int index) { return termCheck[index]; }

    public interface TermAction {
        public final static char termAction[] = {0,
            5056,3103,5056,4657,5400,2221,5409,5414,5398,5399,
            5401,5402,5403,5404,5405,5406,5407,5408,5410,5411,
            5412,5413,5417,5419,5418,5416,5415,4876,5056,2223,
            1396,4871,4896,4866,4864,4861,4859,4856,4851,4846,
            4702,5157,5155,5156,5158,5159,5160,5161,5162,5163,
            4869,2347,2345,2343,2284,2282,4590,5341,5307,5070,
            5071,5072,2160,5057,5058,5059,5060,5061,5062,5063,
            5064,5065,5066,5067,5068,4886,4877,4890,4891,4895,
            4894,4670,5069,4564,2099,2404,5200,5197,5199,5201,
            5202,5204,240,712,3157,5056,3103,3913,4657,5400,
            2221,5409,5414,5398,5399,5401,5402,5403,5404,5405,
            5406,5407,5408,5410,5411,5412,5413,5417,5419,5418,
            5416,5415,4876,5056,2223,5056,4871,4896,4866,4864,
            4861,4859,4856,4851,4846,4702,5157,5155,5156,5158,
            5159,5160,5161,5162,5163,4869,2347,2345,2343,2284,
            2282,4590,5345,5332,5070,5071,5072,2160,5057,5058,
            5059,5060,5061,5062,5063,5064,5065,5066,5067,5068,
            4886,4877,4890,4891,4895,4894,4670,5069,4564,2099,
            2404,5200,5197,5199,5201,5202,5204,5056,712,3157,
            126,3103,2930,4657,5400,2221,5409,5414,5398,5399,
            5401,5402,5403,5404,5405,5406,5407,5408,5410,5411,
            5412,5413,5417,5419,5418,5416,5415,4876,5056,2223,
            219,4871,4896,4866,4864,4861,4859,4856,4851,4846,
            4702,5157,5155,5156,5158,5159,5160,5161,5162,5163,
            4869,2347,2345,2343,2284,2282,4616,36,5381,5070,
            5071,5072,2160,5057,5058,5059,5060,5061,5062,5063,
            5064,5065,5066,5067,5068,4886,4877,4890,4891,4895,
            4894,4670,5069,4564,2099,2404,5200,5197,5199,5201,
            5202,5204,5056,712,3157,4202,4164,4126,5056,3103,
            3319,4657,5400,2221,5409,5414,5398,5399,5401,5402,
            5403,5404,5405,5406,5407,5408,5410,5411,5412,5413,
            5417,5419,5418,5416,5415,4876,5276,2223,2764,4871,
            4896,4866,4864,4861,4859,4856,4851,4846,4702,5157,
            5155,5156,5158,5159,5160,5161,5162,5163,4869,2347,
            2345,2343,2284,2282,4616,5056,4668,5070,5071,5072,
            2160,5057,5058,5059,5060,5061,5062,5063,5064,5065,
            5066,5067,5068,4886,4877,4890,4891,4895,4894,4670,
            5069,4564,2099,2404,5200,5197,5199,5201,5202,5204,
            5056,712,3157,78,309,219,233,3103,3319,4657,
            5400,2221,5409,5414,5398,5399,5401,5402,5403,5404,
            5405,5406,5407,5408,5410,5411,5412,5413,5417,5419,
            5418,5416,5415,4876,3211,2223,5056,4871,4896,4866,
            4864,4861,4859,4856,4851,4846,4702,5157,5155,5156,
            5158,5159,5160,5161,5162,5163,4869,2347,2345,2343,
            2284,2282,4590,5056,601,5070,5071,5072,2160,5057,
            5058,5059,5060,5061,5062,5063,5064,5065,5066,5067,
            5068,4886,4877,4890,4891,4895,4894,4670,5069,4564,
            2099,2404,5200,5197,5199,5201,5202,5204,288,712,
            3157,5276,441,2820,4647,2531,1852,590,5286,5056,
            3103,5041,4657,5400,2221,5409,5414,5398,5399,5401,
            5402,5403,5404,5405,5406,5407,5408,5410,5411,5412,
            5413,5417,5419,5418,5416,5415,4876,5056,2223,5056,
            4871,4896,4866,4864,4861,4859,4856,4851,4846,4702,
            5157,5155,5156,5158,5159,5160,5161,5162,5163,4869,
            2347,2345,2343,2284,2282,4590,38,369,5070,5071,
            5072,2160,5057,5058,5059,5060,5061,5062,5063,5064,
            5065,5066,5067,5068,4886,4877,4890,4891,4895,4894,
            4670,5069,4564,2099,2404,5200,5197,5199,5201,5202,
            5204,5056,712,3157,4202,4164,4126,1981,142,219,
            5056,5056,5056,3103,5041,4657,5400,2221,5409,5414,
            5398,5399,5401,5402,5403,5404,5405,5406,5407,5408,
            5410,5411,5412,5413,5417,5419,5418,5416,5415,4876,
            4662,2223,5056,4871,4896,4866,4864,4861,4859,4856,
            4851,4846,4702,5157,5155,5156,5158,5159,5160,5161,
            5162,5163,4869,2347,2345,2343,2284,2282,4590,147,
            23,5070,5071,5072,2160,5057,5058,5059,5060,5061,
            5062,5063,5064,5065,5066,5067,5068,4886,4877,4890,
            4891,4895,4894,4670,5069,4564,2099,2404,5200,5197,
            5199,5201,5202,5204,5276,712,3157,221,3103,226,
            4657,5400,2221,5409,5414,5398,5399,5401,5402,5403,
            5404,5405,5406,5407,5408,5410,5411,5412,5413,5417,
            5419,5418,5416,5415,4876,5056,2223,826,4871,4896,
            4866,4864,4861,4859,4856,4851,4846,4702,5157,5155,
            5156,5158,5159,5160,5161,5162,5163,4869,2347,2345,
            2343,2284,2282,4590,219,23,5070,5071,5072,2160,
            5057,5058,5059,5060,5061,5062,5063,5064,5065,5066,
            5067,5068,4886,4877,4890,4891,4895,4894,4670,5069,
            4564,2099,2404,5200,5197,5199,5201,5202,5204,5056,
            712,3157,5056,3103,4885,4657,5400,5029,5409,5414,
            5398,5399,5401,5402,5403,5404,5405,5406,5407,5408,
            5410,5411,5412,5413,5417,5419,5418,5416,5415,4876,
            3967,2223,5056,4871,4896,4866,4864,4861,4859,4856,
            4851,4846,4702,5157,5155,5156,5158,5159,5160,5161,
            5162,5163,4869,2347,2345,2343,2284,2282,4590,3265,
            5276,5070,5071,5072,2160,5057,5058,5059,5060,5061,
            5062,5063,5064,5065,5066,5067,5068,4886,4877,4890,
            4891,4895,4894,4670,5069,4564,2099,2404,5200,5197,
            5199,5201,5202,5204,5056,712,3157,5056,3103,5056,
            4791,5400,2932,5409,5414,5398,5399,5401,5402,5403,
            5404,5405,5406,5407,5408,5410,5411,5412,5413,5417,
            5419,5418,5416,5415,4876,21,5153,5056,4871,4896,
            4866,4864,4861,4859,4856,4851,4846,4702,5157,5155,
            5156,5158,5159,5160,5161,5162,5163,4869,2347,2345,
            2343,2284,2282,4590,3427,125,5070,5071,5072,2160,
            5057,5058,5059,5060,5061,5062,5063,5064,5065,5066,
            5067,5068,4886,4877,4890,4891,4895,4894,4670,5069,
            4564,2099,2404,5200,5197,5199,5201,5202,5204,4021,
            712,3157,5056,3103,5056,658,5400,2932,5409,5414,
            5398,5399,5401,5402,5403,5404,5405,5406,5407,5408,
            5410,5411,5412,5413,5417,5419,5418,5416,5415,4876,
            20,5153,5056,4871,4896,4866,4864,4861,4859,4856,
            4851,4846,4702,5157,5155,5156,5158,5159,5160,5161,
            5162,5163,4869,2347,2345,2343,2284,2282,4590,5056,
            124,5070,5071,5072,2160,5057,5058,5059,5060,5061,
            5062,5063,5064,5065,5066,5067,5068,4886,4877,4890,
            4891,4895,4894,4670,5069,4564,2099,2404,5200,5197,
            5199,5201,5202,5204,5056,712,5056,3103,524,172,
            5400,2932,5409,5414,5398,5399,5401,5402,5403,5404,
            5405,5406,5407,5408,5410,5411,5412,5413,5417,5419,
            5418,5416,5415,4876,5339,5153,3751,4871,4896,4866,
            4864,4861,4859,4856,4851,4846,4702,5157,5155,5156,
            5158,5159,5160,5161,5162,5163,4869,2347,2345,2343,
            2284,2282,4590,5056,48,5070,5071,5072,2160,5057,
            5058,5059,5060,5061,5062,5063,5064,5065,5066,5067,
            5068,4886,4877,4890,4891,4895,4894,4670,5069,4564,
            2099,2404,5200,5197,5199,5201,5202,5204,4414,4380,
            4346,4312,365,5056,3103,4671,3589,5400,2932,5409,
            5414,5398,5399,5401,5402,5403,5404,5405,5406,5407,
            5408,5410,5411,5412,5413,5417,5419,5418,5416,5415,
            4876,5056,5153,5056,4871,4896,4866,4864,4861,4859,
            4856,4851,4846,4702,5157,5155,5156,5158,5159,5160,
            5161,5162,5163,4869,2347,2345,2343,2284,2282,4590,
            364,3049,5070,5071,5072,2160,5057,5058,5059,5060,
            5061,5062,5063,5064,5065,5066,5067,5068,4886,4877,
            4890,4891,4895,4894,4670,5069,4564,2099,2404,5200,
            5197,5199,5201,5202,5204,5056,5056,431,34,5400,
            5154,5409,5414,5398,5399,5401,5402,5403,5404,5405,
            5406,5407,5408,5410,5411,5412,5413,5417,5419,5418,
            5416,5415,4876,5394,5153,5056,4871,4909,4866,4864,
            4861,4859,4856,4851,4846,4702,5157,5155,5156,5158,
            5159,5160,5161,5162,5163,4869,5073,5074,5075,5076,
            5077,4908,5056,5322,5070,5071,5072,5079,5057,5058,
            5059,5060,5061,5062,5063,5064,5065,5066,5067,5068,
            4886,4877,4890,4891,4895,4894,4670,5069,4907,5056,
            5315,5056,2587,5400,5154,5409,5414,5398,5399,5401,
            5402,5403,5404,5405,5406,5407,5408,5410,5411,5412,
            5413,5417,5419,5418,5416,5415,4876,4075,5153,5318,
            4871,4909,4866,4864,4861,4859,4856,4851,4846,4702,
            5157,5155,5156,5158,5159,5160,5161,5162,5163,4869,
            5073,5074,5075,5076,5077,4908,5056,5390,5070,5071,
            5072,5079,4936,4969,4967,4964,4958,4959,4955,4954,
            4953,4942,4941,4938,4886,4877,4890,4891,4895,4894,
            4670,5069,4907,5056,52,19,18,5400,5154,5409,
            5414,5398,5399,5401,5402,5403,5404,5405,5406,5407,
            5408,5410,5411,5412,5413,5417,5419,5418,5416,5415,
            17,5056,5153,5304,583,123,122,5056,4414,4380,
            4346,4312,219,22,5157,5155,5156,5158,5159,5160,
            5161,5162,5163,5056,5073,5074,5075,5076,5077,4664,
            121,5056,5070,5071,5072,5079,5057,5058,5059,5060,
            5061,5062,5063,5064,5065,5066,5067,5068,5056,5056,
            5056,3697,5056,5313,5056,5069,5400,5154,5409,5414,
            5398,5399,5401,5402,5403,5404,5405,5406,5407,5408,
            5410,5411,5412,5413,5417,5419,5418,5416,5415,4876,
            50,5153,5383,4871,4909,4866,4864,4861,4859,4856,
            4851,4846,4702,5157,5155,5156,5158,5159,5160,5161,
            5162,5163,4869,5056,66,5346,5056,524,7095,242,
            2708,2038,1981,1977,4414,4380,4346,4312,64,2528,
            4919,1795,4839,437,249,4649,5056,4886,4877,4890,
            4891,4895,4894,4670,5056,1862,4536,4508,5400,5164,
            5409,5414,5398,5399,5401,5402,5403,5404,5405,5406,
            5407,5408,5410,5411,5412,5413,5417,5419,5418,5416,
            5415,5056,715,5312,5056,2164,1681,5056,4478,98,
            5056,5056,4694,326,4448,5157,5155,5156,5158,5159,
            5160,5161,5162,5163,315,5177,5178,5179,5180,5181,
            5056,597,5391,70,5400,5154,5409,5414,5398,5399,
            5401,5402,5403,5404,5405,5406,5407,5408,5410,5411,
            5412,5413,5417,5419,5418,5416,5415,5056,4682,5153,
            22,98,5276,131,4806,4536,4508,108,253,274,
            5386,5157,5155,5156,5158,5159,5160,5161,5162,5163,
            40,5374,4678,5056,2042,5372,4762,5276,5276,171,
            5056,5276,5276,5276,5276,5276,5276,5276,5276,5276,
            5276,279,5297,5056,303,5056,4776,4276,284,2103,
            5276,4240,97,4677,5375,4829,5276,5276,4700,108,
            5056,5056,2467,5055,5400,5164,5409,5414,5398,5399,
            5401,5402,5403,5404,5405,5406,5407,5408,5410,5411,
            5412,5413,5417,5419,5418,5416,5415,5196,299,5056,
            5056,5370,5276,4786,5056,5276,171,5276,284,5276,
            512,5276,5276,5276,5276,3535,5276,5276,5276,5276,
            5276,5177,5178,5179,5180,5181,5056,5056,2225,583,
            5400,5422,5409,5414,5398,5399,5401,5402,5403,5404,
            5405,5406,5407,5408,5410,5411,5412,5413,5417,5419,
            5418,5416,5415,5056,5056,5424,5314,4657,5400,2705,
            5409,5414,5398,5399,5401,5402,5403,5404,5405,5406,
            5407,5408,5410,5411,5412,5413,5417,5419,5418,5416,
            5415,5056,5056,2592,5395,5400,5422,5409,5414,5398,
            5399,5401,5402,5403,5404,5405,5406,5407,5408,5410,
            5411,5412,5413,5417,5419,5418,5416,5415,5056,3481,
            5424,4657,5400,4988,5409,5414,5398,5399,5401,5402,
            5403,5404,5405,5406,5407,5408,5410,5411,5412,5413,
            5417,5419,5418,5416,5415,5056,5056,4986,5360,5400,
            5422,5409,5414,5398,5399,5401,5402,5403,5404,5405,
            5406,5407,5408,5410,5411,5412,5413,5417,5419,5418,
            5416,5415,5056,5056,5424,5056,7463,5422,5409,5414,
            7479,5399,7453,5402,5403,5404,5405,5406,7448,5408,
            7447,5411,5412,5413,5417,5419,5418,5416,5415,5056,
            5056,5424,5147,5400,5164,5409,5414,5398,5399,5401,
            5402,5403,5404,5405,5406,5407,5408,5410,5411,5412,
            5413,5417,5419,5418,5416,5415,110,5056,5056,5056,
            5400,5164,5409,5414,5398,5399,5401,5402,5403,5404,
            5405,5406,5407,5408,5410,5411,5412,5413,5417,5419,
            5418,5416,5415,171,5056,5056,4796,5368,5367,5369,
            119,1866,68,5056,5056,44,43,1282,5056,180,
            3859,42,278,278,5056,5410,5407,269,278,5056,
            3643,5401,3697,3697,5056,583,583,583,278,5056,
            365,5400,4276,4276,4536,4508,4240,4240,4276,5367,
            5410,5407,4240,98,278,5056,5401,5398,5056,5338,
            368,5056,2286,4829,5342,5056,5400,367,109,5321,
            4671,423,366,171,180,4694,4796,583,5056,772,
            5056,829,5398,5056,886,583,5056,943,5056,1000,
            5056,1057,5056,1114,5056,1171,5056,1228,364,5056,
            1285,4922,4924,5056,1342,5056,5361,5056,1399,5056,
            5343,108,5056,1456,5056,1513,5324,5056,1570,5056,
            1627,5056,1684,92,1741,5056,4836,5056,227,5056,
            127,5056,583,5141,222,5357,1,1054,12,1923,
            11,1984,10,2045,9,2106,8,2167,7,2228,
            5,2289,6,2350,4,2411,940,5349,1798,3,
            2472,3373,3697,2,2533,111,5385,5056,455,5056,
            528,5056,5056,5056,4829,4671,4694,5056,183,5056,
            4801,5237,5056,2930,5366,5056,5176,5270,5056,5056,
            5271,5269,5056,5056,5268,5267,5056,5056,5266,5265,
            5056,5056,5264,5263,5056,5056,5262,5260,5056,5056,
            5259,5258,5056,5056,5257,5256,5056,5056,5255,5254,
            5056,5056,5253,583,5056,5056,5252,5261,5056,184,
            5251,5056,2594,5056,2651,217,658,216,1741,5056,
            1741,5056,5056,5238,5142,5056,5056,5221,5220,5056,
            5056,5219,5218,5056,5056,5217,5216,1168,5056,5056,
            5215,5214,5056,5056,5213,5212,5056,5056,5211,5288,
            238,234,5056,4811,5287,5056,5056,5056,5250,5249,
            5056,179,5225,5056,5056,5226,5056,5056,5056,3805,
            5056,5056,5056,5056,5056,5056,5056,5056,5056,2876,
            5056,5056,5056,5056,5056,5056,5056,5056,5056,5056,
            5056,322,5056,5389,5056,5056,5056,5056,5056,5056,
            5056,5056,5056,5056,5056,5056,5056,5056,5056,5056,
            5056,5056,5056,5056,5056,5056,5056,5056,5056,5056,
            5056,5056,5056,5056,5056,5056,5056,5056,5056,5056,
            5056,5056,5056,5056,5056,5056,5056,5056,5056,5056,
            5056,5056,5056,5056,5056,5056,5056,5362
        };
    };
    public final static char termAction[] = TermAction.termAction;
    public final int termAction(int index) { return termAction[index]; }

    public interface Asb {
        public final static char asb[] = {0,
            576,577,576,607,117,192,120,571,570,192,
            192,530,192,123,192,193,117,527,439,520,
            606,192,556,192,607,211,439,526,361,193,
            192,217,361,583,192,396,192,128,396,310,
            396,647,532,607,502,436,281,192,361,503,
            313,308,131,131,128,529,529,529,529,529,
            529,529,529,529,529,529,529,529,529,529,
            529,529,529,529,607,607,332,332,329,329,
            364,398,398,398,398,398,331,331,433,530,
            334,338,128,340,346,342,351,348,607,192,
            395,647,325,192,215,215,215,503,326,215,
            647,607,647,607,432,192,527,271,183,271,
            435,435,435,192,432,530,90,128,580,391,
            330,330,676,530,530,530,530,530,530,530,
            530,530,530,530,530,530,530,530,530,530,
            530,530,1,308,530,281,281,281,128,128,
            401,161,220,140,140,183,183,130,130,558,
            130,130,129,129,129,129,129,129,129,129,
            129,129,271,192,39,532,90,607,192,560,
            530,527,271,128,527,581,580,308,271,220,
            92,220,220,220,220,220,220,220,220,220,
            220,220,220,220,220,220,220,220,527,360,
            128,5,361,361,609,220,432,432,432,614,
            614,220,617,676,117,529,529,529,332,331,
            333,332,332,332,332,332,332,332,332,332,
            332,332,332,530,530,128,338,338,342,342,
            348,346,346,346,647,529,396,396,396,128,
            396,114,676,128,308,424,676,676,675,676,
            676,676,676,676,676,676,676,676,676,676,
            676,676,676,676,676,676,128,128,2,308,
            128,676,128,333,333,676,220,530,530,401,
            128,401,308,128,128,128,128,128,128,128,
            128,128,128,128,126,126,649,530,647,271,
            676,117,128,676,220,220,614,646,676,429,
            651,676,676,676,676,676,676,676,676,676,
            676,676,394,117,676,128,647,308,676,676,
            333,308,128,308,128,271,271,127,678,430,
            676,430,565,564,128,128,676
        };
    };
    public final static char asb[] = Asb.asb;
    public final int asb(int index) { return asb[index]; }

    public interface Asr {
        public final static byte asr[] = {0,
            57,94,93,3,85,63,64,65,66,67,
            68,69,70,71,72,73,74,82,59,60,
            61,51,52,53,54,55,91,62,87,88,
            86,89,90,84,1,56,83,100,29,5,
            8,9,4,10,11,12,13,14,15,16,
            17,6,18,19,20,21,7,26,25,22,
            24,23,42,43,41,44,45,46,47,48,
            49,79,80,78,77,75,76,31,50,32,
            33,34,35,36,37,38,39,40,81,27,
            0,8,9,4,10,11,12,13,14,15,
            16,17,6,18,19,20,21,7,26,25,
            22,24,23,2,5,0,28,2,0,30,
            11,0,92,30,0,2,105,3,94,93,
            85,91,87,88,86,89,90,84,1,79,
            80,78,77,75,76,27,31,50,32,33,
            34,35,36,37,38,39,40,81,56,83,
            63,64,65,66,67,68,69,70,71,72,
            73,74,82,59,60,61,51,52,53,54,
            55,62,42,43,41,44,45,46,47,48,
            49,29,9,11,12,13,14,15,17,6,
            19,20,21,7,26,25,22,24,23,5,
            16,8,10,18,4,0,92,99,0,2,
            94,85,63,64,65,66,67,68,69,70,
            71,72,73,74,82,59,60,61,29,91,
            62,87,32,88,86,89,90,79,80,78,
            77,75,76,27,31,50,33,34,35,36,
            37,38,39,40,81,1,56,83,93,3,
            42,43,41,44,45,46,47,48,49,84,
            51,52,53,54,55,8,9,4,10,11,
            12,13,14,15,16,17,6,18,19,20,
            21,7,26,25,22,24,23,5,0,58,
            1,0,111,2,57,97,95,28,102,106,
            107,108,110,30,12,92,9,0,3,58,
            98,1,96,103,104,101,99,32,33,50,
            56,34,35,36,37,27,31,38,39,40,
            2,97,95,92,106,107,108,110,109,102,
            28,57,0,50,56,32,33,34,35,27,
            36,37,31,1,57,98,97,101,99,102,
            96,103,104,106,107,108,38,39,40,109,
            95,92,110,2,28,3,0,30,98,96,
            50,56,32,33,34,35,36,37,31,97,
            101,99,102,103,104,106,107,108,38,39,
            40,109,1,2,57,92,110,27,28,95,
            0,30,58,0,3,28,111,0,94,85,
            63,64,65,66,67,68,69,70,71,72,
            73,74,82,59,60,61,51,52,53,54,
            55,42,43,41,44,45,46,47,48,49,
            91,62,87,32,88,86,89,90,84,79,
            80,78,77,75,76,27,31,50,33,34,
            35,36,37,38,39,40,81,1,56,83,
            93,3,29,22,23,24,25,26,9,11,
            12,13,14,15,17,6,19,20,5,8,
            4,10,16,18,21,7,57,0,96,1,
            0,5,29,8,9,4,10,11,12,13,
            14,15,16,17,18,19,20,21,7,26,
            25,22,24,23,3,6,0,106,0,2,
            57,92,110,58,30,27,95,28,0,14,
            19,6,17,57,0,13,112,20,0,28,
            110,0,5,29,8,9,4,10,11,12,
            13,14,16,17,6,18,19,20,21,7,
            26,25,22,24,23,15,30,0,57,28,
            3,27,0,97,28,0,50,56,32,33,
            34,35,27,36,37,31,2,57,97,101,
            28,99,102,103,104,106,107,108,38,39,
            40,109,110,58,1,95,92,0,107,0,
            95,28,50,56,32,33,34,35,27,36,
            37,31,1,98,101,99,96,103,104,38,
            39,40,109,3,58,2,0,108,0
        };
    };
    public final static byte asr[] = Asr.asr;
    public final int asr(int index) { return asr[index]; }

    public interface Nasb {
        public final static byte nasb[] = {0,
            115,93,23,23,23,122,23,54,98,110,
            84,23,122,23,112,75,23,23,14,23,
            23,122,71,102,23,77,14,23,23,75,
            106,23,23,119,119,23,84,14,23,23,
            23,23,16,23,23,23,73,105,23,23,
            23,91,30,30,14,65,65,65,65,65,
            65,65,65,65,65,65,65,65,65,65,
            65,65,65,65,23,23,65,23,23,23,
            23,23,23,23,23,23,65,65,23,23,
            1,23,14,23,23,23,23,23,23,122,
            23,23,23,88,11,11,11,121,23,23,
            23,23,23,23,23,122,23,74,69,74,
            23,23,23,122,23,23,23,14,117,23,
            23,23,23,23,23,23,23,23,23,23,
            23,23,23,23,23,23,23,23,23,23,
            23,23,14,82,23,73,73,73,14,14,
            23,68,14,4,67,69,69,49,49,23,
            44,44,34,34,39,39,39,39,24,29,
            29,29,74,122,8,16,23,23,122,23,
            23,23,74,14,23,23,23,91,74,14,
            75,14,14,14,14,14,14,14,14,14,
            14,14,14,14,14,14,14,14,23,23,
            14,30,23,23,23,14,23,23,23,23,
            23,14,23,23,23,65,65,65,65,65,
            65,23,23,23,23,23,23,23,23,23,
            23,23,23,23,23,14,23,23,23,23,
            23,23,23,23,23,65,23,23,23,14,
            23,108,23,14,91,23,23,23,23,23,
            23,23,23,23,23,23,23,23,23,23,
            23,23,23,23,23,23,14,14,14,90,
            14,23,14,65,65,23,14,23,23,23,
            14,23,91,13,13,13,13,13,13,13,
            13,13,13,13,14,14,23,23,23,74,
            23,23,14,23,14,14,23,23,23,23,
            23,23,23,23,23,23,23,23,23,23,
            23,23,23,23,23,14,23,91,23,23,
            65,91,14,91,14,73,74,14,23,23,
            23,23,23,23,14,14,23
        };
    };
    public final static byte nasb[] = Nasb.nasb;
    public final int nasb(int index) { return nasb[index]; }

    public interface Nasr {
        public final static char nasr[] = {0,
            81,82,0,5,7,9,0,5,8,0,
            63,0,57,6,4,1,39,42,44,48,
            46,45,0,6,1,4,50,0,37,6,
            1,4,0,6,1,4,35,0,6,1,
            4,31,0,6,1,4,29,0,6,1,
            4,26,0,118,110,108,113,116,129,128,
            131,103,104,0,54,0,87,7,5,0,
            79,0,59,4,2,0,123,121,114,115,
            0,86,0,75,74,76,73,65,0,69,
            57,0,100,98,97,96,0,105,107,101,
            0,120,111,0,126,78,0,91,0,95,
            0,58,130,0,94,0,93,0,77,0,
            124,58,0
        };
    };
    public final static char nasr[] = Nasr.nasr;
    public final int nasr(int index) { return nasr[index]; }

    public interface TerminalIndex {
        public final static char terminalIndex[] = {0,
            12,13,21,100,116,109,114,98,99,101,
            102,103,104,105,106,107,108,110,111,112,
            113,36,37,38,41,42,8,20,35,14,
            11,4,5,6,7,9,10,47,48,49,
            87,88,89,90,91,93,94,95,96,2,
            62,63,64,65,66,3,15,22,56,57,
            58,59,67,68,69,70,71,72,73,74,
            75,76,77,78,79,80,81,82,83,84,
            85,86,50,92,31,32,33,34,54,55,
            97,23,52,43,19,26,17,16,24,117,
            18,25,27,28,29,44,45,46,51,53,
            1,115,39,40,60,61,118
        };
    };
    public final static char terminalIndex[] = TerminalIndex.terminalIndex;
    public final int terminalIndex(int index) { return terminalIndex[index]; }

    public interface NonterminalIndex {
        public final static char nonterminalIndex[] = {0,
            203,121,0,145,122,119,120,142,143,137,
            139,0,0,0,0,0,0,0,0,0,
            0,0,0,0,0,138,0,135,136,132,
            133,134,0,130,131,128,129,195,201,0,
            0,202,204,205,207,208,209,210,126,127,
            124,125,0,0,144,0,123,161,154,151,
            152,0,194,158,172,147,0,149,153,0,
            0,157,163,171,173,174,175,179,180,0,
            140,141,0,0,146,148,150,0,0,0,
            155,0,156,0,159,160,162,164,165,166,
            167,168,169,170,176,177,178,181,182,183,
            184,185,186,187,188,189,190,191,192,193,
            196,197,198,199,200,206,211,212,213,214,
            215,0,0,0,0,0,0,0,0
        };
    };
    public final static char nonterminalIndex[] = NonterminalIndex.nonterminalIndex;
    public final int nonterminalIndex(int index) { return nonterminalIndex[index]; }

    public interface ScopePrefix {
        public final static char scopePrefix[] = {
            199,33,227,306,207,21,28,74,79,84,
            89,94,99,104,109,114,119,124,129,134,
            139,144,149,154,159,164,169,174,179,42,
            17,184,188,247,251,255,259,263,267,271,
            275,279,283,287,291,295,312,60,67,192,
            233,299,67,217,217,303,51,1,11,15,
            240,316,316,324,324,332,332,332,332,346,
            346,354,354,354,5,240
        };
    };
    public final static char scopePrefix[] = ScopePrefix.scopePrefix;
    public final int scopePrefix(int index) { return scopePrefix[index]; }

    public interface ScopeSuffix {
        public final static char scopeSuffix[] = {
            26,40,26,26,213,26,26,26,26,26,
            26,26,26,26,26,26,26,26,26,26,
            26,26,26,26,26,26,26,26,26,47,
            3,26,26,26,26,26,26,26,26,26,
            26,26,26,26,3,3,26,64,71,196,
            237,71,71,213,221,26,54,3,13,3,
            237,318,321,326,329,334,337,340,343,348,
            351,356,359,362,7,242
        };
    };
    public final static char scopeSuffix[] = ScopeSuffix.scopeSuffix;
    public final int scopeSuffix(int index) { return scopeSuffix[index]; }

    public interface ScopeLhs {
        public final static char scopeLhs[] = {
            89,33,89,11,89,82,82,9,8,8,
            8,8,8,8,8,8,8,8,8,8,
            8,8,8,8,8,8,8,68,68,33,
            38,62,59,88,88,88,88,88,88,88,
            88,88,88,88,17,16,11,27,70,57,
            60,13,13,89,89,12,33,41,46,40,
            60,29,29,31,31,35,35,35,35,37,
            37,50,50,50,41,60
        };
    };
    public final static char scopeLhs[] = ScopeLhs.scopeLhs;
    public final int scopeLhs(int index) { return scopeLhs[index]; }

    public interface ScopeLa {
        public final static byte scopeLa[] = {
            2,108,2,2,95,2,2,2,2,2,
            2,2,2,2,2,2,2,2,2,2,
            2,2,2,2,2,2,2,2,2,107,
            57,2,2,2,2,2,2,2,2,2,
            2,2,2,2,57,57,2,110,97,27,
            95,97,97,95,92,2,106,57,30,57,
            95,33,32,56,50,37,36,35,34,31,
            27,40,39,38,111,28
        };
    };
    public final static byte scopeLa[] = ScopeLa.scopeLa;
    public final int scopeLa(int index) { return scopeLa[index]; }

    public interface ScopeStateSet {
        public final static char scopeStateSet[] = {
            2,51,2,44,2,4,4,43,41,41,
            41,41,41,41,41,41,41,41,41,41,
            41,41,41,41,41,41,41,1,1,51,
            126,32,28,2,2,2,2,2,2,2,
            2,2,2,2,44,44,44,47,1,6,
            114,44,44,2,2,44,51,126,126,126,
            114,49,49,51,51,55,55,55,55,57,
            57,60,60,60,126,114
        };
    };
    public final static char scopeStateSet[] = ScopeStateSet.scopeStateSet;
    public final int scopeStateSet(int index) { return scopeStateSet[index]; }

    public interface ScopeRhs {
        public final static char scopeRhs[] = {0,
            163,0,15,0,165,0,1,161,15,0,
            162,0,14,0,161,0,168,30,156,0,
            188,1,122,104,0,13,0,188,1,122,
            103,0,168,107,168,106,168,94,0,46,
            0,168,106,168,94,0,45,124,46,0,
            168,94,0,44,124,45,124,46,0,209,
            174,93,0,53,124,0,172,98,122,0,
            17,0,0,173,1,171,124,0,173,1,
            171,40,0,173,1,171,39,0,173,1,
            171,38,0,173,1,171,37,0,173,1,
            171,36,0,173,1,171,35,0,173,1,
            171,34,0,173,1,171,33,0,173,1,
            171,32,0,173,1,171,50,0,173,1,
            171,31,0,173,1,171,27,0,173,1,
            171,76,0,173,1,171,75,0,173,1,
            171,77,0,173,1,171,78,0,173,1,
            171,80,0,173,1,171,79,0,173,1,
            171,122,0,173,1,171,83,0,173,1,
            171,56,0,207,1,84,0,178,1,121,
            0,178,3,5,0,8,124,0,168,95,
            174,92,174,1,63,0,174,92,174,1,
            63,0,19,124,13,0,174,1,63,0,
            23,123,19,124,13,0,168,95,174,1,
            63,0,174,28,174,0,19,124,0,174,
            0,20,123,19,124,0,177,1,74,0,
            177,1,73,0,177,1,72,0,177,1,
            71,0,177,1,70,0,177,1,69,0,
            177,1,67,0,177,1,68,0,177,1,
            66,0,177,1,65,0,177,1,64,0,
            203,30,84,0,201,30,121,0,172,98,
            123,0,168,1,0,173,1,122,58,119,
            0,173,1,85,0,145,0,5,138,0,
            4,138,0,149,0,3,136,0,2,136,
            0,151,0,10,133,0,9,133,0,7,
            133,0,6,133,0,153,0,11,131,0,
            8,131,0,166,0,49,129,0,48,129,
            0,47,129,0
        };
    };
    public final static char scopeRhs[] = ScopeRhs.scopeRhs;
    public final int scopeRhs(int index) { return scopeRhs[index]; }

    public interface ScopeState {
        public final static char scopeState[] = {0,
            441,4647,0,440,0,1396,1282,1168,2533,2472,
            2411,2350,2289,2228,2167,2106,2045,1984,1923,1054,
            4700,940,4836,826,4662,712,0,4829,4694,4671,
            4657,4811,4806,4801,4796,4791,4786,4776,4762,0,
            512,4647,441,4616,4590,4564,4536,4508,4478,4448,
            4414,4380,4346,4312,4276,4240,4202,4164,4126,4021,
            3967,2876,3913,3859,3805,2651,2594,3751,528,455,
            2820,1866,3697,3643,1798,3589,3535,3481,3427,3373,
            1741,1684,3319,1627,1570,1513,1456,1399,1342,1285,
            1228,1171,1114,1057,1000,943,886,829,772,715,
            658,3265,4075,601,2764,2708,369,3211,3157,3103,
            3049,2995,2941,2533,2472,2411,2350,2289,2228,2167,
            2106,2045,1984,1923,0,4021,3967,2876,3913,3859,
            3805,2651,2594,3751,528,455,2533,2472,2411,2350,
            2289,2228,2167,2106,2045,1984,1923,2820,1866,3697,
            3643,1798,3589,3535,3481,3427,3373,1741,1684,3319,
            1627,1570,1513,1456,1399,1342,1285,1228,1171,1114,
            1057,1000,943,886,829,772,715,658,3265,4666,
            601,2764,2708,369,3211,3157,3103,4645,3049,2995,
            2941,0
        };
    };
    public final static char scopeState[] = ScopeState.scopeState;
    public final int scopeState(int index) { return scopeState[index]; }

    public interface InSymb {
        public final static char inSymb[] = {0,
            0,197,211,216,214,20,215,219,217,13,
            28,175,11,248,245,17,246,236,233,230,
            225,6,19,227,226,229,235,234,224,14,
            222,212,193,191,192,182,1,30,175,119,
            2,168,164,162,163,165,3,160,161,159,
            156,93,83,56,1,124,81,40,39,38,
            37,36,35,34,33,50,31,27,76,75,
            77,78,80,79,121,84,32,62,118,5,
            29,55,54,53,52,51,123,122,119,85,
            128,145,94,149,153,151,169,166,21,15,
            237,242,238,4,18,10,8,240,239,16,
            168,7,57,223,119,99,168,3,58,3,
            29,118,5,111,119,121,195,30,174,5,
            118,5,168,171,171,171,171,171,171,171,
            171,171,171,171,171,171,171,171,171,171,
            171,171,30,30,171,3,3,3,98,98,
            171,58,1,99,101,104,103,33,32,168,
            56,50,31,27,37,36,35,34,109,40,
            39,38,3,28,12,182,175,9,4,119,
            84,175,1,27,168,209,210,28,3,1,
            1,1,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,1,1,201,168,
            100,56,202,203,5,1,119,119,119,172,
            172,1,122,173,172,83,56,32,124,122,
            124,63,74,73,72,71,70,69,67,68,
            66,65,64,122,122,106,145,145,151,151,
            166,153,153,153,178,122,29,118,5,27,
            175,1,178,110,28,178,173,200,119,173,
            173,173,173,173,173,173,173,173,173,173,
            173,173,173,173,173,173,102,100,28,28,
            27,173,28,97,97,173,1,171,171,171,
            98,171,1,1,1,1,1,1,1,1,
            1,1,1,1,1,1,168,171,168,3,
            207,208,27,173,1,1,172,174,177,174,
            5,177,177,177,177,177,177,177,177,177,
            177,188,105,189,188,107,178,28,173,173,
            97,92,95,28,95,3,3,28,168,174,
            168,174,176,119,95,95,168
        };
    };
    public final static char inSymb[] = InSymb.inSymb;
    public final int inSymb(int index) { return inSymb[index]; }

    public interface Name {
        public final static String name[] = {
            "",
            "++",
            "+",
            "-",
            "*",
            "/",
            ">",
            "<",
            "=",
            ">=",
            "<=",
            "<>",
            "(",
            ")",
            "{",
            "}",
            "[",
            "]",
            "->",
            "|",
            ",",
            ":",
            "::",
            ";",
            ".",
            "..",
            "@pre",
            "^",
            "^^",
            "?",
            "$empty",
            "NUMERIC_OPERATION",
            "STRING_LITERAL",
            "INTEGER_LITERAL",
            "REAL_LITERAL",
            "self",
            "inv",
            "pre",
            "post",
            "context",
            "package",
            "endpackage",
            "def",
            "if",
            "then",
            "else",
            "endif",
            "and",
            "or",
            "xor",
            "not",
            "implies",
            "let",
            "in",
            "true",
            "false",
            "body",
            "derive",
            "init",
            "null",
            "attr",
            "oper",
            "Set",
            "Bag",
            "Sequence",
            "Collection",
            "OrderedSet",
            "iterate",
            "forAll",
            "exists",
            "isUnique",
            "any",
            "one",
            "collect",
            "select",
            "reject",
            "collectNested",
            "sortedBy",
            "closure",
            "oclIsKindOf",
            "oclIsTypeOf",
            "oclAsType",
            "oclIsNew",
            "oclIsUndefined",
            "oclIsInvalid",
            "oclIsInState",
            "allInstances",
            "String",
            "Integer",
            "UnlimitedNatural",
            "Real",
            "Boolean",
            "Tuple",
            "OclAny",
            "OclVoid",
            "Invalid",
            "OclMessage",
            "OclInvalid",
            "checkonly",
            "default_values",
            "domain",
            "enforce",
            "extends",
            "implementedby",
            "import",
            "key",
            "overrides",
            "primitive",
            "query",
            "relation",
            "replace",
            "top",
            "transformation",
            "when",
            "where",
            "EOF_TOKEN",
            "IDENTIFIER",
            "INTEGER_RANGE_START",
            "ERROR_TOKEN",
            "keywordAsIdentifier1",
            "keywordAsIdentifier",
            "pathNameCS",
            "simpleNameCS",
            "variableCS",
            "oclExpressionCS",
            "impliesExpCS",
            "andOrXorExpCS",
            "andOrXorWithLet",
            "equalityExpCS",
            "equalityWithLet",
            "relationalExpCS",
            "relationalWithLet",
            "ifExpCSPrec",
            "additiveWithLet",
            "additiveExpCS",
            "multiplicativeExpCS",
            "multiplicativeWithLet",
            "unaryExpCS",
            "unaryWithLet",
            "dotArrowExpCS",
            "callExpCS",
            "messageExpCS",
            "operationCallExpCS",
            "keywordOperationCallExpCS",
            "argumentsCS",
            "collectionTypeIdentifierCS",
            "collectionLiteralPartsCS",
            "collectionLiteralPartCS",
            "variableListCS2",
            "featureCallExpCS",
            "loopExpCS",
            "iterContents",
            "typeCS",
            "variableCS2",
            "collectionTypeCS",
            "variableListCS",
            "letExpSubCS",
            "oclMessageArgumentsCS",
            "oclMessageArgCS",
            "unitCS",
            "transformationCS",
            "identifierCS",
            "transformationCS_0_",
            "modelDeclCS",
            "transformationCS_1_",
            "transformationCS_2_",
            "transformationCS_3_",
            "keyDeclCS",
            "transformationCS_4_",
            "queryCS",
            "relationCS",
            "modelDeclCS_0_",
            "modelIdCS",
            "modelDeclCS_1_",
            "modelDeclCS_2_",
            "metaModelIdCS",
            "keyDeclCS_0_",
            "classIdCS",
            "keyDeclCS_1_",
            "propertyIdCS",
            "relationCS_0_",
            "relationCS_1_",
            "relationCS_2_",
            "relationCS_3_",
            "varDeclarationCS",
            "relationCS_preDomain",
            "relationCS_postDomain",
            "domainCS",
            "primitiveTypeDomainCS",
            "relationCS_preWhenExpression",
            "relationCS_postWhen",
            "relationCS_preWhereExpression",
            "relationCS_postWhere",
            "varDeclarationCS_0",
            "domainCS_0_",
            "templateCS",
            "domainCS_1_",
            "domainCS_postImplementedby",
            "domainCS_preDefaultValue",
            "defaultValueCS",
            "domainCS_postDefaultValues",
            "templateCS_0_",
            "objectTemplateCS_prePropertyTe" +
            "mplates",
            "relationIdentifier",
            "objectTemplateCS_prePropertyTe" +
            "mplate",
            "objectTemplateCS_postPropertyT" +
            "emplate",
            "propertyTemplateCS",
            "collectionTemplateCS_1_",
            "collectionTemplateCS_preMember" +
            "Selections",
            "collectionTemplateCS_preMember" +
            "Selection",
            "collectionTemplateCS_postMembe" +
            "rSelection",
            "memberSelectorCS",
            "queryCS_preParamDeclaration",
            "queryCS_postParamDeclaration",
            "paramDeclarationCS",
            "queryCS_postType"
        };
    };
    public final static String name[] = Name.name;
    public final String name(int index) { return name[index]; }

    public final static int
           ERROR_SYMBOL      = 117,
           SCOPE_UBOUND      = 75,
           SCOPE_SIZE        = 76,
           MAX_NAME_LENGTH   = 40;

    public final int getErrorSymbol() { return ERROR_SYMBOL; }
    public final int getScopeUbound() { return SCOPE_UBOUND; }
    public final int getScopeSize() { return SCOPE_SIZE; }
    public final int getMaxNameLength() { return MAX_NAME_LENGTH; }

    public final static int
           NUM_STATES        = 377,
           NT_OFFSET         = 117,
           LA_STATE_OFFSET   = 5424,
           MAX_LA            = 2,
           NUM_RULES         = 368,
           NUM_NONTERMINALS  = 139,
           NUM_SYMBOLS       = 256,
           SEGMENT_SIZE      = 8192,
           START_STATE       = 4849,
           IDENTIFIER_SYMBOL = 5,
           EOFT_SYMBOL       = 112,
           EOLT_SYMBOL       = 112,
           ACCEPT_ACTION     = 5055,
           ERROR_ACTION      = 5056;

    public final static boolean BACKTRACK = false;

    public final int getNumStates() { return NUM_STATES; }
    public final int getNtOffset() { return NT_OFFSET; }
    public final int getLaStateOffset() { return LA_STATE_OFFSET; }
    public final int getMaxLa() { return MAX_LA; }
    public final int getNumRules() { return NUM_RULES; }
    public final int getNumNonterminals() { return NUM_NONTERMINALS; }
    public final int getNumSymbols() { return NUM_SYMBOLS; }
    public final int getSegmentSize() { return SEGMENT_SIZE; }
    public final int getStartState() { return START_STATE; }
    public final int getStartSymbol() { return lhs[0]; }
    public final int getIdentifierSymbol() { return IDENTIFIER_SYMBOL; }
    public final int getEoftSymbol() { return EOFT_SYMBOL; }
    public final int getEoltSymbol() { return EOLT_SYMBOL; }
    public final int getAcceptAction() { return ACCEPT_ACTION; }
    public final int getErrorAction() { return ERROR_ACTION; }
    public final boolean isValidForParser() { return isValidForParser; }
    public final boolean getBacktrack() { return BACKTRACK; }

    public final int originalState(int state) {
        return -baseCheck[state];
    }
    public final int asi(int state) {
        return asb[originalState(state)];
    }
    public final int nasi(int state) {
        return nasb[originalState(state)];
    }
    public final int inSymbol(int state) {
        return inSymb[originalState(state)];
    }

    public final int ntAction(int state, int sym) {
        return baseAction[state + sym];
    }

    public final int tAction(int state, int sym) {
        int i = baseAction[state],
            k = i + sym;
        return termAction[termCheck[k] == sym ? k : i];
    }
    public final int lookAhead(int la_state, int sym) {
        int k = la_state + sym;
        return termAction[termCheck[k] == sym ? k : la_state];
    }
}
