/*******************************************************************************
 * Copyright (c) 2007 E.D.Willink and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     E.D.Willink - initial API and implementation
 *******************************************************************************/
package org.eclipse.gmt.umlx.eqvt.tests;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.qvt.declarative.ecore.adapters.AdaptingEObject;
import org.eclipse.qvt.declarative.emof.EMOF.NamedElement;

@Deprecated // use MappingUtils
public class EcoreNames
{
	public static String formatFeatureName(EStructuralFeature eFeature) {
		return formatLocalName(eFeature.eContainer()) + "." + formatLocalName(eFeature);
	}

	public static String formatFullName(Object object) {
		Object container = null;
		if (object instanceof EObject)
			container = ((EObject) object).eContainer();
		if (container != null)
			return formatFullName(container) + "/" + formatLocalName(object);
		else
			return "/" + formatLocalName(object);
	}

	public static String formatLocalName(Object object) {
		if (object instanceof AdaptingEObject)
			object = ((AdaptingEObject) object).getTarget();
		if (object == null)
			return "null-object";
		else if ((object instanceof EObject) && ((EObject)object).eIsProxy())
			return formatString(EcoreUtil.getURI((EObject)object));
		else if (object instanceof ENamedElement)
			return formatString(((ENamedElement)object).getName());
		else if (object instanceof NamedElement)
			return formatString(((NamedElement)object).getName());
		else if (object instanceof Boolean)
			return "Boolean:" + object.toString();
		else if (object instanceof Integer)
			return "Integer:" + object.toString();
		else if (object instanceof String)
			return "String:'" + object + "'";
		else if (object instanceof EAnnotation)
			return "EAnnotation:'" + ((EAnnotation)object).getSource() + "'";
		else
			return "Class:" + object.getClass().getSimpleName();
	}

	public static String formatString(Object object) {
		if (object != null)
			return object.toString();
		else
			return "null-string";
	}
}
