package org.eclipse.gmt.umlx.eqvtc.tests;

import junit.framework.Test;
import junit.framework.TestSuite;

import org.eclipse.gmt.umlx.eqvtc.tests.editor.QVTcEditingTests;
import org.eclipse.gmt.umlx.eqvtc.tests.mapping.QVTCoreMapperTest;
import org.eclipse.gmt.umlx.eqvtc.tests.parser.AnalyzerErrorTests;
import org.eclipse.gmt.umlx.eqvtc.tests.parser.ParserErrorTests;
import org.eclipse.gmt.umlx.eqvtc.tests.parser.QVTcParseTests;
import org.eclipse.gmt.umlx.eqvtc.tests.parser.QVTcUnparseTests;

public class AllQVTcoreTests
{
	public static void buildEditingSuite(TestSuite suite) {
		suite.addTestSuite(QVTcEditingTests.class);
	}

	public static void buildSuite(TestSuite suite) {
		suite.addTestSuite(QVTCoreConsistencyTest.class);
		suite.addTestSuite(QVTCoreMapperTest.class);
		suite.addTestSuite(AnalyzerErrorTests.class);
//		suite.addTestSuite(LexerErrorTests.class);
		suite.addTestSuite(ParserErrorTests.class);
		suite.addTestSuite(QVTcParseTests.class);
		suite.addTestSuite(QVTcUnparseTests.class);
	}

	public static Test suite() {
		TestSuite suite = new TestSuite("All QVTcore Tests");
		buildSuite(suite);
		return suite;
	}
}
