/*******************************************************************************
 * Copyright (c) 2007 E.D.Willink and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     E.D.Willink - initial API and implementation
 *******************************************************************************/
package org.eclipse.gmt.umlx.eqvtc.tests.parser;

import java.io.IOException;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.qvt.declarative.ecore.mappings.MappingConfigurationException;

public class QVTcUnparseTests extends AbstractQVTcTestCase
{
	public void testUnparseEqvtCore_test() throws IOException, CoreException, MappingConfigurationException {
		unparserTest("test", false);
	}

	public void testUnparseQvtcore_test() throws IOException, CoreException, MappingConfigurationException {
		unparserTest("test", true);
	}

	public void testUnparseEqvtcore_Rule4b() throws IOException, CoreException, MappingConfigurationException {
		unparserTest("Rule4b", false);
	}

	public void testUnparseEqvtcore_Rule6() throws IOException, CoreException, MappingConfigurationException {
		unparserTest("Rule6", false);
	}
	
	public void testUnparseEqvtCore_multimaps() throws IOException, CoreException, MappingConfigurationException {
		unparserTest("multimaps", false);
	}

}
