<?xml version="1.0" encoding="UTF-8"?>
<!-- Generated by NiceXSL 2.0.5 at Wed Mar 29 20:51:10 BST 2006 -->
<!--
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
- - Copyright (c) 2006 E.D.Willink and others.
- - All rights reserved. This program and the accompanying materials
- - are made available under the terms of the Eclipse Public License v1.0
- - which accompanies this distribution, and is available at
- - http://www.eclipse.org/legal/epl-v10.html
- -
- - Contributors:
- -     E.D.Willink - initial API and implementation
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 
This stylesheet contains utility functions.
-->
<xsl:stylesheet xmlns:utilities="http://www.eclipse.org/gmt/umlx/utilities.nxsl" xmlns:xmi="http://www.omg.org/XMI" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" exclude-result-prefixes="utilities" version="2.0">
    <xsl:template match="/ | * | @*" mode="Unexpected">
        <xsl:param name="mode"/>
        <xsl:param name="new-line" select="' '"/>
        <xsl:variable name="dot-id">
            <xsl:call-template name="write-identity">
                <xsl:with-param name="new-line" select="$new-line"/>
            </xsl:call-template>
        </xsl:variable>
        <xsl:call-template name="error">
            <xsl:with-param name="error" select="concat('Unsupported ', $dot-id, ' in mode=', $mode)"/>
        </xsl:call-template>
        <xsl:element name="{concat('error-', $mode)}">
            <xsl:attribute name="dot">
                <xsl:value-of select="$dot-id"/>
            </xsl:attribute>
        </xsl:element>
    </xsl:template>
    <xsl:function as="xs:string" name="utilities:get-domain-name">
        <xsl:param as="element()" name="node"/>
        <xsl:choose>
            <xsl:when test="$node/@name != ''">
                <xsl:sequence select="$node/@name"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:sequence select="concat(generate-id($node), '-domain')"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:function>
    <xsl:function as="xs:string" name="utilities:get-variable-name">
        <xsl:param as="element()" name="node"/>
        <xsl:choose>
            <xsl:when test="$node/@name != ''">
                <xsl:sequence select="$node/@name"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:sequence select="concat(generate-id($node), '-variable')"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:function>
    <xsl:function as="element()?" name="utilities:get-id">
        <xsl:param as="element()" name="node"/>
        <xsl:param as="xs:string" name="xmi-id-ref"/>
        <xsl:choose>
            <xsl:when test="contains($xmi-id-ref, ' ')">
                <xsl:variable as="xs:string" name="ecore-class" select="substring-before($xmi-id-ref, ' ')"/>
                <xsl:variable as="xs:string" name="ecore-doc-ref" select="substring-after($xmi-id-ref, ' ')"/>
                <xsl:variable as="xs:string" name="ecore-doc-name" select="substring-before($ecore-doc-ref, '#')"/>
                <xsl:variable as="xs:string" name="xmi-id" select="substring-after($ecore-doc-ref, '#')"/>
                <xsl:variable as="document-node()" name="ecore-doc" select="document($ecore-doc-name, $node)"/>
                <xsl:for-each select="$ecore-doc/*">
                    <xsl:variable as="element()?" name="used-element" select="key('xmi-id', $xmi-id)"/>
                    <xsl:sequence select="$used-element"/>
                </xsl:for-each>
            </xsl:when>
            <xsl:otherwise>
                <xsl:variable as="xs:string" name="ecore-doc-name" select="substring-before($xmi-id-ref, '#')"/>
                <xsl:variable as="xs:string" name="xmi-id" select="substring-after($xmi-id-ref, '#')"/>
                <xsl:variable as="document-node()" name="ecore-doc" select="document($ecore-doc-name, $node)"/>
                <xsl:for-each select="$ecore-doc/*">
                    <xsl:variable as="element()?" name="used-element" select="key('xmi-id', $xmi-id)"/>
                    <xsl:sequence select="$used-element"/>
                </xsl:for-each>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:function>
    <xsl:function as="element()*" name="utilities:get-ids">
        <xsl:param as="element()" name="node"/>
        <xsl:param as="xs:string*" name="xmi-id-refs"/>
        <xsl:for-each select="$xmi-id-refs">
            <xsl:variable name="xmi-id-ref" select="."/>
            <xsl:choose>
                <xsl:when test="contains($xmi-id-ref, ' ')">
                    <xsl:variable as="xs:string" name="ecore-class" select="substring-before($xmi-id-ref, ' ')"/>
                    <xsl:variable as="xs:string" name="ecore-doc-ref" select="substring-after($xmi-id-ref, ' ')"/>
                    <xsl:variable as="xs:string" name="ecore-doc-name" select="substring-before($ecore-doc-ref, '#')"/>
                    <xsl:variable as="xs:string" name="xmi-id" select="substring-after($ecore-doc-ref, '#')"/>
                    <xsl:variable as="document-node()" name="ecore-doc" select="document($ecore-doc-name, $node)"/>
                    <xsl:for-each select="$ecore-doc/*">
                        <xsl:variable as="element()?" name="used-element" select="key('xmi-id', $xmi-id)"/>
                        <xsl:sequence select="$used-element"/>
                    </xsl:for-each>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:for-each select="$node">
                        <xsl:variable as="xs:string" name="xmi-id" select="substring-after($xmi-id-ref, '#')"/>
                        <xsl:variable as="element()?" name="used-element" select="key('xmi-id', $xmi-id)"/>
                        <xsl:sequence select="$used-element"/>
                    </xsl:for-each>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:for-each>
    </xsl:function>
    <xsl:function as="element()?" name="utilities:get-used-element">
        <xsl:param as="element()" name="doc"/>
        <xsl:param as="element()" name="dot"/>
        <xsl:sequence select="utilities:get-id($doc, $dot/@type)"/>
    </xsl:function>
    <xsl:function name="utilities:just-one">
        <xsl:param as="element()*" name="node"/>
        <xsl:param as="xs:string" name="context"/>
        <xsl:choose>
            <xsl:when test="count($node) &lt; 1">
                <xsl:call-template name="error">
                    <xsl:with-param name="error" select="concat(&quot;Missing instance while &quot;, $context)"/>
                </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
                <xsl:if test="count($node) &gt; 1">
                    <xsl:variable name="error-text">Multiple instances while <xsl:value-of select="$context"/>
                        <xsl:for-each select="$node">
                            <xsl:variable name="dot-id">
                                <xsl:call-template name="write-identity"/>
                            </xsl:variable>
                            <xsl:value-of select="'#  '"/>
                            <xsl:value-of select="$dot-id"/>
                        </xsl:for-each>
                    </xsl:variable>
                    <xsl:call-template name="error">
                        <xsl:with-param name="error" select="$error-text"/>
                    </xsl:call-template>
                </xsl:if>
            </xsl:otherwise>
        </xsl:choose>
        <xsl:sequence select="$node[1]"/>
    </xsl:function>
    <xsl:function name="utilities:upto-one">
        <xsl:param as="element()*" name="node"/>
        <xsl:param as="xs:string" name="context"/>
        <xsl:if test="count($node) &gt; 1">
            <xsl:call-template name="error">
                <xsl:with-param name="error" select="concat(&quot;Multiple instances while &quot;, $context)"/>
            </xsl:call-template>
        </xsl:if>
        <xsl:sequence select="$node[1]"/>
    </xsl:function>
    <xsl:function name="utilities:at-least-one">
        <xsl:param as="element()*" name="nodes"/>
        <xsl:param as="xs:string" name="context"/>
        <xsl:if test="count($nodes) &lt; 1">
            <xsl:call-template name="error">
                <xsl:with-param name="error" select="concat(&quot;No instances while &quot;, $context)"/>
            </xsl:call-template>
        </xsl:if>
        <xsl:sequence select="$nodes"/>
    </xsl:function>
    <xsl:template name="diagnostic">
        <xsl:param as="xs:string" name="text"/>
        <xsl:param as="xs:string" name="prefix" select="''"/>
        <xsl:param as="xs:string" name="continuation" select="'  '"/>
        <xsl:param as="xs:boolean" name="terminate" select="false()"/>
        <xsl:choose>
            <xsl:when test="contains($text, '#')">
                <xsl:call-template name="diagnostic">
                    <xsl:with-param name="text" select="substring-before($text, '#')"/>
                    <xsl:with-param name="prefix" select="$prefix"/>
                    <xsl:with-param name="continuation" select="$continuation"/>
                </xsl:call-template>
                <xsl:call-template name="diagnostic">
                    <xsl:with-param name="text" select="substring-after($text, '#')"/>
                    <xsl:with-param name="prefix" select="$continuation"/>
                    <xsl:with-param name="continuation" select="$continuation"/>
                    <xsl:with-param name="terminate" select="$terminate"/>
                </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
                <xsl:choose>
                    <xsl:when test="$terminate">
                        <xsl:message terminate="yes">
                            <xsl:value-of disable-output-escaping="yes" select="concat($prefix, $text)"/>
                        </xsl:message>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:message>
                            <xsl:value-of disable-output-escaping="yes" select="concat($prefix, $text)"/>
                        </xsl:message>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template name="error">
        <xsl:param as="xs:string" name="error"/>
        <xsl:param as="xs:string" name="prefix" select="'ERROR -- '"/>
        <xsl:param name="continuation" select="'  '"/>
        <xsl:call-template name="diagnostic">
            <xsl:with-param name="text" select="$error"/>
            <xsl:with-param name="prefix" select="$prefix"/>
            <xsl:with-param name="continuation" select="$continuation"/>
        </xsl:call-template>
    </xsl:template>
    <xsl:template name="fatal-error">
        <xsl:param as="xs:string" name="error"/>
        <xsl:param as="xs:string" name="prefix" select="'FATAL-ERROR -- '"/>
        <xsl:param name="continuation" select="'  '"/>
        <xsl:call-template name="diagnostic">
            <xsl:with-param name="text" select="$error"/>
            <xsl:with-param name="prefix" select="$prefix"/>
            <xsl:with-param name="continuation" select="$continuation"/>
            <xsl:with-param name="terminate" select="true()"/>
        </xsl:call-template>
    </xsl:template>
    <xsl:template name="terminate">
        <xsl:message terminate="yes"/>
    </xsl:template>
    <xsl:template name="warning">
        <xsl:param as="xs:string" name="warning"/>
        <xsl:param as="xs:string" name="prefix" select="'WARNING -- '"/>
        <xsl:param name="continuation" select="'  '"/>
        <xsl:call-template name="diagnostic">
            <xsl:with-param name="text" select="$warning"/>
            <xsl:with-param name="prefix" select="$prefix"/>
            <xsl:with-param name="continuation" select="$continuation"/>
        </xsl:call-template>
    </xsl:template>
    <xsl:template as="node()*" name="utilities:namespaces">
        <xsl:param as="node()*" name="nodes"/>
        <xsl:copy-of select="$nodes//namespace::*[. != '']"/>
    </xsl:template>
    <xsl:template name="idref-of">
        <xsl:param name="node"/>
        <xsl:param name="context" select="'unknown'"/>
        <xsl:choose>
            <xsl:when test="not($node)">
                <xsl:call-template name="error">
                    <xsl:with-param name="error" select="concat('missing node for idref-of-node at ', $context)"/>
                </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
                <xsl:choose>
                    <xsl:when test="not($node[../node()])">
                        <xsl:call-template name="error">
                            <xsl:with-param name="error" select="concat('non-node for idref-of-node at ', $context)"/>
                        </xsl:call-template>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:choose>
                            <xsl:when test="not($node/@xmi:id)">
                                <xsl:call-template name="error">
                                    <xsl:with-param name="error" select="concat('missing @xmi:id for idref-of-node at ', $context)"/>
                                </xsl:call-template>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:call-template name="idref-of-id">
                                    <xsl:with-param name="id" select="$node/@xmi:id"/>
                                    <xsl:with-param name="context" select="$context"/>
                                </xsl:call-template>
                            </xsl:otherwise>
                        </xsl:choose>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template name="idref-of-id">
        <xsl:param name="id"/>
        <xsl:param name="context" select="'unknown'"/>
        <xsl:choose>
            <xsl:when test="not($id)">
                <xsl:call-template name="error">
                    <xsl:with-param name="error" select="concat('missing @xmi:id for idref-of-id at ', $context)"/>
                </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
                <xsl:choose>
                    <xsl:when test="not($id[../@*])">
                        <xsl:call-template name="error">
                            <xsl:with-param name="error" select="concat('non-attribute for idref-of-id at ', $context)"/>
                        </xsl:call-template>
                        <xsl:variable name="dot-id" select="string($id)"/>
                        <xsl:call-template name="diagnostic">
                            <xsl:with-param name="text" select="$dot-id"/>
                        </xsl:call-template>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:choose>
                            <xsl:when test="not($id[../../node()])">
                                <xsl:call-template name="error">
                                    <xsl:with-param name="error" select="concat('non-node for idref-of-id at ', $context)"/>
                                </xsl:call-template>
                                <xsl:variable name="dot-id">
                                    <xsl:apply-templates mode="write-identity" select="$id"/>
                                </xsl:variable>
                                <xsl:call-template name="diagnostic">
                                    <xsl:with-param name="text" select="$dot-id"/>
                                </xsl:call-template>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:variable name="node" select="$id/.."/>
                                <xsl:attribute name="xmi:idref">
                                    <xsl:value-of select="$id"/>
                                </xsl:attribute>
                                <xsl:choose>
                                    <xsl:when test="$node/@name">
                                        <xsl:attribute name="debug-name">
                                            <xsl:value-of select="$node/@name"/>
                                        </xsl:attribute>
                                    </xsl:when>
                                    <xsl:otherwise>
                                        <xsl:if test="$node/@debug-name">
                                            <xsl:attribute name="debug-name">
                                                <xsl:value-of select="$node/@debug-name"/>
                                            </xsl:attribute>
                                        </xsl:if>
                                    </xsl:otherwise>
                                </xsl:choose>
                                <xsl:choose>
                                    <xsl:when test="$node/@full-name">
                                        <xsl:attribute name="debug-full-name">
                                            <xsl:value-of select="$node/@full-name"/>
                                        </xsl:attribute>
                                    </xsl:when>
                                    <xsl:otherwise>
                                        <xsl:if test="$node/@debug-full-name">
                                            <xsl:attribute name="debug-full-name">
                                                <xsl:value-of select="$node/@debug-full-name"/>
                                            </xsl:attribute>
                                        </xsl:if>
                                    </xsl:otherwise>
                                </xsl:choose>
                                <xsl:choose>
                                    <xsl:when test="$node/of">
                                        <xsl:choose>
                                            <xsl:when test="$node/of/@name">
                                                <xsl:attribute name="debug-type">
                                                    <xsl:value-of select="$node/of/@name"/>
                                                </xsl:attribute>
                                            </xsl:when>
                                            <xsl:otherwise>
                                                <xsl:if test="$node/of/@debug-name">
                                                    <xsl:attribute name="debug-type">
                                                        <xsl:value-of select="$node/of/@debug-name"/>
                                                    </xsl:attribute>
                                                </xsl:if>
                                            </xsl:otherwise>
                                        </xsl:choose>
                                        <xsl:choose>
                                            <xsl:when test="$node/of/@full-name">
                                                <xsl:attribute name="debug-full-type">
                                                    <xsl:value-of select="$node/of/@full-name"/>
                                                </xsl:attribute>
                                            </xsl:when>
                                            <xsl:otherwise>
                                                <xsl:if test="$node/of/@debug-full-name">
                                                    <xsl:attribute name="debug-full-type">
                                                        <xsl:value-of select="$node/of/@debug-full-name"/>
                                                    </xsl:attribute>
                                                </xsl:if>
                                            </xsl:otherwise>
                                        </xsl:choose>
                                    </xsl:when>
                                    <xsl:otherwise>
                                        <xsl:if test="$node/@debug-type">
                                            <xsl:attribute name="debug-type">
                                                <xsl:value-of select="$node/@debug-type"/>
                                            </xsl:attribute>
                                        </xsl:if>
                                        <xsl:if test="$node/@debug-full-type">
                                            <xsl:attribute name="debug-full-type">
                                                <xsl:value-of select="$node/@debug-full-type"/>
                                            </xsl:attribute>
                                        </xsl:if>
                                    </xsl:otherwise>
                                </xsl:choose>
                            </xsl:otherwise>
                        </xsl:choose>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template name="idref-of-idref">
        <xsl:param name="idref"/>
        <xsl:param name="context" select="'unknown'"/>
        <xsl:choose>
            <xsl:when test="not($idref)">
                <xsl:call-template name="error">
                    <xsl:with-param name="error" select="concat('missing @xmi:idref for idref-of-idref at ', $context)"/>
                </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
                <xsl:choose>
                    <xsl:when test="not($idref[../@*])">
                        <xsl:call-template name="error">
                            <xsl:with-param name="error" select="concat('non-attribute for idref-of-idref at ', $context)"/>
                        </xsl:call-template>
                        <xsl:variable name="dot-id" select="string($idref)"/>
                        <xsl:call-template name="diagnostic">
                            <xsl:with-param name="text" select="$dot-id"/>
                        </xsl:call-template>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:choose>
                            <xsl:when test="not($idref[../../node()])">
                                <xsl:call-template name="error">
                                    <xsl:with-param name="error" select="concat('non-node for idref-of-idref at ', $context)"/>
                                </xsl:call-template>
                                <xsl:variable name="dot-id">
                                    <xsl:apply-templates mode="write-identity" select="$idref"/>
                                </xsl:variable>
                                <xsl:call-template name="diagnostic">
                                    <xsl:with-param name="text" select="$dot-id"/>
                                </xsl:call-template>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:variable name="node-ref" select="$idref/.."/>
                                <xsl:attribute name="xmi:idref">
                                    <xsl:value-of select="$idref"/>
                                </xsl:attribute>
                                <xsl:if test="$node-ref/@debug-name">
                                    <xsl:attribute name="debug-name">
                                        <xsl:value-of select="$node-ref/@debug-name"/>
                                    </xsl:attribute>
                                </xsl:if>
                                <xsl:if test="$node-ref/@debug-full-name">
                                    <xsl:attribute name="debug-full-name">
                                        <xsl:value-of select="$node-ref/@debug-full-name"/>
                                    </xsl:attribute>
                                </xsl:if>
                                <xsl:if test="$node-ref/@debug-type">
                                    <xsl:attribute name="debug-type">
                                        <xsl:value-of select="$node-ref/@debug-type"/>
                                    </xsl:attribute>
                                </xsl:if>
                                <xsl:if test="$node-ref/@debug-full-type">
                                    <xsl:attribute name="debug-full-type">
                                        <xsl:value-of select="$node-ref/@debug-full-type"/>
                                    </xsl:attribute>
                                </xsl:if>
                            </xsl:otherwise>
                        </xsl:choose>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template name="write-identity">
        <xsl:param name="new-line" select="' '"/>
        <xsl:apply-templates mode="write-identity" select=".">
            <xsl:with-param name="new-line" select="$new-line"/>
        </xsl:apply-templates>
    </xsl:template>
    <xsl:template name="write-identity-dot">
        <xsl:param name="dot"/>
        <xsl:param name="new-line" select="' '"/>
        <xsl:apply-templates mode="write-identity" select="$dot">
            <xsl:with-param name="new-line" select="$new-line"/>
        </xsl:apply-templates>
    </xsl:template>
    <xsl:template match="*[@xsi:type = 'Schema'] | *[@xsi:type = 'Transform'] | *[@xsi:type = 'Usage'] | *[@xsi:type = 'MultiModel']" mode="write-identity">
        <xsl:param name="new-line" select="' '"/>
        <xsl:value-of select="&quot;'&quot;"/>
        <xsl:value-of select="@xsi:type"/>
        <xsl:if test="@name">
            <xsl:value-of select="':&quot;'"/>
            <xsl:value-of select="@name"/>
            <xsl:value-of select="'&quot;'"/>
        </xsl:if>
        <xsl:value-of select="&quot;'&quot;"/>
    </xsl:template>
    <xsl:template match="*" mode="write-identity">
        <xsl:param name="new-line" select="' '"/>
        <xsl:value-of select="&quot;'&quot;"/>
        <xsl:value-of select="name()"/>
        <xsl:if test="@xsi:type">
            <xsl:value-of select="':'"/>
            <xsl:value-of select="@xsi:type"/>
        </xsl:if>
        <xsl:if test="@kind">
            <xsl:value-of select="'.'"/>
            <xsl:value-of select="@kind"/>
        </xsl:if>
        <xsl:if test="@name">
            <xsl:value-of select="':&quot;'"/>
            <xsl:value-of select="@name"/>
            <xsl:value-of select="'&quot;'"/>
        </xsl:if>
        <xsl:if test="@xmi:id">
            <xsl:value-of select="'@'"/>
            <xsl:value-of select="@xmi:id"/>
        </xsl:if>
        <xsl:value-of select="&quot;'&quot;"/>
        <xsl:if test="source | target">
            <xsl:value-of select="'(&quot;'"/>
            <xsl:value-of select="source/@name"/>
            <xsl:value-of select="'&quot;@'"/>
            <xsl:value-of select="source/@xmi:idref"/>
            <xsl:value-of select="' to &quot;'"/>
            <xsl:value-of select="target/@name"/>
            <xsl:value-of select="'&quot;@'"/>
            <xsl:value-of select="target/@xmi:idref"/>
            <xsl:value-of select="'&quot;)'"/>
        </xsl:if>
        <xsl:value-of select="$new-line"/>
        <xsl:value-of select="&quot;in &quot;"/>
        <xsl:choose>
            <xsl:when test="@full-name">
                <xsl:value-of select="&quot;'&quot;"/>
                <xsl:value-of select="@full-name"/>
                <xsl:value-of select="&quot;'&quot;"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:apply-templates mode="#current" select="..">
                    <xsl:with-param name="new-line" select="$new-line"/>
                </xsl:apply-templates>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="@*" mode="write-identity">
        <xsl:param name="new-line"/>
        <xsl:value-of select="&quot;@&quot;"/>
        <xsl:value-of select="name()"/>
        <xsl:value-of select="&quot; in &quot;"/>
        <xsl:apply-templates mode="#current" select="..">
            <xsl:with-param name="new-line" select="$new-line"/>
        </xsl:apply-templates>
    </xsl:template>
    <xsl:template match="/" mode="write-identity">
        <xsl:param name="new-line"/>
        <xsl:value-of select="&quot;'&quot;"/>
        <xsl:value-of select="name()"/>
        <xsl:value-of select="&quot;'&quot;"/>
    </xsl:template>
    <xsl:template name="write-node">
        <xsl:param name="prefix" select="''"/>
        <xsl:param name="indent" select="''"/>
        <xsl:param name="depth" select="0"/>
        <xsl:variable name="indentation">
            <xsl:for-each select="0 to $depth">
                <xsl:value-of select="'  '"/>
            </xsl:for-each>
        </xsl:variable>
        <xsl:apply-templates mode="write-node" select=".">
            <xsl:with-param name="indent" select="concat($indentation, $indent, $prefix)"/>
        </xsl:apply-templates>
    </xsl:template>
    <xsl:template name="write-node-dot">
        <xsl:param name="dot"/>
        <xsl:param name="prefix" select="''"/>
        <xsl:param name="indent" select="''"/>
        <xsl:param name="depth" select="0"/>
        <xsl:variable name="indentation">
            <xsl:for-each select="0 to $depth">
                <xsl:value-of select="'  '"/>
            </xsl:for-each>
        </xsl:variable>
        <xsl:apply-templates mode="write-node" select="$dot">
            <xsl:with-param name="indent" select="concat($indentation, $indent, $prefix)"/>
        </xsl:apply-templates>
    </xsl:template>
    <xsl:template match="*" mode="write-node">
        <xsl:param name="indent"/>
        <xsl:variable name="line">
            <xsl:value-of select="name()"/>
            <xsl:apply-templates mode="#current" select="@name">
                <xsl:with-param name="indent" select="$indent"/>
            </xsl:apply-templates>
            <xsl:apply-templates mode="#current" select="@debug-name">
                <xsl:with-param name="indent" select="$indent"/>
            </xsl:apply-templates>
            <xsl:apply-templates mode="#current" select="@xsi:type">
                <xsl:with-param name="indent" select="$indent"/>
            </xsl:apply-templates>
            <xsl:apply-templates mode="#current" select="@xmi:id">
                <xsl:with-param name="indent" select="$indent"/>
            </xsl:apply-templates>
            <xsl:apply-templates mode="#current" select="@*[not(name() = 'name') and not(name() = 'debug-name') and not(name() = 'xsi:type') and not(name() = 'xmi:id')]">
                <xsl:with-param name="indent" select="$indent"/>
            </xsl:apply-templates>
        </xsl:variable>
        <xsl:call-template name="diagnostic">
            <xsl:with-param name="text" select="$line"/>
            <xsl:with-param name="prefix" select="$indent"/>
        </xsl:call-template>
    </xsl:template>
    <xsl:template match="@*" mode="write-node">
        <xsl:param name="indent"/>
        <xsl:value-of select="&quot; &quot;"/>
        <xsl:value-of select="name()"/>
        <xsl:value-of select="&quot;='&quot;"/>
        <xsl:value-of select="."/>
        <xsl:value-of select="&quot;'&quot;"/>
    </xsl:template>
    <xsl:template match="/" mode="write-node">
        <xsl:param name="indent"/>
        <xsl:call-template name="diagnostic">
            <xsl:with-param name="text" select="'/'"/>
            <xsl:with-param name="prefix" select="$indent"/>
        </xsl:call-template>
    </xsl:template>
    <xsl:template name="write-tree">
        <xsl:param name="prefix" select="''"/>
        <xsl:param name="indent" select="''"/>
        <xsl:param name="depth-limit" select="10"/>
        <xsl:param name="depth" select="0"/>
        <xsl:variable name="indentation">
            <xsl:for-each select="0 to $depth">
                <xsl:value-of select="'  '"/>
            </xsl:for-each>
        </xsl:variable>
        <xsl:apply-templates mode="write-tree" select=".">
            <xsl:with-param name="indent" select="concat($indentation, $indent, $prefix)"/>
            <xsl:with-param name="depth-limit" select="$depth-limit"/>
        </xsl:apply-templates>
    </xsl:template>
    <xsl:template name="write-tree-dot">
        <xsl:param name="dot"/>
        <xsl:param name="indent" select="''"/>
        <xsl:param name="prefix" select="''"/>
        <xsl:param name="depth-limit" select="10"/>
        <xsl:param name="depth" select="0"/>
        <xsl:variable name="indentation">
            <xsl:for-each select="0 to $depth">
                <xsl:value-of select="'  '"/>
            </xsl:for-each>
        </xsl:variable>
        <xsl:apply-templates mode="write-tree" select="$dot">
            <xsl:with-param name="indent" select="concat($indentation, $indent, $prefix)"/>
            <xsl:with-param name="depth-limit" select="$depth-limit"/>
        </xsl:apply-templates>
    </xsl:template>
    <xsl:template match="*" mode="write-tree">
        <xsl:param name="indent"/>
        <xsl:param name="depth-limit"/>
        <xsl:variable name="line">
            <xsl:value-of select="name()"/>
            <xsl:apply-templates mode="write-node" select="@name">
                <xsl:with-param name="indent" select="$indent"/>
            </xsl:apply-templates>
            <xsl:apply-templates mode="write-node" select="@debug-name">
                <xsl:with-param name="indent" select="$indent"/>
            </xsl:apply-templates>
            <xsl:apply-templates mode="write-node" select="@xsi:type">
                <xsl:with-param name="indent" select="$indent"/>
            </xsl:apply-templates>
            <xsl:apply-templates mode="write-node" select="@xmi:id">
                <xsl:with-param name="indent" select="$indent"/>
            </xsl:apply-templates>
            <xsl:apply-templates mode="write-node" select="@*[not(name() = 'name') and not(name() = 'debug-name') and not(name() = 'xsi:type') and not(name() = 'xmi:id')]">
                <xsl:with-param name="indent" select="$indent"/>
            </xsl:apply-templates>
        </xsl:variable>
        <xsl:call-template name="diagnostic">
            <xsl:with-param name="text" select="$line"/>
            <xsl:with-param name="prefix" select="$indent"/>
        </xsl:call-template>
        <xsl:choose>
            <xsl:when test="$depth-limit &gt; 0">
                <xsl:apply-templates mode="write-tree" select="node()">
                    <xsl:with-param name="indent" select="concat($indent, '  ')"/>
                    <xsl:with-param name="depth-limit" select="$depth-limit - 1"/>
                </xsl:apply-templates>
            </xsl:when>
            <xsl:otherwise>
                <xsl:if test="node()">
                    <xsl:call-template name="diagnostic">
                        <xsl:with-param name="text" select="'  ...'"/>
                        <xsl:with-param name="prefix" select="$indent"/>
                    </xsl:call-template>
                </xsl:if>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="@*" mode="write-tree">
        <xsl:value-of select="&quot; &quot;"/>
        <xsl:value-of select="name()"/>
        <xsl:value-of select="&quot;='&quot;"/>
        <xsl:value-of select="."/>
        <xsl:value-of select="&quot;'&quot;"/>
    </xsl:template>
    <xsl:template match="/" mode="write-tree">
        <xsl:param name="indent"/>
        <xsl:param name="depth-limit"/>
        <xsl:call-template name="diagnostic">
            <xsl:with-param name="text" select="'/'"/>
            <xsl:with-param name="prefix" select="$indent"/>
        </xsl:call-template>
        <xsl:choose>
            <xsl:when test="$depth-limit &gt; 0">
                <xsl:apply-templates mode="write-tree" select="node()">
                    <xsl:with-param name="indent" select="concat($indent, '  ')"/>
                    <xsl:with-param name="depth-limit" select="$depth-limit - 1"/>
                </xsl:apply-templates>
            </xsl:when>
            <xsl:otherwise>
                <xsl:if test="node()">
                    <xsl:call-template name="diagnostic">
                        <xsl:with-param name="text" select="'  ...'"/>
                        <xsl:with-param name="prefix" select="$indent"/>
                    </xsl:call-template>
                </xsl:if>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
</xsl:stylesheet>
